c This file contains the following subroutines for renormalization of following sector
c     ** Higgs sector using mixed OS-DR scheme** 
c subroutine RenConstEW()     ! full 
c subroutine RenConstEWTop()  ! only (s)fermions contribute 
c subroutine RenConstEWNeu()  ! only chargino+neutralino contribute

c     ** stop/sbottom sector options: DR(3) or OS(1) schemes**
c subroutine RenConstSTSB(ischemet,ischemeb)
c     ** stau/sneutrino sector OS scheme for sneutrino and right-handed stau**
c subroutine RenConstSTauSneu(ischeme) 
c     ** chargino + neutralino sector, options: DR(3) or OS(1) scheme
c subroutine RenConstchaneuDR(ischeme) 

c Author: Dao Thi Nhung
c last update: 10/4/2020
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

      subroutine RenConstEW()
      implicit none 
  
      integer i,j,k,I2,I2G2,I2G3,I2G4,I3G2,I3G3,I3G4,I5G2,
     &         I5G3,I5G4,I6G2,I6G3,I6G4

      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
     
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

      double precision MHpm1l,Mh1l(5),ZH1l(5,5)

      common /H1loop/ MHpm1l,MH1l,ZH1l

      double precision Divergence,v2,vs2,phi,phiIK,phiIl,Spart,Apart

      double precision selfHHIn(6,6),P22,ZHH(6,6),ZHG(6,6),la2,ReAkappa,dZHIN(6,6),
     &                 ReB0i,addrun,myA0
      double complex   ZEN(6,6),ZDN(6,6),ZUN(6,6),dUVSelfHH(6,6),
     &                 dSelfHH(6,6),dUVSelfHHIN(6,6),dUVDSelfHH(6,6),
     &                 dUVDSelfHHIN(6,6),dmb,myB0i

      double complex ChHmHpn(2,2,6),CRhChapChamn(2,2,6),CLhChapChamn(2,2,6),
     &          ChHmWpn(2,6),ChHpWmn(6,2),chZZn(6),chhZn(6,6),chWmWpn(6),
     &          chhhn(6,6,6),crhchichin(5,5,6),clhchichin(5,5,6)
      common/CLhff_decay/ ChHmHpn,CRhChapChamn,CLhChapChamn,ChHmWpn,
     &          ChHpWmn,chZZn,chhZn,chWmWpn,chhhn,crhchichin,clhchichin

#include "HdecayCTs.inc"
#include "HdecayTCLs.inc"

      double complex cI,IC,lam,lamC,kap,kapC,Expeta,ExpetaS,SelfNN(4),DSelfN(4),
     &               SelfC(4),DSelfC(4),SelfCH,SelfHH,SelfHZ

      parameter (cI=(0,1D0),IC=(0,1D0))

      Pi=2d0*Asin(1d0); Pi2 =Pi**2; sqrt2=Sqrt(2d0)
      p22=0D0
      MW2=MW**2;         MZ2=MZ**2;           v2=v**2
      MHp2=MHpm**2
      fac=1D0/16D0/Pi2
      CB=Cos(beta);      CB2=CB**2
      SB=Sin(beta);      SB2=SB**2
      TB=tanb;           C2B=CB2-SB2
      CW=MW/MZ;          CW2=CW**2
      SW=sqrt(1-CW2);    SW2=1-CW2
      C2W=CW2-SW2;       S2W=2*SW*CW
      ZP(1,1)=-CB;       ZP(1,2)=SB
      ZP(2,1)=SB;        ZP(2,2)=CB

      lam=abslambda*(Cos(phil) + cI*Sin(phil))
      lamC=abslambda*(Cos(phil) - cI*Sin(phil))
      kap=abskappa*(Cos(phik) + cI*Sin(phik))
      kapC=abskappa*(Cos(phik) - cI*Sin(phik))
      Expeta=(Cos(phiu) + cI*Sin(phiu))
      ExpetaS=(Cos(phis) + cI*Sin(phis)) 
      la2=abslambda**2
      vs2=vs**2
      ReAkappa= absAkappa*Cos(phiAk)
      phi=phik - phil + 2* phis - phiu
      phiIK=phik + 3*phis
      phiIL=phil + phis + phiu
      ZHH(1:6,1:6)=ZH(1:6,1:6)
      ZEN(1:6,1:6)=ZE(1:6,1:6)
      ZUN(1:6,1:6)=ZU(1:6,1:6)
      ZDN(1:6,1:6)=ZD(1:6,1:6)
      call neutralinomasses(absM1,phiM1,absM2,phiM2,g1,g2,v,vs,
     &          abslambda,phil,abskappa,phik,phiu,phis,beta,NN,MChi,
     &          .false.)

      call couplings      
      call CouplingsXX()
      ChHmHpn(1:2,1:2,1:6)=ChHmHp(1:2,1:2,1:6)
      CRhChapChamn(1:2,1:2,1:6)=CRhChapCham(1:2,1:2,1:6)
      CLhChapChamn(1:2,1:2,1:6)=CLhChapCham(1:2,1:2,1:6)
      ChHmWpn(1:2,1:6)=ChHmWp(1:2,1:6)
      ChHpWmn(1:6,1:2)=ChHpWm(1:6,1:2)
      ChZZn(1:6)=ChZZ(1:6)
      ChhZn(1:6,1:6)=ChhZ(1:6,1:6)
      ChWmWpn(1:6)= ChWmWp(1:6)
      Chhhn(1:6,1:6,1:6)=chhh(1:6,1:6,1:6)
      Crhchichin(1:5,1:5,1:6)=crhchichi(1:5,1:5,1:6)
      Clhchichin(1:5,1:5,1:6)=clhchichi(1:5,1:5,1:6)


      dMHpsq1= SelfCH(MHp2,2,2,1)
       dMWsq1=0D0
       dMWsq1=dMWsq1+((-2*CWWA**2-2*CWWZ**2+3*g2**2)*myA0(MW2)+3*CWWZ*
     &  *2*myA0(MZ2)-5*CWWA**2*MW2*DBLE(myB0i(bb0k,MW2,0D0,MW2))-3*CWWZ**2*
     &  MW2*DBLE(myB0i(bb0k,MW2,MW2,MZ2))-2*CWWZ**2*MZ2*
     &  DBLE(myB0i(bb0k,MW2,MW2,MZ2))-8*CWWA**2*DBLE(myB0i(bb00k,MW2,0D0,MW2)
     &  )-8*CWWZ**2*DBLE(myB0i(bb00k,MW2,MW2,MZ2))-2*CWWA**2*MW2*
     &  DBLE(myB0i(bb1k,MW2,0D0,MW2))+2*CWWZ**2*MW2*
     &  DBLE(myB0i(bb1k,MW2,MW2,MZ2)))

    	do I2G3 = 1,2
       dMWsq1=dMWsq1+(myA0(MassHpm2(I2G3))*CHmHpWW(I2G3,I2G3)+
     &  CHmWpA(I2G3)**2*DBLE(myB0i(bb0k,MW2,0D0,MassHpm2(I2G3)))+
     &  CHmWpZ(I2G3)**2*DBLE(myB0i(bb0k,MW2,MZ2,MassHpm2(I2G3))))
    	enddo
    	do I3G3 = 1,3
       dMWsq1=dMWsq1+(g2**2*(-6*myA0(MFd2(I3G3))-2*myA0(MFe2(I3G3))+
     &  myA0(MSv2(I3G3))+2*MW2*DBLE(myB0i(bb0k,MW2,0D0,MFe2(I3G3)))+6*MW2*
     &  DBLE(myB0i(bb0k,MW2,MFd2(I3G3),MFu2(I3G3)))+12*
     &  DBLE(myB0i(bb00k,MW2,MFd2(I3G3),MFu2(I3G3)))+4*
     &  DBLE(myB0i(bb00k,MW2,MFe2(I3G3),0D0))+6*MW2*
     &  DBLE(myB0i(bb1k,MW2,MFd2(I3G3),MFu2(I3G3)))+2*MW2*
     &  DBLE(myB0i(bb1k,MW2,MFe2(I3G3),0D0))-6*DBLE(myB0i(bb0k,MW2,MFd2(I3G3)
     &  ,MFu2(I3G3)))*MFu2(I3G3)))/2.
    	enddo

    	do I2G3 = 1,2
    	do I5G3 = 1,5
       dMWsq1=dMWsq1+2*(-(myA0(MCha2(I2G3))*(CLF12F11W(I2G3,I5G3)*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+CRF12F11W(I2G3,I5G3)*
     &  DCONJG(CRF12F11W(I2G3,I5G3))))+CLF12F11W(I2G3,I5G3)*((2*
     &  DBLE(myB0i(bb00k,MW2,MCha2(I2G3),MNeu2(I5G3)))+MW2*
     &  DBLE(myB0i(bb1k,MW2,MCha2(I2G3),MNeu2(I5G3))))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+DBLE(myB0i(bb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*(DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)+DCONJG(CLF12F11W(I2G3,I5G3))*(MW2-MNeu2(I5G3))))+
     &  CRF12F11W(I2G3,I5G3)*((2*DBLE(myB0i(bb00k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))+MW2*DBLE(myB0i(bb1k,MW2,MCha2(I2G3),MNeu2(I5G3))))
     &  *DCONJG(CRF12F11W(I2G3,I5G3))+DBLE(myB0i(bb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*(DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)+DCONJG(CRF12F11W(I2G3,I5G3))*(MW2-MNeu2(I5G3)))))
    	enddo
    	enddo
    	do I6G3 = 1,6
       dMWsq1=dMWsq1+(-(IC*myA0(Masshh2(I6G3))*ChhWmWp(I6G3,I6G3))/2.+
     &  3*myA0(MSd2(I6G3))*CSdSdWW(I6G3,I6G3)+myA0(MSe2(I6G3))*
     &  CSeSeWW(I6G3,I6G3)+3*myA0(MSu2(I6G3))*CSuSuWW(I6G3,I6G3)-
     &  ChWmWp(I6G3)**2*DBLE(myB0i(bb0k,MW2,MW2,Masshh2(I6G3))))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       dMWsq1=dMWsq1+4*ChHmWp(I2G3,I6G3)*ChHpWm(I6G3,I2G3)*
     &  DBLE(myB0i(bb00k,MW2,Masshh2(I6G3),MassHpm2(I2G3)))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I6G3 = 1,6
       dMWsq1=dMWsq1-4*CsesvW(I6G3,I3G3)*
     &  DBLE(myB0i(bb00k,MW2,MSe2(I6G3),MSv2(I3G3)))*
     &  DCONJG(CsesvW(I6G3,I3G3))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dMWsq1=dMWsq1-12*CsdsuW(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MW2,MSd2(I6G4),MSu2(I6G3)))*
     &  DCONJG(CsdsuW(I6G4,I6G3))
    	enddo
    	enddo
       dMWsq1=dMWsq1/Pi**2/16D0


       dMZsq1=0D0
       dMZsq1=dMZsq1+CWWZ**2*(4*myA0(MW2)-(2*MW2+5*MZ2)*
     &  DBLE(myB0i(bb0k,MZ2,MW2,MW2))-2*(4*DBLE(myB0i(bb00k,MZ2,MW2,MW2))+
     &  MZ2*DBLE(myB0i(bb1k,MZ2,MW2,MW2))))
c#define printdetail
#ifdef printdetail
        print*, "dMZsq1",dMZsq1*fac,fac
        dMZsq1=0D0
#endif
    	do I2G3 = 1,2
       dMZsq1=dMZsq1+(myA0(MassHpm2(I2G3))*CHpHmZZ(I2G3,I2G3)+2*
     &  CHmWpZ(I2G3)**2*DBLE(myB0i(bb0k,MZ2,MW2,MassHpm2(I2G3)))-4*
     &  CHpHmZ**2*DBLE(myB0i(bb00k,MZ2,MassHpm2(I2G3),MassHpm2(I2G3))))
    	enddo
#ifdef printdetail
        print*, "dMZsq1 I2G3",dMZsq1*fac
        dMZsq1=0D0
#endif
    	do I2G3 = 1,2
    	do I2G4 = 1,2
       dMZsq1=dMZsq1+2*(-(myA0(MCha2(I2G4))*(CF12ZL(I2G3,I2G4)*
     &  CF12ZL(I2G4,I2G3)+CF12ZR(I2G3,I2G4)*CF12ZR(I2G4,I2G3)))+
     &  CF12ZL(I2G3,I2G4)*(CF12ZR(I2G4,I2G3)*
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha(I2G3)*
     &  MCha(I2G4)+CF12ZL(I2G4,I2G3)*(2*DBLE(myB0i(bb00k,MZ2,MCha2(I2G3)
     &  ,MCha2(I2G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MCha2(I2G3),MCha2(I2G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha2(I2G3)))+
     &  CF12ZR(I2G3,I2G4)*(CF12ZL(I2G4,I2G3)*
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha(I2G3)*
     &  MCha(I2G4)+CF12ZR(I2G4,I2G3)*(2*DBLE(myB0i(bb00k,MZ2,MCha2(I2G3)
     &  ,MCha2(I2G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MCha2(I2G3),MCha2(I2G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha2(I2G3))))
    	enddo
    	enddo
#ifdef printdetail
        print*, "dMZsq1 I2G3,I2G4",dMZsq1*fac
        dMZsq1=0D0
#endif
    	do I3G3 = 1,3
       dMZsq1=dMZsq1+(-12*(CddZL**2+CddZR**2)*myA0(MFd2(I3G3))-4*
     &  (ctautauZL**2+ctautauZR**2)*myA0(MFe2(I3G3))-12*(CuuZL**2+CuuZR*
     &  *2)*myA0(MFu2(I3G3))+2*CSvSvZZ*myA0(MSv2(I3G3))+2*(CW2*g2**2+g1*
     &  (2*CW*g2*SW+g1*SW2))*DBLE(myB0i(bb00k,MZ2,0D0,0D0))+24*(CddZL**2+
     &  CddZR**2)*DBLE(myB0i(bb00k,MZ2,MFd2(I3G3),MFd2(I3G3)))+8*
     &  (ctautauZL**2+ctautauZR**2)*DBLE(myB0i(bb00k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))+24*(CuuZL**2+CuuZR**2)*
     &  DBLE(myB0i(bb00k,MZ2,MFu2(I3G3),MFu2(I3G3)))-8*CsvsvZ**2*
     &  DBLE(myB0i(bb00k,MZ2,MSv2(I3G3),MSv2(I3G3)))-MZ2*(CW2*g2**2+g1*
     &  (2*CW*g2*SW+g1*SW2))*DBLE(myB0i(bb1k,MZ2,0D0,0D0))-12*(CddZL**2+
     &  CddZR**2)*MZ2*DBLE(myB0i(bb1k,MZ2,MFd2(I3G3),MFd2(I3G3)))-4*
     &  (ctautauZL**2+ctautauZR**2)*MZ2*DBLE(myB0i(bb1k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))-12*(CuuZL**2+CuuZR**2)*MZ2*
     &  DBLE(myB0i(bb1k,MZ2,MFu2(I3G3),MFu2(I3G3)))-12*(CddZL-CddZR)**2*
     &  DBLE(myB0i(bb0k,MZ2,MFd2(I3G3),MFd2(I3G3)))*MFd2(I3G3)-4*
     &  (ctautauZL-ctautauZR)**2*DBLE(myB0i(bb0k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))*MFe2(I3G3)-12*(CuuZL-CuuZR)**2*
     &  DBLE(myB0i(bb0k,MZ2,MFu2(I3G3),MFu2(I3G3)))*MFu2(I3G3))/2.
    	enddo

#ifdef printdetail
        print*, "dMZsq1 I3G3",dMZsq1*fac
        dMZsq1=0D0
#endif
    	do I5G3 = 1,5
    	do I5G4 = 1,5
       dMZsq1=dMZsq1+(-(myA0(MNeu2(I5G4))*(CF11ZL(I5G3,I5G4)*
     &  CF11ZL(I5G4,I5G3)+CF11ZR(I5G3,I5G4)*CF11ZR(I5G4,I5G3)))+
     &  CF11ZL(I5G3,I5G4)*(CF11ZR(I5G4,I5G3)*
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu(I5G3)*
     &  MNeu(I5G4)+CF11ZL(I5G4,I5G3)*(2*DBLE(myB0i(bb00k,MZ2,MNeu2(I5G3)
     &  ,MNeu2(I5G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu2(I5G3)))+
     &  CF11ZR(I5G3,I5G4)*(CF11ZL(I5G4,I5G3)*
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu(I5G3)*
     &  MNeu(I5G4)+CF11ZR(I5G4,I5G3)*(2*DBLE(myB0i(bb00k,MZ2,MNeu2(I5G3)
     &  ,MNeu2(I5G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu2(I5G3))))
    	enddo
    	enddo
#ifdef printdetail
        print*, "dMZsq1 I5G3,I5G4",dMZsq1*fac
        dMZsq1=0D0
#endif
    	do I6G3 = 1,6
       dMZsq1=dMZsq1+(-(IC*myA0(Masshh2(I6G3))*ChhZZ(I6G3,I6G3))/2.+3*
     &  myA0(MSd2(I6G3))*CSdSdZZ(I6G3,I6G3)+myA0(MSe2(I6G3))*
     &  CSeSeZZ(I6G3,I6G3)+3*myA0(MSu2(I6G3))*CSuSuZZ(I6G3,I6G3)-
     &  ChZZ(I6G3)**2*DBLE(myB0i(bb0k,MZ2,MZ2,Masshh2(I6G3))))
    	enddo

#ifdef printdetail
        print*, "dMZsq1 I6G3",dMZsq1*fac
        dMZsq1=0D0
#endif
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dMZsq1=dMZsq1-2*(ChhZ(I6G3,I6G4)**2*
     &  DBLE(myB0i(bb00k,MZ2,Masshh2(I6G3),Masshh2(I6G4)))+6*
     &  CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MZ2,MSd2(I6G3),MSd2(I6G4)))+2*
     &  CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MZ2,MSe2(I6G3),MSe2(I6G4)))+6*
     &  CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MZ2,MSu2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo

#ifdef printdetail
        print*, "dMZsq1 I6G3",dMZsq1*fac

        stop

#endif
       dMZsq1=dMZsq1/Pi**2/16D0


       do i=1,6

       dTadMH1(i)=-(IC*(myA0(MW2)*(ChU3U3(i)+ChU4U4(i)+4*ChWmWp(i))+
     &  myA0(MZ2)*(ChU2U2(i)+2*ChZZ(i))))
    	do I2G2 = 1,2
       dTadMH1(i)=dTadMH1(i)+IC*(myA0(MassHpm2(I2G2))*
     &  ChHmHp(I2G2,I2G2,i)-2*myA0(MCha2(I2G2))*
     &  (CLhChapCham(I2G2,I2G2,i)+CRhChapCham(I2G2,I2G2,i))*MCha(I2G2))
    	enddo
    	do I3G2 = 1,3
       dTadMH1(i)=dTadMH1(i)+IC*(myA0(MSv2(I3G2))*ChSvSvconj(i)-2*(3*
     &  myA0(MFd2(I3G2))*(CLhFdpFdm(I3G2,I3G2,i)+CRhFdpFdm(I3G2,I3G2,i))
     &  *MassFd(I3G2)+myA0(MFe2(I3G2))*(CLhFepFem(I3G2,I3G2,i)+
     &  CRhFepFem(I3G2,I3G2,i))*MassFe(I3G2)+3*myA0(MFu2(I3G2))*
     &  (CLhFumFup(I3G2,I3G2,i)+CRhFumFup(I3G2,I3G2,i))*MassFu(I3G2)))
    	enddo
    	do I5G2 = 1,5
       dTadMH1(i)=dTadMH1(i)-(IC*myA0(MNeu2(I5G2))*
     &  (CLhChiChi(I5G2,I5G2,i)+CRhChiChi(I5G2,I5G2,i))*MNeu(I5G2))
    	enddo
    	do I6G2 = 1,6
       dTadMH1(i)=(IC*(myA0(Masshh2(I6G2))*Chhh(i,I6G2,I6G2)+6*
     &  myA0(MSd2(I6G2))*ChSdmSdp(I6G2,I6G2,i)+2*myA0(MSe2(I6G2))*
     &  ChSemSep(I6G2,I6G2,i)+6*myA0(MSu2(I6G2))*ChSupSum(I6G2,I6G2,i)))
     &  /2.+dTadMH1(i)
    	enddo

       dTadMH1(i)=dTadMH1(i)*fac
       enddo

       do i=1,6
       ZHG(i,1)=ZH(i,4); ZHG(i,2)=ZH(i,5); ZHG(i,3)=ZH(i,6)
       ZHG(i,6)=ZH(i,3)
       ZHG(i,4)= -CB* ZH(i,1)+SB*ZH(i,2)
       ZHG(i,5)=  SB* ZH(i,1)+CB*ZH(i,2)
       enddo
       do i=1,6
        dTadih1(i)=0
         do j=1,6
          dTadih1(i)=dTadih1(i) + ZHG(j,i)* dTadMH1(j)
         enddo
       enddo



       dZAA1=CWWA**2*(5*DBLE(myB0i(bb0k,0D0,MW2,MW2))+2*
     &  (DBLE(myB0i(bb1k,0D0,MW2,MW2))+MW2*DBLE(myB0i(dbb0k,0D0,MW2,MW2))+
     &  4*DBLE(myB0i(dbb00k,0D0,MW2,MW2))))
    	do I2G3 = 1,2
       dZAA1=dZAA1+(4*e**2*DBLE(myB0i(bb1k,0D0,MCha2(I2G3),MCha2(I2G3)))-
     &  2*CHmWpA(I2G3)**2*DBLE(myB0i(dbb0k,0D0,MW2,MassHpm2(I2G3)))+4*e**
     &  2*(DBLE(myB0i(dbb00k,0D0,MassHpm2(I2G3),MassHpm2(I2G3)))-2*
     &  DBLE(myB0i(dbb00k,0D0,MCha2(I2G3),MCha2(I2G3)))))
    	enddo
    	do I3G3 = 1,3
       dZAA1=dZAA1+(4*e**2*(DBLE(myB0i(bb1k,0D0,MFd2(I3G3),MFd2(I3G3)))+
     &  3*DBLE(myB0i(bb1k,0D0,MFe2(I3G3),MFe2(I3G3)))+4*
     &  DBLE(myB0i(bb1k,0D0,MFu2(I3G3),MFu2(I3G3)))-2*
     &  DBLE(myB0i(dbb00k,0D0,MFd2(I3G3),MFd2(I3G3)))-6*
     &  DBLE(myB0i(dbb00k,0D0,MFe2(I3G3),MFe2(I3G3)))-8*
     &  DBLE(myB0i(dbb00k,0D0,MFu2(I3G3),MFu2(I3G3)))))/3.
    	enddo
    	do I6G3 = 1,6
       dZAA1=dZAA1+(4*e**2*(DBLE(myB0i(dbb00k,0D0,MSd2(I6G3),MSd2(I6G3)))
     &  +3*DBLE(myB0i(dbb00k,0D0,MSe2(I6G3),MSe2(I6G3)))+4*
     &  DBLE(myB0i(dbb00k,0D0,MSu2(I6G3),MSu2(I6G3)))))/3.
    	enddo

       dZAA1=dZAA1*fac

       dZZA1=(-2*((2*CWWA*CWWZ-3*g2**2*S2W)*DBLE(myA0(MW2))+2*
     &  CWWA*CWWZ*(MW2*DBLE(myB0i(bb0k,0D0,MW2,MW2))+4*
     &  DBLE(myB0i(bb00k,0D0,MW2,MW2)))))/MZ2
    	do I2G3 = 1,2
       dZZA1=dZZA1+(-8*e*(CF12ZL(I2G3,I2G3)+CF12ZR(I2G3,I2G3))*
     &  DBLE(myA0(MCha2(I2G3)))-8*CHmWpA(I2G3)*CHmWpZ(I2G3)*
     &  DBLE(myB0i(bb0k,0D0,MW2,MassHpm2(I2G3)))-16*CHpHmZ*e*
     &  DBLE(myB0i(bb00k,0D0,MassHpm2(I2G3),MassHpm2(I2G3)))+16*e*
     &  (CF12ZL(I2G3,I2G3)+CF12ZR(I2G3,I2G3))*
     &  DBLE(myB0i(bb00k,0D0,MCha2(I2G3),MCha2(I2G3)))+(2*C2W*g1*g2+(-g1*
     &  *2+g2**2)*S2W)*DBLE(myA0(MassHpm2(I2G3)))*(ZP(I2G3,1)**2+
     &  ZP(I2G3,2)**2))/(2.*MZ2)
    	enddo
    	do I3G3 = 1,3
       dZZA1=dZZA1+(-4*e*((CddZL+CddZR)*DBLE(myA0(MFd2(I3G3)))+
     &  (ctautauZL+ctautauZR)*DBLE(myA0(MFe2(I3G3)))-2*((CuuZL+CuuZR)*
     &  DBLE(myA0(MFu2(I3G3)))+(CddZL+CddZR)*
     &  DBLE(myB0i(bb00k,0D0,MFd2(I3G3),MFd2(I3G3)))+ctautauZL*
     &  DBLE(myB0i(bb00k,0D0,MFe2(I3G3),MFe2(I3G3)))+ctautauZR*
     &  DBLE(myB0i(bb00k,0D0,MFe2(I3G3),MFe2(I3G3)))-2*CuuZL*
     &  DBLE(myB0i(bb00k,0D0,MFu2(I3G3),MFu2(I3G3)))-2*CuuZR*
     &  DBLE(myB0i(bb00k,0D0,MFu2(I3G3),MFu2(I3G3))))))/MZ2
    	enddo
    	do I6G3 = 1,6
       dZZA1=dZZA1+(-48*e*CsdmsdpZ(I6G3,I6G3)*
     &  DBLE(myB0i(bb00k,0D0,MSd2(I6G3),MSd2(I6G3)))-48*e*
     &  CsemsepZ(I6G3,I6G3)*DBLE(myB0i(bb00k,0D0,MSe2(I6G3),MSe2(I6G3)))+
     &  96*e*CsupsumZ(I6G3,I6G3)*DBLE(myB0i(bb00k,0D0,MSu2(I6G3)
     &  ,MSu2(I6G3)))-DBLE(myA0(MSd2(I6G3)))*((6*C2W*g1*g2+(g1**2-9*g2**
     &  2)*S2W)*DCONJG(ZDN(I6G3,1))*ZDN(I6G3,1)+4*g1**2*S2W*
     &  DCONJG(ZDN(I6G3,2))*ZDN(I6G3,2)+6*C2W*g1*g2*DCONJG(ZDN(I6G3,3))
     &  *ZDN(I6G3,3)+g1**2*S2W*DCONJG(ZDN(I6G3,3))*ZDN(I6G3,3)-9*g2**2*
     &  S2W*DCONJG(ZDN(I6G3,3))*ZDN(I6G3,3)+4*g1**2*S2W*
     &  DCONJG(ZDN(I6G3,4))*ZDN(I6G3,4)+6*C2W*g1*g2*DCONJG(ZDN(I6G3,5))
     &  *ZDN(I6G3,5)+g1**2*S2W*DCONJG(ZDN(I6G3,5))*ZDN(I6G3,5)-9*g2**2*
     &  S2W*DCONJG(ZDN(I6G3,5))*ZDN(I6G3,5)+4*g1**2*S2W*
     &  DCONJG(ZDN(I6G3,6))*ZDN(I6G3,6))+3*DBLE(myA0(MSe2(I6G3)))*((2*
     &  C2W*g1*g2+(-g1**2+g2**2)*S2W)*DCONJG(ZEN(I6G3,1))*ZEN(I6G3,1)-
     &  4*g1**2*S2W*DCONJG(ZEN(I6G3,2))*ZEN(I6G3,2)+2*C2W*g1*g2*
     &  DCONJG(ZEN(I6G3,3))*ZEN(I6G3,3)-g1**2*S2W*DCONJG(ZEN(I6G3,3))*
     &  ZEN(I6G3,3)+g2**2*S2W*DCONJG(ZEN(I6G3,3))*ZEN(I6G3,3)-4*g1**2*
     &  S2W*DCONJG(ZEN(I6G3,4))*ZEN(I6G3,4)+2*C2W*g1*g2*
     &  DCONJG(ZEN(I6G3,5))*ZEN(I6G3,5)-g1**2*S2W*DCONJG(ZEN(I6G3,5))*
     &  ZEN(I6G3,5)+g2**2*S2W*DCONJG(ZEN(I6G3,5))*ZEN(I6G3,5)-4*g1**2*
     &  S2W*DCONJG(ZEN(I6G3,6))*ZEN(I6G3,6))+DBLE(myA0(MSu2(I6G3)))*((6*
     &  C2W*g1*g2-g1**2*S2W+9*g2**2*S2W)*DCONJG(ZUN(I6G3,1))*
     &  ZUN(I6G3,1)-16*g1**2*S2W*DCONJG(ZUN(I6G3,2))*ZUN(I6G3,2)+6*C2W*
     &  g1*g2*DCONJG(ZUN(I6G3,3))*ZUN(I6G3,3)-g1**2*S2W*
     &  DCONJG(ZUN(I6G3,3))*ZUN(I6G3,3)+9*g2**2*S2W*DCONJG(ZUN(I6G3,3))
     &  *ZUN(I6G3,3)-16*g1**2*S2W*DCONJG(ZUN(I6G3,4))*ZUN(I6G3,4)+6*
     &  C2W*g1*g2*DCONJG(ZUN(I6G3,5))*ZUN(I6G3,5)-g1**2*S2W*
     &  DCONJG(ZUN(I6G3,5))*ZUN(I6G3,5)+9*g2**2*S2W*DCONJG(ZUN(I6G3,5))
     &  *ZUN(I6G3,5)-16*g1**2*S2W*DCONJG(ZUN(I6G3,6))*ZUN(I6G3,6)))/(6.*MZ2)
    	enddo
       dZZA1=dZZA1*fac



      addrun=  -(e**2*(myA0(mb**2) + 4*myA0(mc**2) + myA0(md**2) + 
     -       3*myA0(me**2) + 3*myA0(mmu**2) + myA0(ms**2) + 
     -       3*myA0(mtau**2) + 4*myA0(mu**2) - 
     -       2*ReB0i(bb00k,Mz**2,mb**2,mb**2) - 
     -       8*ReB0i(bb00k,Mz**2,mc**2,mc**2) - 
     -       2*ReB0i(bb00k,Mz**2,md**2,md**2) - 
     -       6*ReB0i(bb00k,Mz**2,me**2,me**2) - 
     -       6*ReB0i(bb00k,Mz**2,mmu**2,mmu**2) - 
     -       2*ReB0i(bb00k,Mz**2,ms**2,ms**2) - 
     -       6*ReB0i(bb00k,Mz**2,mtau**2,mtau**2) - 
     -       8*ReB0i(bb00k,Mz**2,mu**2,mu**2) - 
     -       Mz**2*ReB0i(bb1k,0d0,mb**2,mb**2) - 
     -       4*Mz**2*ReB0i(bb1k,0d0,mc**2,mc**2) - 
     -       Mz**2*ReB0i(bb1k,0d0,md**2,md**2) - 
     -       3*Mz**2*ReB0i(bb1k,0d0,me**2,me**2) - 
     -       3*Mz**2*ReB0i(bb1k,0d0,mmu**2,mmu**2) - 
     -       Mz**2*ReB0i(bb1k,0d0,ms**2,ms**2) - 
     -       3*Mz**2*ReB0i(bb1k,0d0,mtau**2,mtau**2) - 
     -       4*Mz**2*ReB0i(bb1k,0d0,mu**2,mu**2) + 
     -       Mz**2*ReB0i(bb1k,Mz**2,mb**2,mb**2) + 
     -       4*Mz**2*ReB0i(bb1k,Mz**2,mc**2,mc**2) + 
     -       Mz**2*ReB0i(bb1k,Mz**2,md**2,md**2) + 
     -       3*Mz**2*ReB0i(bb1k,Mz**2,me**2,me**2) + 
     -       3*Mz**2*ReB0i(bb1k,Mz**2,mmu**2,mmu**2) + 
     -       Mz**2*ReB0i(bb1k,Mz**2,ms**2,ms**2) + 
     -       3*Mz**2*ReB0i(bb1k,Mz**2,mtau**2,mtau**2) + 
     -       4*Mz**2*ReB0i(bb1k,Mz**2,mu**2,mu**2) + 
     -       2*Mz**2*ReB0i(dbb00k,0d0,mb**2,mb**2) + 
     -       8*Mz**2*ReB0i(dbb00k,0d0,mc**2,mc**2) + 
     -       2*Mz**2*ReB0i(dbb00k,0d0,md**2,md**2) + 
     -       6*Mz**2*ReB0i(dbb00k,0d0,me**2,me**2) + 
     -       6*Mz**2*ReB0i(dbb00k,0d0,mmu**2,mmu**2) + 
     -       2*Mz**2*ReB0i(dbb00k,0d0,ms**2,ms**2) + 
     -       6*Mz**2*ReB0i(dbb00k,0d0,mtau**2,mtau**2) + 
     -       8*Mz**2*ReB0i(dbb00k,0d0,mu**2,mu**2)))/
     -      (24.*Mz**2*pi**2)

	dZe1 = 1/(2.D0*CW)*(dZZA1*SW - CW*dZAA1)+ addrun

c%%%%%%%

       dSW1= CW2/SW/2.D0 * (dMZsq1/MZ2 - dMWsq1/MW2)

       dv1= (-dZe1 + (2*dMWsq1*MW2 - dMWsq1*MZ2)/(2*MW2**2 - 2*MW2*MZ2) 
     &      - (dMZsq1*MW2)/(2*MW2*MZ2 - 2*MZ2**2))*v


       dZZZ1=0D0
       dZZZ1=dZZZ1+CWWZ**2*(5*DBLE(myB0i(bb0k,MZ2,MW2,MW2))+2*
     &  DBLE(myB0i(bb1k,MZ2,MW2,MW2))+2*MW2*DBLE(myB0i(dbb0k,MZ2,MW2,MW2))+
     &  5*MZ2*DBLE(myB0i(dbb0k,MZ2,MW2,MW2))+8*
     &  DBLE(myB0i(dbb00k,MZ2,MW2,MW2))+2*MZ2*DBLE(myB0i(dbb1k,MZ2,MW2,MW2)
     &  ))

    	do I2G3 = 1,2
       dZZZ1=dZZZ1+(-2*DCONJG(CHmWpZ(I2G3))**2*
     &  DBLE(myB0i(dbb0k,MZ2,MW2,MassHpm2(I2G3)))+4*CHpHmZ**2*
     &  DBLE(myB0i(dbb00k,MZ2,MassHpm2(I2G3),MassHpm2(I2G3))))
    	enddo

    	do I2G3 = 1,2
    	do I2G4 = 1,2
       dZZZ1=dZZZ1+2*(CF12ZL(I2G3,I2G4)*(-(CF12ZR(I2G4,I2G3)*
     &  DBLE(myB0i(dbb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha(I2G3)*
     &  MCha(I2G4))+CF12ZL(I2G4,I2G3)*(DBLE(myB0i(bb1k,MZ2,MCha2(I2G3)
     &  ,MCha2(I2G4)))-2*DBLE(myB0i(dbb00k,MZ2,MCha2(I2G3),MCha2(I2G4)))+
     &  MZ2*DBLE(myB0i(dbb1k,MZ2,MCha2(I2G3),MCha2(I2G4)))+
     &  DBLE(myB0i(dbb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha2(I2G3)))+
     &  CF12ZR(I2G3,I2G4)*(-(CF12ZL(I2G4,I2G3)*
     &  DBLE(myB0i(dbb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha(I2G3)*
     &  MCha(I2G4))+CF12ZR(I2G4,I2G3)*(DBLE(myB0i(bb1k,MZ2,MCha2(I2G3)
     &  ,MCha2(I2G4)))-2*DBLE(myB0i(dbb00k,MZ2,MCha2(I2G3),MCha2(I2G4)))+
     &  MZ2*DBLE(myB0i(dbb1k,MZ2,MCha2(I2G3),MCha2(I2G4)))+
     &  DBLE(myB0i(dbb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha2(I2G3))))
    	enddo
    	enddo

    	do I3G3 = 1,3
       dZZZ1=dZZZ1+((CW2*g2**2+g1*(2*CW*g2*SW+g1*SW2))*
     &  DBLE(myB0i(bb1k,MZ2,0D0,0D0))+12*(CddZL**2+CddZR**2)*
     &  DBLE(myB0i(bb1k,MZ2,MFd2(I3G3),MFd2(I3G3)))+4*(ctautauZL**2+
     &  ctautauZR**2)*DBLE(myB0i(bb1k,MZ2,MFe2(I3G3),MFe2(I3G3)))+12*
     &  (CuuZL**2+CuuZR**2)*DBLE(myB0i(bb1k,MZ2,MFu2(I3G3),MFu2(I3G3)))-
     &  2*(CW2*g2**2+g1*(2*CW*g2*SW+g1*SW2))*DBLE(myB0i(dbb00k,MZ2,0D0,0D0))-
     &  24*(CddZL**2+CddZR**2)*DBLE(myB0i(dbb00k,MZ2,MFd2(I3G3)
     &  ,MFd2(I3G3)))-8*(ctautauZL**2+ctautauZR**2)*
     &  DBLE(myB0i(dbb00k,MZ2,MFe2(I3G3),MFe2(I3G3)))-24*(CuuZL**2+CuuZR*
     &  *2)*DBLE(myB0i(dbb00k,MZ2,MFu2(I3G3),MFu2(I3G3)))+8*CsvsvZ**2*
     &  DBLE(myB0i(dbb00k,MZ2,MSv2(I3G3),MSv2(I3G3)))+MZ2*(CW2*g2**2+g1*
     &  (2*CW*g2*SW+g1*SW2))*DBLE(myB0i(dbb1k,MZ2,0D0,0D0))+12*(CddZL**2+
     &  CddZR**2)*MZ2*DBLE(myB0i(dbb1k,MZ2,MFd2(I3G3),MFd2(I3G3)))+4*
     &  (ctautauZL**2+ctautauZR**2)*MZ2*DBLE(myB0i(dbb1k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))+12*(CuuZL**2+CuuZR**2)*MZ2*
     &  DBLE(myB0i(dbb1k,MZ2,MFu2(I3G3),MFu2(I3G3)))+12*(CddZL-CddZR)**2*
     &  DBLE(myB0i(dbb0k,MZ2,MFd2(I3G3),MFd2(I3G3)))*MFd2(I3G3)+4*
     &  (ctautauZL-ctautauZR)**2*DBLE(myB0i(dbb0k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))*MFe2(I3G3)+12*(CuuZL-CuuZR)**2*
     &  DBLE(myB0i(dbb0k,MZ2,MFu2(I3G3),MFu2(I3G3)))*MFu2(I3G3))/2.
    	enddo

    	do I5G3 = 1,5
    	do I5G4 = 1,5
       dZZZ1=dZZZ1+(CF11ZL(I5G3,I5G4)*(-(CF11ZR(I5G4,I5G3)*
     &  DBLE(myB0i(dbb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu(I5G3)*
     &  MNeu(I5G4))+CF11ZL(I5G4,I5G3)*(DBLE(myB0i(bb1k,MZ2,MNeu2(I5G3)
     &  ,MNeu2(I5G4)))-2*DBLE(myB0i(dbb00k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))+
     &  MZ2*DBLE(myB0i(dbb1k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))+
     &  DBLE(myB0i(dbb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu2(I5G3)))+
     &  CF11ZR(I5G3,I5G4)*(-(CF11ZL(I5G4,I5G3)*
     &  DBLE(myB0i(dbb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu(I5G3)*
     &  MNeu(I5G4))+CF11ZR(I5G4,I5G3)*(DBLE(myB0i(bb1k,MZ2,MNeu2(I5G3)
     &  ,MNeu2(I5G4)))-2*DBLE(myB0i(dbb00k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))+
     &  MZ2*DBLE(myB0i(dbb1k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))+
     &  DBLE(myB0i(dbb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu2(I5G3))))
    	enddo
    	enddo

    	do I6G3 = 1,6
       dZZZ1=dZZZ1+ChZZ(I6G3)**2*DBLE(myB0i(dbb0k,MZ2,MZ2,Masshh2(I6G3)))
    	enddo


    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dZZZ1=dZZZ1+2*(ChhZ(I6G3,I6G4)**2*
     &  DBLE(myB0i(dbb00k,MZ2,Masshh2(I6G3),Masshh2(I6G4)))+6*
     &  CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MZ2,MSd2(I6G3),MSd2(I6G4)))+2*
     &  CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MZ2,MSe2(I6G3),MSe2(I6G4)))+6*
     &  CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MZ2,MSu2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo

       dZZZ1=dZZZ1*fac

       dZW1=0D0

       dZW1=dZW1+(5*CWWA**2*DBLE(myB0i(bb0k,MW2,0D0,MW2))+2*CWWA**2*MW2*
     &  DBLE(myB0i(dbb1k,MW2,0D0,MW2))+5*CWWA**2*MW2*
     &  DBLE(myB0i(dbb0k,MW2,0D0,MW2))+8*CWWA**2*
     &  DBLE(myB0i(dbb00k,MW2,0D0,MW2))+2*CWWA**2*DBLE(myB0i(bb1k,MW2,0D0,MW2)))

    	do I2G3 = 1,2
       dZW1=dZW1+(-(CHmWpA(I2G3)**2*DBLE(myB0i(dbb0k,MW2,0D0,MassHpm2(I2G3)
     &  )))-CHmWpZ(I2G3)**2*DBLE(myB0i(dbb0k,MW2,MZ2,MassHpm2(I2G3))))
    	enddo

       dZW1=dZW1+
     &  (3*CWWZ**2*DBLE(myB0i(bb0k,MW2,MW2,MZ2))
     &  -2*CWWZ**2*DBLE(myB0i(bb1k,MW2,MW2,MZ2))+3*CWWZ**2*MW2*
     &  DBLE(myB0i(dbb0k,MW2,MW2,MZ2))+2*CWWZ**2*MZ2*
     &  DBLE(myB0i(dbb0k,MW2,MW2,MZ2))+8*CWWZ**2*
     &  DBLE(myB0i(dbb00k,MW2,MW2,MZ2))-2*CWWZ**2*MW2*DBLE(myB0i(dbb1k,MW2,MW2,MZ2)))

    	do I3G3 = 1,3
       dZW1=dZW1+(-(g2**2*DBLE(myB0i(bb0k,MW2,0D0,MFe2(I3G3))))-g2**2*
     &  DBLE(myB0i(bb1k,MW2,MFe2(I3G3),0D0))-g2**2*MW2*
     &  DBLE(myB0i(dbb0k,MW2,0D0,MFe2(I3G3)))-2*g2**2*
     &  DBLE(myB0i(dbb00k,MW2,MFe2(I3G3),0D0))-g2**2*MW2*
     &  DBLE(myB0i(dbb1k,MW2,MFe2(I3G3),0D0))-6*CupdmWp*
     &  DBLE(myB0i(bb0k,MW2,MFd2(I3G3),MFu2(I3G3)))*DCONJG(CupdmWp)-6*
     &  CupdmWp*DBLE(myB0i(bb1k,MW2,MFd2(I3G3),MFu2(I3G3)))*
     &  DCONJG(CupdmWp)-6*CupdmWp*MW2*DBLE(myB0i(dbb0k,MW2,MFd2(I3G3)
     &  ,MFu2(I3G3)))*DCONJG(CupdmWp)-12*CupdmWp*
     &  DBLE(myB0i(dbb00k,MW2,MFd2(I3G3),MFu2(I3G3)))*DCONJG(CupdmWp)-6*
     &  CupdmWp*MW2*DBLE(myB0i(dbb1k,MW2,MFd2(I3G3),MFu2(I3G3)))*
     &  DCONJG(CupdmWp)+6*CupdmWp*DBLE(myB0i(dbb0k,MW2,MFd2(I3G3)
     &  ,MFu2(I3G3)))*DCONJG(CupdmWp)*MFu2(I3G3))
    	enddo
    	do I2G3 = 1,2
    	do I5G3 = 1,5
       dZW1=dZW1-2*(CLF12F11W(I2G3,I5G3)*
     &  (DBLE(myB0i(bb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+DBLE(myB0i(bb1k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CLF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+2*DBLE(myB0i(dbb00k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CLF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb1k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+DBLE(myB0i(dbb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)-DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))*MNeu2(I5G3))+CRF12F11W(I2G3,I5G3)*
     &  (DBLE(myB0i(bb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))+DBLE(myB0i(bb1k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CRF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))+2*DBLE(myB0i(dbb00k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CRF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb1k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))+DBLE(myB0i(dbb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)-DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))*MNeu2(I5G3)))
    	enddo
    	enddo
    	do I6G3 = 1,6
       dZW1=dZW1+ChWmWp(I6G3)**2*DBLE(myB0i(dbb0k,MW2,MW2,Masshh2(I6G3)))
    	enddo
    	do I2G3 = 1,2
    	do I6G3 = 1,6
       dZW1=dZW1+4*ChHmWp(I2G3,I6G3)*DBLE(myB0i(dbb00k,MW2,Masshh2(I6G3)
     &  ,MassHpm2(I2G3)))*DCONJG(ChHmWp(I2G3,I6G3))
    	enddo
    	enddo
    	do I3G3 = 1,3
    	do I6G3 = 1,6
       dZW1=dZW1+4*CsesvW(I6G3,I3G3)*DBLE(myB0i(dbb00k,MW2,MSe2(I6G3)
     &  ,MSv2(I3G3)))*DCONJG(CsesvW(I6G3,I3G3))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dZW1=dZW1+12*CsdsuW(I6G4,I6G3)*DBLE(myB0i(dbb00k,MW2,MSd2(I6G4)
     &  ,MSu2(I6G3)))*DCONJG(CsdsuW(I6G4,I6G3))
    	enddo
    	enddo
        dZW1=dZW1*fac

       do i=2,6
        dGZmix(i)= SelfHZ(MH1L(i-1)**2, i)
       enddo

      end subroutine RenConstEW
c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine RenConstEWTop()
      implicit none  
  
      integer i,j,k,I2,I2G2,I2G3,I2G4,I3G2,I3G3,I3G4,I5G2,
     &         I5G3,I5G4,I6G2,I6G3,I6G4

      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
     
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

      double precision MHpm1l,Mh1l(5),ZH1l(5,5)

      common /H1loop/ MHpm1l,MH1l,ZH1l

      double precision p2,myA0,ZHG(6,6)

#include "HdecayTCLs.inc"

      double complex IC,myB0i

      double precision dphitop,dphitopIL,dphitopl,dphitops,dphitopu,
     &                 dUVZZAtop1,dUVTadMHtop1(6),dphitopk,dUVZAAtop1,dZAAtop1,
     &                  dZZAtop1,dZHutop,dZHdtop,dZHstop, dUVTadihtop1(6),
     &                 dUVMHpsqtop1,dUVMWsqtop1,dUVMZsqtop1,dUVZetop1,dUVvtop1,
     &                 dUVSWtop1,dTadihtop1(6),dTadMHtop1(6)

      double precision dMHpsqtop1,dMWsqtop1,dMZsqtop1,dZNHiggstop(6,6),
     &                 dZZZtop1, dZWtop1,dvstop1,dZetop1,
     &                 dTANBtop1,dSWtop1,dSinBtop1,dReAkappatop,dCosBtop1
     &                 dabslambdatop,dabskappatop,dCosBtop1,dabslambdatop

      double complex   dGZmixtop(6),dvtop1
      common/CTermsfermiononly/dMHpsqtop1,dMWsqtop1,dMZsqtop1,dZNHiggstop,
     &                 dZZZtop1, dZWtop1,dvstop1,dZetop1,
     &                 dTANBtop1,dSWtop1,dSinBtop1,dReAkappatop,dCosBtop1
     &                 dabslambdatop,dabskappatop,dCosBtop1,dabslambdatop,
     &                 dGZmixtop,dvtop1

      parameter (IC=(0,1D0))
       dMHpsqtop1=0D0
       i=2;j=2
    	do I3G3 = 1,3
        dMHpsqtop1=dMHpsqtop1+(2*(3*
     &  MHp2*myB0i(bb1k,MHp2,MFd2(I3G3),MFu2(I3G3))*Yd(I3G3)**2*ZP(i,1)*
     &  ZP(j,1)-myA0(MFe2(I3G3))*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+MHp2*
     &  myB0i(bb0k,MHp2,0D0,MFe2(I3G3))*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+MHp2*
     &  myB0i(bb1k,MHp2,MFe2(I3G3),0D0)*Ye(I3G3)**2*ZP(i,1)*ZP(j,1)+3*MHp2*
     &  myB0i(bb1k,MHp2,MFd2(I3G3),MFu2(I3G3))*Yu(I3G3)**2*ZP(i,2)*ZP(j,2)-
     &  3*myA0(MFd2(I3G3))*(Yd(I3G3)**2*ZP(i,1)*ZP(j,1)+Yu(I3G3)**2*
     &  ZP(i,2)*ZP(j,2))+3*myB0i(bb0k,MHp2,MFd2(I3G3),MFu2(I3G3))*((MHp2-
     &  MFu2(I3G3))*Yd(I3G3)**2*ZP(i,1)*ZP(j,1)+(MHp2-MFu2(I3G3))*
     &  Yu(I3G3)**2*ZP(i,2)*ZP(j,2)-MassFd(I3G3)*MassFu(I3G3)*Yd(I3G3)*
     &  Yu(I3G3)*(ZP(i,2)*ZP(j,1)+ZP(i,1)*ZP(j,2)))))
    	enddo
    	do I3G3 = 1,3
       dMHpsqtop1=dMHpsqtop1+(IC*myA0(MSv2(I3G3))*CHmHpSvSv(I3G3,i,I3G3,j))
    	enddo 
    	do I6G3 = 1,6
       dMHpsqtop1=dMHpsqtop1+(
     &  +3*IC*myA0(MSd2(I6G3))*CHmHpSdmSdp(I6G3,i,I6G3,j)+IC*
     &  myA0(MSe2(I6G3))*CHmHpSemSep(I6G3,i,I6G3,j)+3*IC*myA0(MSu2(I6G3))
     &  *CHmHpSupSum(I6G3,i,I6G3,j))
    	enddo
    	do I3G3 = 1,3
    	do I6G3 = 1,6
       dMHpsqtop1=dMHpsqtop1-(myB0i(bb0k,MHp2,MSe2(I6G3),MSv2(I3G3))*
     &  CHmSepSv(I3G3,I6G3,i)*CHpSemSv(I6G3,I3G3,j))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dMHpsqtop1=dMHpsqtop1-3*myB0i(bb0k,MHp2,MSd2(I6G4),MSu2(I6G3))*
     &  CHmSupSdp(I6G3,I6G4,i)*CHpSumSdm(I6G4,I6G3,j)
    	enddo
    	enddo
        dMHpsqtop1=dMHpsqtop1*fac
c#define DEBUG
#ifdef DEBUGRenConstEWTop
	DEB 'dMHpsqtop1 =', dMHpsqtop1
#endif

       dMWsqtop1=0D0

    	do I3G3 = 1,3
       dMWsqtop1=dMWsqtop1+(g2**2*(-6*myA0(MFd2(I3G3))-2*myA0(MFe2(I3G3))+
     &  myA0(MSv2(I3G3))+2*MW2*DBLE(myB0i(bb0k,MW2,0D0,MFe2(I3G3)))+6*MW2*
     &  DBLE(myB0i(bb0k,MW2,MFd2(I3G3),MFu2(I3G3)))+12*
     &  DBLE(myB0i(bb00k,MW2,MFd2(I3G3),MFu2(I3G3)))+4*
     &  DBLE(myB0i(bb00k,MW2,MFe2(I3G3),0D0))+6*MW2*
     &  DBLE(myB0i(bb1k,MW2,MFd2(I3G3),MFu2(I3G3)))+2*MW2*
     &  DBLE(myB0i(bb1k,MW2,MFe2(I3G3),0D0))-6*DBLE(myB0i(bb0k,MW2,MFd2(I3G3)
     &  ,MFu2(I3G3)))*MFu2(I3G3)))/2.
    	enddo
    	do I6G3 = 1,6
       dMWsqtop1=dMWsqtop1+(3*CSdSdWW(I6G3,I6G3)*DBLE(myA0(MSd2(I6G3)))+
     &  CSeSeWW(I6G3,I6G3)*DBLE(myA0(MSe2(I6G3)))+3*CSuSuWW(I6G3,I6G3)*
     &  DBLE(myA0(MSu2(I6G3))))
    	enddo

    	do I3G3 = 1,3
    	do I6G3 = 1,6
       dMWsqtop1=dMWsqtop1-4*CsesvW(I6G3,I3G3)*
     &  DBLE(myB0i(bb00k,MW2,MSe2(I6G3),MSv2(I3G3)))*
     &  DCONJG(CsesvW(I6G3,I3G3))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dMWsqtop1=dMWsqtop1-12*CsdsuW(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MW2,MSd2(I6G4),MSu2(I6G3)))*
     &  DCONJG(CsdsuW(I6G4,I6G3))
    	enddo
    	enddo
       dMWsqtop1=dMWsqtop1*fac
#ifdef DEBUGRenConstEWTop
	print*,'dMWsqtop1 =', dMWsqtop1
#endif

       dMZsqtop1=0D0

    	do I3G3 = 1,3
       dMZsqtop1=dMZsqtop1+(-12*(CddZL**2+CddZR**2)*myA0(MFd2(I3G3))-4*
     &  (ctautauZL**2+ctautauZR**2)*myA0(MFe2(I3G3))-12*(CuuZL**2+CuuZR*
     &  *2)*myA0(MFu2(I3G3))+2*CSvSvZZ*myA0(MSv2(I3G3))+2*(CW2*g2**2+g1*
     &  (2*CW*g2*SW+g1*SW2))*DBLE(myB0i(bb00k,MZ2,0D0,0D0))+24*(CddZL**2+
     &  CddZR**2)*DBLE(myB0i(bb00k,MZ2,MFd2(I3G3),MFd2(I3G3)))+8*
     &  (ctautauZL**2+ctautauZR**2)*DBLE(myB0i(bb00k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))+24*(CuuZL**2+CuuZR**2)*
     &  DBLE(myB0i(bb00k,MZ2,MFu2(I3G3),MFu2(I3G3)))-8*CsvsvZ**2*
     &  DBLE(myB0i(bb00k,MZ2,MSv2(I3G3),MSv2(I3G3)))-MZ2*(CW2*g2**2+g1*
     &  (2*CW*g2*SW+g1*SW2))*DBLE(myB0i(bb1k,MZ2,0D0,0D0))-12*(CddZL**2+
     &  CddZR**2)*MZ2*DBLE(myB0i(bb1k,MZ2,MFd2(I3G3),MFd2(I3G3)))-4*
     &  (ctautauZL**2+ctautauZR**2)*MZ2*DBLE(myB0i(bb1k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))-12*(CuuZL**2+CuuZR**2)*MZ2*
     &  DBLE(myB0i(bb1k,MZ2,MFu2(I3G3),MFu2(I3G3)))-12*(CddZL-CddZR)**2*
     &  DBLE(myB0i(bb0k,MZ2,MFd2(I3G3),MFd2(I3G3)))*MFd2(I3G3)-4*
     &  (ctautauZL-ctautauZR)**2*DBLE(myB0i(bb0k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))*MFe2(I3G3)-12*(CuuZL-CuuZR)**2*
     &  DBLE(myB0i(bb0k,MZ2,MFu2(I3G3),MFu2(I3G3)))*MFu2(I3G3))/2.
    	enddo

    	do I6G3 = 1,6
       dMZsqtop1=dMZsqtop1+(+3*
     &  myA0(MSd2(I6G3))*CSdSdZZ(I6G3,I6G3)+myA0(MSe2(I6G3))*
     &  CSeSeZZ(I6G3,I6G3)+3*myA0(MSu2(I6G3))*CSuSuZZ(I6G3,I6G3))
    	enddo


    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dMZsqtop1=dMZsqtop1-2*(+6*
     &  CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MZ2,MSd2(I6G3),MSd2(I6G4)))+2*
     &  CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MZ2,MSe2(I6G3),MSe2(I6G4)))+6*
     &  CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3)*
     &  DBLE(myB0i(bb00k,MZ2,MSu2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo
       dMZsqtop1=dMZsqtop1*fac

       
#ifdef DEBUGRenConstEWTop
	print*,'dMZsqtop1 =', dMZsqtop1
#endif
       do i=1,6
       dTadMHtop1(i)=0D0
    	do I3G2 = 1,3
       dTadMHtop1(i)=dTadMHtop1(i)+IC*(myA0(MSv2(I3G2))*ChSvSvconj(i)-2*(3*
     &  myA0(MFd2(I3G2))*(CLhFdpFdm(I3G2,I3G2,i)+CRhFdpFdm(I3G2,I3G2,i))
     &  *MassFd(I3G2)+myA0(MFe2(I3G2))*(CLhFepFem(I3G2,I3G2,i)+
     &  CRhFepFem(I3G2,I3G2,i))*MassFe(I3G2)+3*myA0(MFu2(I3G2))*
     &  (CLhFumFup(I3G2,I3G2,i)+CRhFumFup(I3G2,I3G2,i))*MassFu(I3G2)))
    	enddo

    	do I6G2 = 1,6
       dTadMHtop1(i)=(IC*(+6*
     &  myA0(MSd2(I6G2))*ChSdmSdp(I6G2,I6G2,i)+2*myA0(MSe2(I6G2))*
     &  ChSemSep(I6G2,I6G2,i)+6*myA0(MSu2(I6G2))*ChSupSum(I6G2,I6G2,i)))
     &  /2.+dTadMHtop1(i)
    	enddo
       dTadMHtop1(i)=dTadMHtop1(i)*fac
        enddo


       do i=1,6
       ZHG(i,1)=ZH(i,4); ZHG(i,2)=ZH(i,5); ZHG(i,3)=ZH(i,6)
       ZHG(i,6)=ZH(i,3)
       ZHG(i,4)= -CB* ZH(i,1)+SB*ZH(i,2)
       ZHG(i,5)=  SB* ZH(i,1)+CB*ZH(i,2)
       enddo
       do i=1,6
        dTadihtop1(i)=0
         do j=1,6
          dTadihtop1(i)=dTadihtop1(i) + ZHG(j,i)* dTadMHtop1(j)
         enddo
       enddo

       dZAAtop1=0D0

    	do I3G3 = 1,3
       dZAAtop1=dZAAtop1+(4*e**2*(DBLE(myB0i(bb1k,0D0,MFd2(I3G3),MFd2(I3G3)))+
     &  3*DBLE(myB0i(bb1k,0D0,MFe2(I3G3),MFe2(I3G3)))+4*
     &  DBLE(myB0i(bb1k,0D0,MFu2(I3G3),MFu2(I3G3)))-2*
     &  DBLE(myB0i(dbb00k,0D0,MFd2(I3G3),MFd2(I3G3)))-6*
     &  DBLE(myB0i(dbb00k,0D0,MFe2(I3G3),MFe2(I3G3)))-8*
     &  DBLE(myB0i(dbb00k,0D0,MFu2(I3G3),MFu2(I3G3)))))/3.
    	enddo

    	do I6G3 = 1,6
       dZAAtop1=dZAAtop1+(4*e**2*(DBLE(myB0i(dbb00k,0D0,MSd2(I6G3),MSd2(I6G3)))
     &  +3*DBLE(myB0i(dbb00k,0D0,MSe2(I6G3),MSe2(I6G3)))+4*
     &  DBLE(myB0i(dbb00k,0D0,MSu2(I6G3),MSu2(I6G3)))))/3.
    	enddo

       dZAAtop1=dZAAtop1*fac
#ifdef DEBUGRenConstEWTop
	print*,'dZAAtop1 =', dZAAtop1
#endif
       dZZAtop1=0D0

    	do I3G3 = 1,3
       dZZAtop1=dZZAtop1+(-4*e*((CddZL+CddZR)*DBLE(myA0(MFd2(I3G3)))+
     &  (ctautauZL+ctautauZR)*DBLE(myA0(MFe2(I3G3)))-2*((CuuZL+CuuZR)*
     &  DBLE(myA0(MFu2(I3G3)))+(CddZL+CddZR)*
     &  DBLE(myB0i(bb00k,0D0,MFd2(I3G3),MFd2(I3G3)))+ctautauZL*
     &  DBLE(myB0i(bb00k,0D0,MFe2(I3G3),MFe2(I3G3)))+ctautauZR*
     &  DBLE(myB0i(bb00k,0D0,MFe2(I3G3),MFe2(I3G3)))-2*CuuZL*
     &  DBLE(myB0i(bb00k,0D0,MFu2(I3G3),MFu2(I3G3)))-2*CuuZR*
     &  DBLE(myB0i(bb00k,0D0,MFu2(I3G3),MFu2(I3G3))))))/MZ2
    	enddo
    	do I6G3 = 1,6
       dZZAtop1=dZZAtop1+(-48*e*CsdmsdpZ(I6G3,I6G3)*
     &  DBLE(myB0i(bb00k,0D0,MSd2(I6G3),MSd2(I6G3)))-48*e*
     &  CsemsepZ(I6G3,I6G3)*DBLE(myB0i(bb00k,0D0,MSe2(I6G3),MSe2(I6G3)))+
     &  96*e*CsupsumZ(I6G3,I6G3)*DBLE(myB0i(bb00k,0D0,MSu2(I6G3)
     &  ,MSu2(I6G3)))-DBLE(myA0(MSd2(I6G3)))*((6*C2W*g1*g2+(g1**2-9*g2**
     &  2)*S2W)*DCONJG(ZD(I6G3,1))*ZD(I6G3,1)+4*g1**2*S2W*
     &  DCONJG(ZD(I6G3,2))*ZD(I6G3,2)+6*C2W*g1*g2*DCONJG(ZD(I6G3,3))
     &  *ZD(I6G3,3)+g1**2*S2W*DCONJG(ZD(I6G3,3))*ZD(I6G3,3)-9*g2**2*
     &  S2W*DCONJG(ZD(I6G3,3))*ZD(I6G3,3)+4*g1**2*S2W*
     &  DCONJG(ZD(I6G3,4))*ZD(I6G3,4)+6*C2W*g1*g2*DCONJG(ZD(I6G3,5))
     &  *ZD(I6G3,5)+g1**2*S2W*DCONJG(ZD(I6G3,5))*ZD(I6G3,5)-9*g2**2*
     &  S2W*DCONJG(ZD(I6G3,5))*ZD(I6G3,5)+4*g1**2*S2W*
     &  DCONJG(ZD(I6G3,6))*ZD(I6G3,6))+3*DBLE(myA0(MSe2(I6G3)))*((2*
     &  C2W*g1*g2+(-g1**2+g2**2)*S2W)*DCONJG(ZE(I6G3,1))*ZE(I6G3,1)-
     &  4*g1**2*S2W*DCONJG(ZE(I6G3,2))*ZE(I6G3,2)+2*C2W*g1*g2*
     &  DCONJG(ZE(I6G3,3))*ZE(I6G3,3)-g1**2*S2W*DCONJG(ZE(I6G3,3))*
     &  ZE(I6G3,3)+g2**2*S2W*DCONJG(ZE(I6G3,3))*ZE(I6G3,3)-4*g1**2*
     &  S2W*DCONJG(ZE(I6G3,4))*ZE(I6G3,4)+2*C2W*g1*g2*
     &  DCONJG(ZE(I6G3,5))*ZE(I6G3,5)-g1**2*S2W*DCONJG(ZE(I6G3,5))*
     &  ZE(I6G3,5)+g2**2*S2W*DCONJG(ZE(I6G3,5))*ZE(I6G3,5)-4*g1**2*
     &  S2W*DCONJG(ZE(I6G3,6))*ZE(I6G3,6))+DBLE(myA0(MSu2(I6G3)))*((6*
     &  C2W*g1*g2-g1**2*S2W+9*g2**2*S2W)*DCONJG(ZU(I6G3,1))*
     &  ZU(I6G3,1)-16*g1**2*S2W*DCONJG(ZU(I6G3,2))*ZU(I6G3,2)+6*C2W*
     &  g1*g2*DCONJG(ZU(I6G3,3))*ZU(I6G3,3)-g1**2*S2W*
     &  DCONJG(ZU(I6G3,3))*ZU(I6G3,3)+9*g2**2*S2W*DCONJG(ZU(I6G3,3))
     &  *ZU(I6G3,3)-16*g1**2*S2W*DCONJG(ZU(I6G3,4))*ZU(I6G3,4)+6*
     &  C2W*g1*g2*DCONJG(ZU(I6G3,5))*ZU(I6G3,5)-g1**2*S2W*
     &  DCONJG(ZU(I6G3,5))*ZU(I6G3,5)+9*g2**2*S2W*DCONJG(ZU(I6G3,5))
     &  *ZU(I6G3,5)-16*g1**2*S2W*DCONJG(ZU(I6G3,6))*ZU(I6G3,6)))/(6.*MZ2)
    	enddo
       dZZAtop1=dZZAtop1*fac
#ifdef DEBUGRenConstEWTop
	print*,'dZZAtop1 =', dZZAtop1
#endif
	dZetop1 = 1/(2.D0*CW)*(dZZAtop1*SW - CW*dZAAtop1)

       dSWtop1= CW2/SW/2.D0 * (dMZsqtop1/MZ2 - dMWsqtop1/MW2)
       dvtop1= (-dZetop1 + (2*dMWsqtop1*MW2 - dMWsqtop1*MZ2)
     &         /(2*MW2**2 - 2*MW2*MZ2) 
     &         - (dMZsqtop1*MW2)/(2*MW2*MZ2 - 2*MZ2**2))*v
       dZZZtop1=0D0
    	do I3G3 = 1,3
       dZZZtop1=dZZZtop1+((CW2*g2**2+g1*(2*CW*g2*SW+g1*SW2))*
     &  DBLE(myB0i(bb1k,MZ2,0D0,0D0))+12*(CddZL**2+CddZR**2)*
     &  DBLE(myB0i(bb1k,MZ2,MFd2(I3G3),MFd2(I3G3)))+4*(ctautauZL**2+
     &  ctautauZR**2)*DBLE(myB0i(bb1k,MZ2,MFe2(I3G3),MFe2(I3G3)))+12*
     &  (CuuZL**2+CuuZR**2)*DBLE(myB0i(bb1k,MZ2,MFu2(I3G3),MFu2(I3G3)))-
     &  2*(CW2*g2**2+g1*(2*CW*g2*SW+g1*SW2))*DBLE(myB0i(dbb00k,MZ2,0D0,0D0))-
     &  24*(CddZL**2+CddZR**2)*DBLE(myB0i(dbb00k,MZ2,MFd2(I3G3)
     &  ,MFd2(I3G3)))-8*(ctautauZL**2+ctautauZR**2)*
     &  DBLE(myB0i(dbb00k,MZ2,MFe2(I3G3),MFe2(I3G3)))-24*(CuuZL**2+CuuZR*
     &  *2)*DBLE(myB0i(dbb00k,MZ2,MFu2(I3G3),MFu2(I3G3)))+8*CsvsvZ**2*
     &  DBLE(myB0i(dbb00k,MZ2,MSv2(I3G3),MSv2(I3G3)))+MZ2*(CW2*g2**2+g1*
     &  (2*CW*g2*SW+g1*SW2))*DBLE(myB0i(dbb1k,MZ2,0D0,0D0))+12*(CddZL**2+
     &  CddZR**2)*MZ2*DBLE(myB0i(dbb1k,MZ2,MFd2(I3G3),MFd2(I3G3)))+4*
     &  (ctautauZL**2+ctautauZR**2)*MZ2*DBLE(myB0i(dbb1k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))+12*(CuuZL**2+CuuZR**2)*MZ2*
     &  DBLE(myB0i(dbb1k,MZ2,MFu2(I3G3),MFu2(I3G3)))+12*(CddZL-CddZR)**2*
     &  DBLE(myB0i(dbb0k,MZ2,MFd2(I3G3),MFd2(I3G3)))*MFd2(I3G3)+4*
     &  (ctautauZL-ctautauZR)**2*DBLE(myB0i(dbb0k,MZ2,MFe2(I3G3)
     &  ,MFe2(I3G3)))*MFe2(I3G3)+12*(CuuZL-CuuZR)**2*
     &  DBLE(myB0i(dbb0k,MZ2,MFu2(I3G3),MFu2(I3G3)))*MFu2(I3G3))/2.
    	enddo


    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dZZZtop1=dZZZtop1+2*(+6*
     &  CsdmsdpZ(I6G3,I6G4)*CsdmsdpZ(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MZ2,MSd2(I6G3),MSd2(I6G4)))+2*
     &  CsemsepZ(I6G3,I6G4)*CsemsepZ(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MZ2,MSe2(I6G3),MSe2(I6G4)))+6*
     &  CsupsumZ(I6G3,I6G4)*CsupsumZ(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MZ2,MSu2(I6G3),MSu2(I6G4))))
    	enddo
    	enddo

        dZZZtop1=dZZZtop1*fac

#ifdef DEBUGRenConstEWTop
	print*,'dZZZtop1 =', dZZZtop1
#endif
 

       dZWtop1=0D0

    	do I3G3 = 1,3
       dZWtop1=dZWtop1+(-(g2**2*DBLE(myB0i(bb0k,MW2,0D0,MFe2(I3G3))))-g2**2*
     &  DBLE(myB0i(bb1k,MW2,MFe2(I3G3),0D0))-g2**2*MW2*
     &  DBLE(myB0i(dbb0k,MW2,0D0,MFe2(I3G3)))-2*g2**2*
     &  DBLE(myB0i(dbb00k,MW2,MFe2(I3G3),0D0))-g2**2*MW2*
     &  DBLE(myB0i(dbb1k,MW2,MFe2(I3G3),0D0))-6*CupdmWp*
     &  DBLE(myB0i(bb0k,MW2,MFd2(I3G3),MFu2(I3G3)))*DCONJG(CupdmWp)-6*
     &  CupdmWp*DBLE(myB0i(bb1k,MW2,MFd2(I3G3),MFu2(I3G3)))*
     &  DCONJG(CupdmWp)-6*CupdmWp*MW2*DBLE(myB0i(dbb0k,MW2,MFd2(I3G3)
     &  ,MFu2(I3G3)))*DCONJG(CupdmWp)-12*CupdmWp*
     &  DBLE(myB0i(dbb00k,MW2,MFd2(I3G3),MFu2(I3G3)))*DCONJG(CupdmWp)-6*
     &  CupdmWp*MW2*DBLE(myB0i(dbb1k,MW2,MFd2(I3G3),MFu2(I3G3)))*
     &  DCONJG(CupdmWp)+6*CupdmWp*DBLE(myB0i(dbb0k,MW2,MFd2(I3G3)
     &  ,MFu2(I3G3)))*DCONJG(CupdmWp)*MFu2(I3G3))
    	enddo

    	do I3G3 = 1,3
    	do I6G3 = 1,6
       dZWtop1=dZWtop1+4*CsesvW(I6G3,I3G3)*
     &  DBLE(myB0i(dbb00k,MW2,MSe2(I6G3),MSv2(I3G3)))*
     &  DCONJG(CsesvW(I6G3,I3G3))
    	enddo
    	enddo
    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dZWtop1=dZWtop1+12*CsdsuW(I6G4,I6G3)*
     &  DBLE(myB0i(dbb00k,MW2,MSd2(I6G4),MSu2(I6G3)))*
     &  DCONJG(CsdsuW(I6G4,I6G3))
    	enddo
    	enddo
        dZWtop1=dZWtop1*fac



#ifdef DEBUGRenConstEWTop
	print*,'dZWtop1 =', dZWtop1
#endif
 
      do i=2,6
       dGZmixtop(i)=0D0
        p2= MH1l(i-1)**2
    	do I3G3 = 1,3
       dGZmixtop(i)=dGZmixtop(i)+IC*(-(CsvsvZ*myB0i(bb0k,P2,MSv2(I3G3),MSv2(I3G3))*
     &  ChSvSvconj(i))-2*CsvsvZ*myB0i(bb1k,P2,MSv2(I3G3),MSv2(I3G3))*
     &  ChSvSvconj(i)+6*(CddZL+CddZR)*myB0i(bb1k,P2,MFd2(I3G3),MFd2(I3G3)
     &  )*(CLhFdpFdm(I3G3,I3G3,i)+CRhFdpFdm(I3G3,I3G3,i))*MassFd(I3G3)+
     &  6*myB0i(bb0k,P2,MFd2(I3G3),MFd2(I3G3))*(CddZR*
     &  CLhFdpFdm(I3G3,I3G3,i)+CddZL*CRhFdpFdm(I3G3,I3G3,i))*
     &  MassFd(I3G3)+2*(ctautauZL+ctautauZR)*myB0i(bb1k,P2,MFe2(I3G3)
     &  ,MFe2(I3G3))*(CLhFepFem(I3G3,I3G3,i)+CRhFepFem(I3G3,I3G3,i))*
     &  MassFe(I3G3)+2*myB0i(bb0k,P2,MFe2(I3G3),MFe2(I3G3))*(ctautauZR*
     &  CLhFepFem(I3G3,I3G3,i)+ctautauZL*CRhFepFem(I3G3,I3G3,i))*
     &  MassFe(I3G3)+6*(CuuZL+CuuZR)*myB0i(bb1k,P2,MFu2(I3G3),MFu2(I3G3))
     &  *(CLhFumFup(I3G3,I3G3,i)+CRhFumFup(I3G3,I3G3,i))*MassFu(I3G3)+
     &  6*myB0i(bb0k,P2,MFu2(I3G3),MFu2(I3G3))*(CuuZR*
     &  CLhFumFup(I3G3,I3G3,i)+CuuZL*CRhFumFup(I3G3,I3G3,i))*MassFu(I3G3))
    	enddo


    	do I6G3 = 1,6
    	do I6G4 = 1,6
       dGZmixtop(i)=dGZmixtop(i)+(-IC*(3*
     &  myB0i(bb0k,P2,MSd2(I6G3),MSd2(I6G4))*ChSdmSdp(I6G3,I6G4,i)*
     &  CsdmsdpZ(I6G4,I6G3)+6*myB0i(bb1k,P2,MSd2(I6G3),MSd2(I6G4))*
     &  ChSdmSdp(I6G3,I6G4,i)*CsdmsdpZ(I6G4,I6G3)+
     &  myB0i(bb0k,P2,MSe2(I6G3),MSe2(I6G4))*ChSemSep(I6G3,I6G4,i)*
     &  CsemsepZ(I6G4,I6G3)+2*myB0i(bb1k,P2,MSe2(I6G3),MSe2(I6G4))*
     &  ChSemSep(I6G3,I6G4,i)*CsemsepZ(I6G4,I6G3)+3*
     &  myB0i(bb0k,P2,MSu2(I6G3),MSu2(I6G4))*ChSupSum(I6G3,I6G4,i)*
     &  CsupsumZ(I6G4,I6G3)+6*myB0i(bb1k,P2,MSu2(I6G3),MSu2(I6G4))*
     &  ChSupSum(I6G3,I6G4,i)*CsupsumZ(I6G4,I6G3)))
    	enddo
    	enddo

       dGZmixtop(i)=dGZmixtop(i)*fac  + IC*MZ*(1D0/2D0*dZNhiggstop(1,i)
     &          +(-dCosBtop1*SB+CB*dSinBtop1)*ZH(i,2)) 
c       print*, 'dGZmixtop(i)',dGZmixtop(i)
      enddo
      end subroutine RenConstEWTop


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine RenConstEWNeu()
      implicit none 

      integer i,j,k,I2,I2G2,I2G3,I2G4,I3G2,I3G3,I3G4,I5G2,
     &         I5G3,I5G4,I6G2,I6G3,I6G4
      integer bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k
      common /funcID/ bb0k,bb1k,bb00k,dbb0k,dbb1k,dbb00k

      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
     
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZE(6,6),ZD(6,6),ZU(6,6)

      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZE,ZD,ZU

      double precision myA0,ZHG(6,6)

#include "HdecayTCLs.inc"

      double complex IC,myB0i

      double precision dphineu,dphineuIL,dphineul,dphineus,dphineuu,
     &                 dUVZZAneu1,dUVTadMHneu1(6),dphineuk,dUVZAAneu1,dZAAneu1,
     &                  dZZAneu1,dZHuneu,dZHdneu,dZHsneu, dUVTadihneu1(6),
     &                 dUVMHpsqneu1,dUVMWsqneu1,dUVMZsqneu1,dUVZeneu1,dUVvneu1,
     &                 dUVSWneu1,dTadihneu1(6),dTadMHneu1(6)

      double precision dMHpsqneu1,dMWsqneu1,dMZsqneu1,dZNHiggsneu(6,6),
     &                 dZZZneu1, dZWneu1,dvsneu1,dZeneu1,
     &                 dTANBneu1,dSWneu1,dSinBneu1,dReAkappaneu,dCosBneu1
     &                 dabslambdaneu,dabskappaneu,dCosBneu1,dabslambdaneu

      double complex   dGZmixneu(6),dvneu1
      common/CTermneuchaonly/dMHpsqneu1,dMWsqneu1,dMZsqneu1,dZNHiggsneu,
     &                 dZZZneu1, dZWneu1,dvsneu1,dZeneu1,
     &                 dTANBneu1,dSWneu1,dSinBneu1,dReAkappaneu,dCosBneu1
     &                 dabslambdaneu,dabskappaneu,dCosBneu1,dabslambdaneu,
     &                 dGZmixneu,dvneu1

      parameter (IC=(0,1D0))
      dMHpsqneu1=0D0
        i=2;j=2
    	do I2G3 = 1,2
    	do I5G3 = 1,5
        dMHpsqneu1=dMHpsqneu1+2*(myA0(MCha2(I2G3))*(CLHpChiCha(I5G3,I2G3,j)*
     &  CRHmChiCha(I2G3,I5G3,i)+CLHmChiCha(I2G3,I5G3,i)*
     &  CRHpChiCha(I5G3,I2G3,j))-MHp2*myB0i(bb1k,MHp2,MCha2(I2G3),MNeu2(I5G3)
     &  )*(CLHpChiCha(I5G3,I2G3,j)*CRHmChiCha(I2G3,I5G3,i)+
     &  CLHmChiCha(I2G3,I5G3,i)*CRHpChiCha(I5G3,I2G3,j))+
     &  myB0i(bb0k,MHp2,MCha2(I2G3),MNeu2(I5G3))*(CRHpChiCha(I5G3,I2G3,j)*
     &  (CRHmChiCha(I2G3,I5G3,i)*MCha(I2G3)*MNeu(I5G3)+
     &  CLHmChiCha(I2G3,I5G3,i)*(-MHp2+MNeu2(I5G3)))+
     &  CLHpChiCha(I5G3,I2G3,j)*(CLHmChiCha(I2G3,I5G3,i)*MCha(I2G3)*
     &  MNeu(I5G3)+CRHmChiCha(I2G3,I5G3,i)*(-MHp2+MNeu2(I5G3)))))
    	enddo
    	enddo

        dMHpsqneu1=dMHpsqneu1*fac
c#define DEBUG
#ifdef DEBUGRenConstEWNeu
	print*,'dMHpsqneu1 =', dMHpsqneu1
#endif

       dMWsqneu1=0D0

    	do I2G3 = 1,2
    	do I5G3 = 1,5
       dMWsqneu1=dMWsqneu1+2*(-(myA0(MCha2(I2G3))*(CLF12F11W(I2G3,I5G3)*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+CRF12F11W(I2G3,I5G3)*
     &  DCONJG(CRF12F11W(I2G3,I5G3))))+CLF12F11W(I2G3,I5G3)*((2*
     &  DBLE(myB0i(bb00k,MW2,MCha2(I2G3),MNeu2(I5G3)))+MW2*
     &  DBLE(myB0i(bb1k,MW2,MCha2(I2G3),MNeu2(I5G3))))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+DBLE(myB0i(bb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*(DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)+DCONJG(CLF12F11W(I2G3,I5G3))*(MW2-MNeu2(I5G3))))+
     &  CRF12F11W(I2G3,I5G3)*((2*DBLE(myB0i(bb00k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))+MW2*DBLE(myB0i(bb1k,MW2,MCha2(I2G3),MNeu2(I5G3))))
     &  *DCONJG(CRF12F11W(I2G3,I5G3))+DBLE(myB0i(bb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*(DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)+DCONJG(CRF12F11W(I2G3,I5G3))*(MW2-MNeu2(I5G3)))))
    	enddo
    	enddo

       dMWsqneu1=dMWsqneu1*fac
#ifdef DEBUGRenConstEWNeu
	print*,'dMWsqneu1 =', dMWsqneu1
#endif

       dMZsqneu1=0D0

    	do I2G3 = 1,2
    	do I2G4 = 1,2
       dMZsqneu1=dMZsqneu1+2*(-(myA0(MCha2(I2G4))*(CF12ZL(I2G3,I2G4)*
     &  CF12ZL(I2G4,I2G3)+CF12ZR(I2G3,I2G4)*CF12ZR(I2G4,I2G3)))+
     &  CF12ZL(I2G3,I2G4)*(CF12ZR(I2G4,I2G3)*
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha(I2G3)*
     &  MCha(I2G4)+CF12ZL(I2G4,I2G3)*(2*DBLE(myB0i(bb00k,MZ2,MCha2(I2G3)
     &  ,MCha2(I2G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MCha2(I2G3),MCha2(I2G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha2(I2G3)))+
     &  CF12ZR(I2G3,I2G4)*(CF12ZL(I2G4,I2G3)*
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha(I2G3)*
     &  MCha(I2G4)+CF12ZR(I2G4,I2G3)*(2*DBLE(myB0i(bb00k,MZ2,MCha2(I2G3)
     &  ,MCha2(I2G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MCha2(I2G3),MCha2(I2G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MCha2(I2G3),MCha2(I2G4)))*MCha2(I2G3))))
    	enddo
    	enddo

    	do I5G3 = 1,5
    	do I5G4 = 1,5
       dMZsqneu1=dMZsqneu1+(-(myA0(MNeu2(I5G4))*(CF11ZL(I5G3,I5G4)*
     &  CF11ZL(I5G4,I5G3)+CF11ZR(I5G3,I5G4)*CF11ZR(I5G4,I5G3)))+
     &  CF11ZL(I5G3,I5G4)*(CF11ZR(I5G4,I5G3)*
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu(I5G3)*
     &  MNeu(I5G4)+CF11ZL(I5G4,I5G3)*(2*DBLE(myB0i(bb00k,MZ2,MNeu2(I5G3)
     &  ,MNeu2(I5G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu2(I5G3)))+
     &  CF11ZR(I5G3,I5G4)*(CF11ZL(I5G4,I5G3)*
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu(I5G3)*
     &  MNeu(I5G4)+CF11ZR(I5G4,I5G3)*(2*DBLE(myB0i(bb00k,MZ2,MNeu2(I5G3)
     &  ,MNeu2(I5G4)))-MZ2*DBLE(myB0i(bb1k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))-
     &  DBLE(myB0i(bb0k,MZ2,MNeu2(I5G3),MNeu2(I5G4)))*MNeu2(I5G3))))
    	enddo
    	enddo

       dMZsqneu1=dMZsqneu1*fac

       
#ifdef DEBUGRenConstEWNeu
	print*,'dMZsqneu1 =', dMZsqneu1
#endif

       do i=1,6

       dTadMHneu1(i)=0D0
    	do I2G2 = 1,2
       dTadMHneu1(i)=dTadMHneu1(i)+IC*(-2*myA0(MCha2(I2G2))*
     &  (CLhChapCham(I2G2,I2G2,i)+CRhChapCham(I2G2,I2G2,i))*MCha(I2G2))
    	enddo
    	do I5G2 = 1,5
       dTadMHneu1(i)=dTadMHneu1(i)-(IC*myA0(MNeu2(I5G2))*
     &  (CLhChiChi(I5G2,I5G2,i)+CRhChiChi(I5G2,I5G2,i))*MNeu(I5G2))
    	enddo
       dTadMHneu1(i)=dTadMHneu1(i)*fac
        enddo
       do i=1,6
       ZHG(i,1)=ZH(i,4); ZHG(i,2)=ZH(i,5); ZHG(i,3)=ZH(i,6)
       ZHG(i,6)=ZH(i,3)
       ZHG(i,4)= -CB* ZH(i,1)+SB*ZH(i,2)
       ZHG(i,5)=  SB* ZH(i,1)+CB*ZH(i,2)
       enddo
       do i=1,6
        dTadihneu1(i)=0
         do j=1,6
          dTadihneu1(i)=dTadihneu1(i) + ZHG(j,i)* dTadMHneu1(j)
         enddo
       enddo
#ifdef DEBUGRenConstEWNeu
       print*, 'dthd, dUVthd',dTadihneu1(1)
       print*, 'dthu, dUVthu',dTadihneu1(2)
       print*, 'dths, dUVths',dTadihneu1(3)
       print*, 'dtad, dUVtad',dTadihneu1(4)
       print*, 'dtau, dUVtau',dTadihneu1(5)
       print*, 'dtas, dUVtas',dTadihneu1(6)
#endif
       dZAAneu1=0D0
    	do I2G3 = 1,2
       dZAAneu1=dZAAneu1+(4*e**2*
     &  DBLE(myB0i(bb1k,0D0,MCha2(I2G3),MCha2(I2G3)))+4*e**2*(-2*
     &  DBLE(myB0i(dbb00k,0D0,MCha2(I2G3),MCha2(I2G3)))))
    	enddo

       dZAAneu1=dZAAneu1*fac
#ifdef DEBUGRenConstEWNeu
	print*,'dZAAneu1 =', dZAAneu1
#endif
       dZZAneu1=0D0

    	do I2G3 = 1,2
       dZZAneu1=dZZAneu1+(-8*e*(CF12ZL(I2G3,I2G3)+CF12ZR(I2G3,I2G3))*
     &  DBLE(myA0(MCha2(I2G3)))+16*e*
     &  (CF12ZL(I2G3,I2G3)+CF12ZR(I2G3,I2G3))*
     &  DBLE(myB0i(bb00k,0D0,MCha2(I2G3),MCha2(I2G3))) )/(2.*MZ2)
    	enddo
       dZZAneu1=dZZAneu1*fac
#ifdef DEBUGRenConstEWNeu
	print*,'dZZAneu1 =', dZZAneu1
#endif
       dZeneu1 = 1/(2.D0*CW)*(dZZAneu1*SW - CW*dZAAneu1)
       dSWneu1= CW2/SW/2.D0 * (dMZsqneu1/MZ2 - dMWsqneu1/MW2)
       dvneu1= (-dZeneu1 + (2*dMWsqneu1*MW2 - dMWsqneu1*MZ2)
     &         /(2*MW2**2 - 2*MW2*MZ2) 
     &         - (dMZsqneu1*MW2)/(2*MW2*MZ2 - 2*MZ2**2))*v

       dZZZneu1=0D0

        dZZZneu1=dZZZneu1*fac
#ifdef DEBUGRenConstEWNeu
	print*,'dZZZneu1 =', dZZZneu1
#endif
       dZWneu1=0D0
    	do I2G3 = 1,2
    	do I5G3 = 1,5
        dZWneu1=dZWneu1-2*(CLF12F11W(I2G3,I5G3)*
     &  (DBLE(myB0i(bb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+DBLE(myB0i(bb1k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CLF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+2*DBLE(myB0i(dbb00k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CLF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb1k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))+DBLE(myB0i(dbb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CRF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)-DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CLF12F11W(I2G3,I5G3))*MNeu2(I5G3))+CRF12F11W(I2G3,I5G3)*
     &  (DBLE(myB0i(bb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))+DBLE(myB0i(bb1k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CRF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))+2*DBLE(myB0i(dbb00k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CRF12F11W(I2G3,I5G3))+MW2*
     &  DBLE(myB0i(dbb1k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))+DBLE(myB0i(dbb0k,MW2,MCha2(I2G3)
     &  ,MNeu2(I5G3)))*DCONJG(CLF12F11W(I2G3,I5G3))*MCha(I2G3)*
     &  MNeu(I5G3)-DBLE(myB0i(dbb0k,MW2,MCha2(I2G3),MNeu2(I5G3)))*
     &  DCONJG(CRF12F11W(I2G3,I5G3))*MNeu2(I5G3)))
    	enddo
    	enddo
        dZWneu1=dZWneu1*fac
#ifdef DEBUGRenConstEWNeu
	print*,'dZWneu1 =', dZWneu1
#endif
       dGZmixneu(1:6)=0D0
      end subroutine RenConstEWNeu

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine RenConstSTSB(ischemet,ischemeb) 
      implicit none
      integer i,j,k,l,ib,ischemet,ischemeb,gt1,gt2,gt3,gt4,iew,iuv,jj,kk
      double precision c1,c2,dmf,mf,Mtree2(2),MLoop2(2),
     &                 mfp,dmfp,a(3,3),d(3),root(3),Mq21L(3),dMSQ2B(3),
     &                 dmfQCD,dmfpQCD,dMSQ2BQCD(3)
      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
     
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)

      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZEN,ZDN,ZUN

      double complex IC,lam,kap,expeta,expetas,
     &               dlambdaC1,lamC,Au(3),Ad(3),Ae(3),self,Dself,
     &               selfT(4),dMSt2(2,2),dMSb2(2,2),ZU(2,2),ZUC(2,2),AuC(3),
     &               AdC(3),AeC(3),ZD(2,2),ZDC(2,2),dMC,dAuC(3),dAdC(3),
     &               dmsttmp(2,2),dmsqtmp(2,2),dZSttmp(2,2),dZSbtmp(2,2),dMUE,
     &               dMUEC,MUE,MUEC,dMSt2QCD(2,2),dMSb2QCD(2,2),dAuCQCD(3),dAdCQCD(3),
     &               ZSfac(2,2),dUVMSQ2(3),dUVMSt2(2,2),dUVmf,dUVMSQ2QCD(3),
     &               dUVmfQCD,dUVMSt2QCD(2,2),atest,ctest


       double precision dYu(3),dYd(3)
       double complex dAu(3),dAd(3),dMSUR2(3),dMSQ2(3),dMSDR2(3),dZSt(6,6),
     &                dZSTC(6,6),dZSb(6,6),dZSbC(6,6),ZD1L(6,6)
       common/CTstst/ dAu,dAd,dMSUR2,dMSQ2,dMSDR2,dZSt,dZStC,dZSb,dZSbC,
     &                ZD1L,dYu,dYd

       double precision MSd1LQCD(6),dYuQCD(3),dYdQCD(3)
       double complex dAuQCD(3),dAdQCD(3),dMSUR2QCD(3),dMSQ2QCD(3),dMSDR2QCD(3),
     &                dZStQCD(6,6),dZStQCDC(6,6),dZSbQCD(6,6),dZSbQCDC(6,6),
     &                ZD1LQCD(6,6)

       common/CTststQCD/ dAuQCD,dAdQCD,dMSUR2QCD,dMSQ2QCD,dMSDR2QCD,
     &                dZStQCD,dZStQCDC,dZSbQCD,dZSbQCDC,ZD1LQCD,MSd1LQCD,
     &                dYuQCD,dYdQCD

       double complex dMStsq1QCD(6,6),dMSbsq1QCD(6,6),dMStsq1(6,6),dMSbsq1(6,6)
       common/CTststmass/dMStsq1QCD,dMSbsq1QCD,dMStsq1,dMSbsq1
    
#include "HdecayTCLs.inc"
#include "HdecayCTs.inc"

       sqrt2=Sqrt(2D0)
       IC= dcmplx(0,1D0)

       lam= abslambda*(cos(phil)+IC*sin(phil) )
       lamc=DCONJG(lam)
       kap= abskappa*(cos(phik)+IC*sin(phik) )
       dlambda1= dabslambda*(cos(phil)+IC*sin(phil) )
       dlambdaC1= dabslambda*(cos(phil)-IC*sin(phil) )
       expeta = (cos(phiu)+IC*sin(phiu) )   
       expetas= (cos(phis)+IC*sin(phis) )  
       dCW1=-dSW1*SW/CW
        do i=1,3
        au(i)= absAu(i)*(cos(phiau(i))+IC*sin(phiau(i))) 
        ad(i)= absAd(i)*(cos(phiad(i))+IC*sin(phiad(i))) 
        ae(i)= absAe(i)*(cos(phiae(i))+IC*sin(phiae(i))) 
        enddo
       AuC(1:3)=DCONJG(Au(1:3))
       AdC(1:3)=DCONJG(Ad(1:3))
       AeC(1:3)=DCONJG(Ae(1:3))
       Zst(1:2,1:2)= ZUN(5:6,5:6)
       Zsb(1:2,1:2)= ZDN(5:6,5:6)
       MSUT(1:6)=MSu(1:6)
       MSDT(1:6)=MSd(1:6)  
c       do i=1,3
       i=3
  

       if(i.eq.1)then
       ZU(1:2,1:2)=ZUN(1:2,1:2)
       mf=mu
       ZD(1:2,1:2)=ZDN(1:2,1:2)
       mfp=md
       elseif (i.eq.2)then
       ZU(1:2,1:2)=ZUN(3:4,3:4)
       mf=mc
       ZD(1:2,1:2)=ZDN(3:4,3:4)
       mfp=ms
       elseif (i.eq.3)then
       ZU(1:2,1:2)=ZUN(5:6,5:6)
       mf=mt
       ZD(1:2,1:2)=ZDN(5:6,5:6)
       mfp=mb
       endif 
       ZUC(1:2,1:2)=DCONJG(ZU(1:2,1:2))
       ZDC(1:2,1:2)=DCONJG(ZD(1:2,1:2))
c stop sector

       if (ischemet.lt.3)then
c( EW corection in OS scheme
        iuv=0
c EW corection in OS scheme)
       else
c( EW corection in DRbar scheme
        iuv=1
c EW corection in DRbar scheme)
       endif

       call Selftop(mf**2, i,i,selfT,1,iuv)  
       dmf= DBLE(mf*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0
       dYu(i)= sqrt2*(dmf/SB/v - mf*dSinB1/SB**2/v- mf*dv1/SB/v**2)
       call SelfStop(msu(2*i-1)**2,2*i-1,2*i-1,self,1,iuv)
       dMSt2(1,1)=DBLE(self)
       call SelfStop(msu(2*i)**2,2*i,2*i,self,1,iuv)
       dMSt2(2,2)=DBLE(self)

       call SelfStopReti(msu(2*i-1)**2,2*i-1,2*i,self,1,iuv)
       dMSt2(1,2)=self
       dZSt(2*i-1,2*i) = self
       call SelfStopReti(msu(2*i)**2,2*i-1,2*i,self,1,iuv)
       dZSt(2*i-1,2*i) =(dZSt(2*i-1,2*i) - self)/(msu(2*i)**2-msu(2*i-1)**2 )
       dZStC(2*i,2*i-1) =       dZSt(2*i-1,2*i) 

       dMSt2(1,2)=(self+dMSt2(1,2))/2D0
       dMSt2(2,1)=DCONJG(dMSt2(1,2))

       call SelfStop(msu(2*i-1)**2,2*i,2*i-1,self,1,iuv)
       dZSt(2*i,2*i-1) = 2*(dMSt2(2,1)-self)/(msu(2*i-1)**2-msu(2*i)**2)
       call SelfStop(msu(2*i)**2,2*i-1,2*i,self,1,iuv)
       dZSt(2*i-1,2*i) = -2*(dMSt2(1,2)-self)/(msu(2*i-1)**2-msu(2*i)**2)
       call SelfStop(msu(2*i)**2,2*i,2*i-1,self,1,iuv)
       dZStC(2*i,2*i-1) =-2*(dMSt2(2,1)-self)/(msu(2*i-1)**2-msu(2*i)**2)  
       call SelfStop(msu(2*i-1)**2,2*i-1,2*i,self,1,iuv)
       dZStC(2*i-1,2*i) = 2*(dMSt2(1,2)-self)/(msu(2*i-1)**2-msu(2*i)**2)

       if (ischemet.lt.3)then
c OS EW
       dMSUR2(i)=DBLE(-2*dmf*Mf-(4*CB**2*dSW1*MZ2*SW)/3.+(4*dSW1*MZ2*SB**2*
     &  SW)/3.-(2*CB**2*dMZsq1*SW**2)/3.+(2*dMZsq1*SB**2*SW**2)/3.
     &  +dMSt2(1,1)*ZU(1,2)*ZUC(1,2)+dMSt2(1,2)*ZU(2,2)*ZUC(1,2)
     &  +dMSt2(2,1)*ZU(1,2)*ZUC(2,2)+dMSt2(2,2)*ZU(2,2)*ZUC(2,2))
       dMSQ2(i)=DBLE(-(CB**2*dMZsq1)/2.-2*dmf*Mf
     &  +(dMZsq1*SB**2)/2.+(4*CB**2*dSW1*MZ2*SW)/3.-(4*dSW1*MZ2*SB**
     &  2*SW)/3.+(2*CB**2*dMZsq1*SW**2)/3.-(2*dMZsq1*SB**2*SW**2)/3.
     &  +dMSt2(1,1)*ZU(1,1)*ZUC(1,1)+dMSt2(1,2)*ZU(2,1)*ZUC(1,1)
     &  +dMSt2(2,1)*ZU(1,1)*ZUC(2,1)+dMSt2(2,2)*ZU(2,1)*ZUC(2,1))
       dMC=dMSt2(1,2)-((12*dmf*Mf-8*dSW1*MZ2*(CB**2-SB**2)*SW
     &  -dMZsq1*(CB**2-SB**2)*(-3+
     &  4*SW**2)+6*dMSQ2(i))*ZU(1,1)*ZUC(2,1)+6*dmf*(-((CB*lamC*vS)
     &  /(sqrt2*expetaS*SB))+expeta*Au(i))*ZU(1,2)*ZUC(2,1)
     &  +6*dmf*(-((CB*expetaS*lam*vS)/(sqrt2*SB))+
     &  AuC(i)/expeta)*ZU(1,1)*ZUC(2,2)+2*(6*dmf*Mf+2*SW*
     &  (2*CB*dCosB1*MZ2*SW+CB**2*(2*dSW1*MZ2+dMZsq1*
     &  SW)-SB*(2*dSW1*MZ2*SB+2*dSinB1*MZ2*SW+dMZsq1*SB*SW))+3*
     &  dMSUR2(i))*ZU(1,2)*ZUC(2,2))/6.
c OS EW)
       else
c( DR EW
       dMSUR2(i)=0D0
       dMSQ2(i)=0D0
       dMC=0D0
c  DR EW) 
       endif
       a(1,1)=DBLE(expeta*Mf*ZU(1,2)*ZUC(2,1)+(Mf*ZU(1,1)*ZUC(2,2))/expeta)
       a(1,2)=DBLE(IC*expeta*Mf*ZU(1,2)*ZUC(2,1)-(IC*Mf*ZU(1,1)*
     &  ZUC(2,2))/expeta)
       a(2,1)=DIMAG(expeta*Mf*ZU(1,2)*ZUC(2,1)+(Mf*ZU(1,1)*ZUC(2,2))/expeta)
       a(2,2)=DIMAG(IC*expeta*Mf*ZU(1,2)*ZUC(2,1)-(IC*Mf*ZU(1,1)
     &  *ZUC(2,2))/expeta)
       d(1)=DBLE(dMC)
       d(2)=DIMAG(dMC)

       dAuC(i)= (d(1)*a(2,2)-d(2)*a(1,2))/(a(1,1)*a(2,2)-a(1,2)*a(2,1))
     &    +IC*(d(1)*a(2,1)-d(2)*a(1,1))/(a(1,1)*a(2,2)-a(1,2)*a(2,1)) 
       dAu(i)= DCONJG(dAuC(i))

       dMSttmp(1,1)=2*dmf*Mf-(4*dSW1*MZ2*(CB**2-SB**2)*SW)/3.
     & +dMZsq1*(CB**2-SB**2)*(0.5-(2*SW**2)/3.)+dMSQ2(i)
       dMSttmp(1,2)=dmf*(-((CB*expetaS*lam*vS)/(SB*sqrt2))
     &  +AuC(i)/expeta)+(Mf*dAuC(i))/expeta
       dMSttmp(2,1)=dmf*(-((CB*lamC*vS)/(expetaS*SB*sqrt2))
     &  +expeta*Au(i))+expeta*Mf*dAu(i)
       dMSttmp(2,2)=2*dmf*Mf+(4*dSW1*MZ2*(CB**2-SB**2)*SW)/3.
     &  +(2*dMZsq1*(CB**2-SB**2)*SW**2)/3.+dMSUR2(i)


       do j=1,2
        do k=1,2
          dmc=0D0
          do gt1=1,2
            do gt2=1,2
            dmc= dmc+ ZU(j,gt1)*ZUC(k,gt2)*dMSttmp(gt1,gt2)
            enddo
          enddo
          dMSqtmp(j,k)= dmc
        enddo
       enddo
       dMStsq1(2*i-1,2*i-1)=dMSqtmp(1,1)
       dMStsq1(2*i-1,2*i)=dMSqtmp(1,2)
       dMStsq1(2*i,2*i-1)=dMSqtmp(2,1)
       dMStsq1(2*i,2*i)=dMSqtmp(2,2)
c)EW correction is in OS scheme
       if (ischemet.eq.1)then
c( QCD corection in OS scheme
        iuv=0
c QCD corection in OS scheme)
       else
c( QCD corection in DRbar scheme
        iuv=1
c QCD corection in DRbar scheme)
       endif

       call Selftop(mf**2, i,i,selfT,2,iuv)  
       dmfQCD= DBLE(mf*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0
       dYuQCD(i)= sqrt2*(dmfQCD/SB/v)
       call SelfStop(msu(2*i-1)**2,2*i-1,2*i-1,self,2,iuv)
       dMSt2QCD(1,1)=DBLE(self)
       call SelfStop(msu(2*i)**2,2*i,2*i,self,2,iuv)
       dMSt2QCD(2,2)=DBLE(self)
       call SelfStopReti(msu(2*i-1)**2,2*i-1,2*i,self,2,iuv)
       dMSt2QCD(1,2)=self
       call SelfStopReti(msu(2*i)**2,2*i-1,2*i,self,2,iuv)
       dMSt2QCD(1,2)=(self+dMSt2QCD(1,2))/2D0
       dMSt2QCD(2,1)=DCONJG(dMSt2QCD(1,2))

       call SelfStop(msu(2*i-1)**2,2*i,2*i-1,self,2,iuv)
       dZStQCD(2*i,2*i-1) = 2*(dMSt2QCD(2,1)-self)/(msu(2*i-1)**2-msu(2*i)**2 )
       call SelfStop(msu(2*i)**2,2*i-1,2*i,self,2,iuv)
       dZStQCD(2*i-1,2*i) = -2*(dMSt2QCD(1,2)-self)/(msu(2*i-1)**2-msu(2*i)**2 )
       call SelfStop(msu(2*i)**2,2*i,2*i-1,self,2,iuv)
       dZStQCDC(2*i,2*i-1) =-2*(dMSt2QCD(2,1)-self)/(msu(2*i-1)**2-msu(2*i)**2 )  
       call SelfStop(msu(2*i-1)**2,2*i-1,2*i,self,2,iuv)
       dZStQCDC(2*i-1,2*i) = 2*(dMSt2QCD(1,2)-self)/(msu(2*i-1)**2-msu(2*i)**2 )

       dAuCQCD(i)=(CB*dmfQCD*expeta*expetaS*lam*vS)/(Mf*SB*sqrt2)-
     &  (dmfQCD*AuC(i))/Mf+(expeta*dMSt2QCD(1,1)*ZU(1,2)*ZUC(1,1))/Mf+
     &  (expeta*dMSt2QCD(1,2)*ZU(2,2)*ZUC(1,1))/Mf+(expeta*
     &  dMSt2QCD(2,1)*ZU(1,2)*ZUC(2,1))/Mf+(expeta*dMSt2QCD(2,2)*
     &  ZU(2,2)*ZUC(2,1))/Mf

       dAuQCD(i)=DCONJG(dAuCQCD(i))
       dMSUR2QCD(i)=-2*dmfQCD*Mf+dMSt2QCD(1,1)*ZU(1,2)*ZUC(1,2)+
     &  dMSt2QCD(1,2)*ZU(2,2)*ZUC(1,2)+dMSt2QCD(2,1)*ZU(1,2)*ZUC(2,2)+
     &  dMSt2QCD(2,2)*ZU(2,2)*ZUC(2,2)
       dMSQ2QCD(i)=-2*dmfQCD*Mf+dMSt2QCD(1,1)*ZU(1,1)*ZUC(1,1)+
     &  dMSt2QCD(1,2)*ZU(2,1)*ZUC(1,1)+dMSt2QCD(2,1)*ZU(1,1)*ZUC(2,1)+
     &  dMSt2QCD(2,2)*ZU(2,1)*ZUC(2,1)

       dMSttmp(1,1)=2*dmfQCD*Mf+dMSQ2QCD(i)
       dMSttmp(1,2)=dmfQCD*(-((CB*expetaS*lam*vS)/(SB*sqrt2))+AuC(i)
     &  /expeta)+(Mf*dAuCQCD(i))/expeta
       dMSttmp(2,1)=dmfQCD*(-((CB*lamC*vS)/(expetaS*SB*sqrt2))+expeta*
     &  Au(i))+expeta*Mf*dAuQCD(i)
       dMSttmp(2,2)=2*dmfQCD*Mf+dMSUR2QCD(i)

       do j=1,2
        do k=1,2
          dmc=0D0
          do gt1=1,2
            do gt2=1,2
            dmc= dmc+ ZU(j,gt1)*ZUC(k,gt2)*dMSttmp(gt1,gt2)
            enddo
          enddo
          dMSqtmp(j,k)= dmc
        enddo
       enddo
       dMStsq1QCD(2*i-1,2*i-1)=dMSqtmp(1,1)
       dMStsq1QCD(2*i-1,2*i)=dMSqtmp(1,2)
       dMStsq1QCD(2*i,2*i-1)=dMSqtmp(2,1)
       dMStsq1QCD(2*i,2*i)=dMSqtmp(2,2)

c note that the WFR constants dZStQCD are UV finite but IR dependent

       if (ischemet.eq.1)then
        MSu1L(2*i-1)=MSu(2*i-1)
        MSu1L(2*i)=MSu(2*i)    
       elseif (ischemet.eq.2)then
        Mtree2(1)=MSu(2*i-1)**2
        Mtree2(2)=MSu(2*i)**2    
        call FindStSb(2,Mtree2,Mloop2,ZSfac,1,2,i)
        MSu1L(2*i-1)=Sqrt(Mloop2(1))
        MSu1L(2*i)=Sqrt(Mloop2(2))
       elseif (ischemet.eq.3)then
        Mtree2(1)=MSu(2*i-1)**2
        Mtree2(2)=MSu(2*i)**2    
        call FindStSb(2,Mtree2,Mloop2,ZSfac,1,3,i)
        MSu1L(2*i-1)=Sqrt(Mloop2(1))
        MSu1L(2*i)=Sqrt(Mloop2(2))
       endif

c note EW DSelfStop(msu(2*i-1)**2) evaluated at tree-level mass or loop-corrected mass 
c we still obtain IR finite. One have to evaluate diagrams with photon with the same mass
c of the external line and internal line for DSelfStop, but not for SelfStop

        call DSelfStop(msu1L(2*i-1)**2,2*i-1,2*i-1,self,1,0)
        dZSt(2*i-1,2*i-1) =-self
        dZStC(2*i-1,2*i-1) =-self
        call DSelfStop(msu1L(2*i)**2,2*i,2*i,self,1,0)
        dZSt(2*i,2*i) =-self
        dZStC(2*i,2*i) =-self
c note QCD DSelfStop(msu(2*i-1)**2) evaluated at tree-level mass or loop-corrected mass
c  we  still obtain IR finite
        call DSelfStop(msu1L(2*i-1)**2,2*i-1,2*i-1,self,2,0)
        dZStQCD(2*i-1,2*i-1) =-self
        dZStQCDC(2*i-1,2*i-1) =-self
        call DSelfStop(msu1L(2*i)**2,2*i,2*i,self,2,0)
        dZStQCD(2*i,2*i) =-self
        dZStQCDC(2*i,2*i) =-self
c stop sector)
c#define details
#ifdef details

        print*,   '///////////////////////////////////////////////////////'
        print*,   'check UV, stop self energy QCD scheme, 1 OS, 3 DR',ischemet
        print*,  "top mass", mf
        print*,  "tree-level masses stop",MSu(2*i-1) ,MSu(2*i)  
        print*,  "loop-corrected stop",MSu1L(2*i-1) ,MSu1L(2*i)      
        print*,   'dmtQCD=',dmfQCD
        print*,   'dAuCQCD(i)=',dAuCQCD(i)
        print*,   'dMSUR2QCD(i)=',dMSUR2QCD(i)
        print*,   'dMSQ2QCD(i)=',dMSQ2QCD(i)
     
        print*,   '1->1, renormalized', dMSt2QCD(1,1) -dMStsq1QCD(2*i-1,2*i-1)
        print*,   '2->2, renormalized', dMSt2QCD(2,2) -dMStsq1QCD(2*i,2*i)
        print*,   '1->2, renormalized', dMSt2QCD(1,2) -dMStsq1QCD(2*i-1,2*i)
        print*,   '2->1, renormalized', dMSt2QCD(2,1) -dMStsq1QCD(2*i,2*i-1)
        print*,   "dMST2QCD(1,1)",dMST2QCD(1,1)
        print*,   "dMST2QCD(1,2)",dMST2QCD(1,2)
        print*,   "dMST2QCD(2,1)",dMST2QCD(2,1)
        print*,   "dMST2QCD(2,2)",dMST2QCD(2,2)
        print*,  'dZStQCD(1,1)=',dZStQCD(2*i-1,2*i-1)
        print*,  'dZStQCD(1,2)=',dZStQCD(2*i-1,2*i)
        print*,  'dZStQCD(2,2)=',dZStQCD(2*i,2*i)
#endif

#ifdef details
        print*,   '///////////////////////////////////////////////////////'
        print*,   'check UV, stop self energy EW, scheme, 1 OS, 3 DR',ischemet  
        print*,   'dmt=',dmf
        print*,   'dAuC(i)=',dAuC(i)
        print*,   'dMSUR2(i)=',dMSUR2(i)
        print*,   'dMSQ2(i)=',dMSQ2(i)

        print*,   '1->1, renormalized', dMSt2(1,1) -dMStsq1(2*i-1,2*i-1)
        print*,    '2->2, renormalized', dMSt2(2,2) -dMStsq1(2*i,2*i)
        print*,    '1->2, renormalized', dMSt2(1,2) -dMStsq1(2*i-1,2*i)
        print*,    '2->1, renormalized', dMSt2(2,1) -dMStsq1(2*i,2*i-1)
        print*,   "dMST2(1,1)",dMST2(1,1)
        print*,   "dMST2(1,2)",dMST2(1,2)
        print*,   "dMST2(2,1)",dMST2(2,1)
        print*,   "dMST2(2,2)",dMST2(2,2)

        print*,    'dZSt(1,1)',dZSt(2*i-1,2*i-1)
        print*,    'dZSt(1,2)',dZSt(2*i-1,2*i)

        print*,   '///////////////////////////////////////////////////////'
        print*,   "Sum of QCD+ EW correction"
        print*,   "dmt", dmf+dmfQCD
        print*,   'dAuC(i)=',dAuC(i)+dAuCQCD(i)
        print*,   'dMSUR2(i)=',dMSUR2(i)+dMSUR2QCD(i)
        print*,   'dMSQ2(i)=',dMSQ2(i)+dMSQ2QCD(i)
        print*,   "dMST2(1,1)",dMST2QCD(1,1)+dMST2(1,1)
        print*,   "dMST2(1,2)",dMST2QCD(1,2)+dMST2(1,2)
        print*,   "dMST2(2,1)",dMST2QCD(2,1)+dMST2(2,1)
        print*,   "dMST2(2,2)",dMST2QCD(2,2)+dMST2(2,2)
        print*,  'dZSt(1,1)=',dZStQCD(2*i-1,2*i-1)+dZSt(2*i-1,2*i-1)
        print*,  'dZSt(1,2)',dZSt(2*i-1,2*i)+dZStQCD(2*i-1,2*i)

#endif

c( for stbottom

       if (ischemeb.lt.3)then
       iuv=0
       else
       iuv=1
       endif

       if(abs(ZD(1,1)) > 0.5D0)then
        ib=2
       else
        ib=1
       endif
c EW correction
       call SelfSbottom(msd(2*i-1)**2,2*i-1,2*i-1,self,1,iuv)
       dMSb2(1,1)=DBLE(self)
       call SelfSbottom(msd(2*i)**2,2*i,2*i,self,1,iuv)
       dMSb2(2,2)=DBLE(self)
       call SelfSbottomReti(msd(2*i-1)**2,2*i-1,2*i,self,1,iuv)
       dMSb2(1,2)=self
       call SelfSbottomReti(msd(2*i)**2,2*i-1,2*i,self,1,iuv)
       dMSb2(1,2)=(self+dMSb2(1,2))/2D0
       dMSb2(2,1)=DCONJG(dMSb2(1,2))

       call SelfSbottom(msd(2*i-1)**2,2*i,2*i-1,self,1,iuv)
       dZSb(2*i,2*i-1)=-(self-dMSb2(2,1))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )
       call SelfSbottom(msd(2*i)**2,2*i,2*i-1,self,1,iuv)
       dZSbC(2*i,2*i-1)=(self-dMSb2(2,1))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )
       call SelfSbottom(msd(2*i-1)**2,2*i-1,2*i,self,1,iuv)
       dZSbC(2*i-1,2*i)=-(self-dMSb2(1,2))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )
       call SelfSbottom(msd(2*i)**2,2*i-1,2*i,self,1,iuv)
       dZSb(2*i-1,2*i)=(self-dMSb2(1,2))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )


       dZSb(2*i-1,2*i-1) =0D0
       dZSbC(2*i-1,2*i-1) =0D0
       dZSb(2*i,2*i) =0D0
       dZSbC(2*i,2*i) =0D0

       call Selfbottom(mfp**2,i,i,selfT,1,iuv)  
       dmfp= DBLE(mfp*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0
       dYd(i)= sqrt2*(dmfp/CB/v - mfp*dCosB1/CB**2/v- mfp*dv1/CB/v**2)

       if (ischemeb.lt.3)then
c( OS EW
       dMC=dMSQ2(i)*ZD(ib,1)*ZDC(ib,1)+dMfp*(2*Mfp*ZD(ib,1)*ZDC(ib,1)+(-
     &  ((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ad(i))*ZD(ib,2)*
     &  ZDC(ib,1)+(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+AdC(i))*
     &  ZD(ib,1)*ZDC(ib,2)+2*Mfp*ZD(ib,2)*ZDC(ib,2))+(dMZsq1*(CB**2-SB*
     &  *2)*((-3+2*SW**2)*ZD(ib,1)*ZDC(ib,1)-2*SW**2*ZD(ib,2)*ZDC(ib,2)
     &  ))/6.+(ZD(ib,2)*(+4*CB**2*expeta*expetaS*MZ2*SW*(-(CB**2*dSW1)
     &  +dSW1*SB**2)*ZDC(ib,2))+expeta*expetaS*ZD(ib,1)*(2*CB**2*MZ2*
     &  (2*CB**2*dSW1*SW+SB*(-2*dSW1*SB*SW))*ZDC(ib,1)))
     &  /(6.*CB**2*expeta*expetaS)
       d(1)=DBLE(dMSb2(ib,ib)- dMC) 
       dMC=dMSb2(1,2)-(dMSQ2(i)*ZD(1,1)*ZDC(2,1)+dMfp*(2*Mfp*ZD(1,1)*
     &  ZDC(2,1)+(-((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+
     &  Ad(i))*ZD(1,2)*ZDC(2,1)+(-((expeta*expetaS*lam*SB*vS)
     &  /(CB*sqrt2))+AdC(i))*ZD(1,1)*ZDC(2,2)+2*Mfp*ZD(1,2)*ZDC(2,2))
     &  +(dMZsq1*(CB**2-SB**2)*((-3+2*SW**2)*ZD(1,1)*ZDC(2,1)-2*SW**2
     &  *ZD(1,2)*ZDC(2,2)))/6.+(+4*CB**4*dSW1*expeta*expetaS*
     &  MZ2*SW*(ZD(1,1)*ZDC(2,1)-ZD(1,2)*ZDC(2,2))+2*CB**2*expeta*
     &  expetaS*MZ2*SB*(2*dSW1*SB*SW*(-(ZD(1,1)*ZDC(2,1))+ZD(1,2)*
     &  ZDC(2,2))))/(6.*CB**2*expeta*expetaS))
       d(2)=DBLE(dMC) 
       d(3)=DIMAG(dMC) 
c OS EW)
       else
c (DRbar EW
       d(1:3)=0D0 
c DRbar EW)
       endif
       a(1,1)=DBLE(ZD(ib,2)*ZDC(ib,2))
       a(2,1)=DBLE(Mfp*(ZD(ib,2)*ZDC(ib,1)+ZD(ib,1)*ZDC(ib,2)))
       a(3,1)=DBLE(IC*Mfp*(ZD(ib,2)*ZDC(ib,1)-ZD(ib,1)*ZDC(ib,2)))

       a(1,2)=DBLE(ZD(1,2)*ZDC(2,2))
       a(2,2)=DBLE(Mfp*(ZD(1,2)*ZDC(2,1)+ZD(1,1)*ZDC(2,2)))
       a(3,2)=DBLE(IC*Mfp*(ZD(1,2)*ZDC(2,1)-ZD(1,1)*ZDC(2,2)))

       a(1,3)=DIMAG(ZD(1,2)*ZDC(2,2))
       a(2,3)=DIMAG(Mfp*(ZD(1,2)*ZDC(2,1)+ZD(1,1)*ZDC(2,2)))
       a(3,3)=DIMAG(IC*Mfp*(ZD(1,2)*ZDC(2,1)-ZD(1,1)*ZDC(2,2)))

       call Linearequation_solver(3,a,d,root)
       dMSDR2(i) =root(1)
       dAd(i)= root(2) + IC*root(3)
       dAdC(i) =DCONJG(dAd(i))

       dMSttmp(1,1)=2*dMfp*Mfp+(2*dSW1*MZ2*(CB**2-SB**2)*SW)/3.+
     &  dMZsq1*(CB**2-SB**2)*(-0.5+SW**2/3.)+dMSQ2(i)
       dMSttmp(1,2)=+dMfp*(-((expeta*expetaS*lam*SB*vS)/(CB*
     &  sqrt2))+AdC(i))+Mfp*dAdC(i)
       dMSttmp(2,1)=+dMfp*(-((lamC*SB*vS)/(CB*expeta*
     &  expetaS*sqrt2))+Ad(i))+Mfp*dAd(i)
       dMSttmp(2,2)=2*dMfp*Mfp-(2*dSW1*MZ2*(CB**2-SB**2)*SW)/3.
     &  -(dMZsq1*(CB**2-SB**2)*SW**2)/3.+dMSDR2(i)


       do j=1,2
        do k=1,2
          dmc=0D0
          do gt1=1,2
            do gt2=1,2
            dmc= dmc+ ZD(j,gt1)*ZDC(k,gt2)*dMSttmp(gt1,gt2)
            enddo
          enddo
          dMSqtmp(j,k)= dmc
        enddo
       enddo

       dMSbsq1(2*i-1,2*i-1)=dMSqtmp(1,1)
       dMSbsq1(2*i-1,2*i)=dMSqtmp(1,2)
       dMSbsq1(2*i,2*i-1)=dMSqtmp(2,1)
       dMSbsq1(2*i,2*i)=dMSqtmp(2,2)
c EW correction )
c( QCD correction for sbottom  
       if (ischemeb.eq.1)then
       iuv=0
       else
       iuv=1
       endif
       call SelfSbottom(msd(2*i-1)**2,2*i-1,2*i-1,self,2,iuv)
       dMSb2QCD(1,1)=DBLE(self)
       call SelfSbottom(msd(2*i)**2,2*i,2*i,self,2,iuv)
       dMSb2QCD(2,2)=DBLE(self)
       call SelfSbottomReti(msd(2*i-1)**2,2*i-1,2*i,self,2,iuv)
       dMSb2QCD(1,2)=self
       call SelfSbottomReti(msd(2*i)**2,2*i-1,2*i,self,2,iuv)
       dMSb2QCD(1,2)=(self+dMSb2QCD(1,2))/2D0
       dMSb2QCD(2,1)=DCONJG(dMSb2QCD(1,2))

       call SelfSbottom(msd(2*i-1)**2,2*i,2*i-1,self,2,iuv)
       dZSbQCD(2*i,2*i-1)=-(self-dMSb2QCD(2,1))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )
       call SelfSbottom(msd(2*i)**2,2*i,2*i-1,self,2,iuv)
       dZSbQCDC(2*i,2*i-1)=(self-dMSb2QCD(2,1))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )
       call SelfSbottom(msd(2*i-1)**2,2*i-1,2*i,self,2,iuv)
       dZSbQCDC(2*i-1,2*i)=-(self-dMSb2QCD(1,2))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )
       call SelfSbottom(msd(2*i)**2,2*i-1,2*i,self,2,iuv)
       dZSbQCD(2*i-1,2*i)=(self-dMSb2QCD(1,2))*2D0/(msd(2*i-1)**2-msd(2*i)**2 )


       dZSbQCD(2*i-1,2*i-1) =0D0
       dZSbQCDC(2*i-1,2*i-1) =0D0
       dZSbQCD(2*i,2*i) =0D0
       dZSbQCDC(2*i,2*i) =0D0


       call Selfbottom(mfp**2,i,i,selfT,2,iuv)  
       dmfpQCD= DBLE(mfp*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0
       dYdQCD(i)= sqrt2*(dmfpQCD/CB/v)

c QCD correction for sbottom )
       a(1,1)=DBLE(ZD(ib,2)*ZDC(ib,2))
       a(2,1)=DBLE(Mfp*(ZD(ib,2)*ZDC(ib,1)+ZD(ib,1)*ZDC(ib,2)))
       a(3,1)=DBLE(IC*Mfp*(ZD(ib,2)*ZDC(ib,1)-ZD(ib,1)*ZDC(ib,2)))

       a(1,2)=DBLE(ZD(1,2)*ZDC(2,2))
       a(2,2)=DBLE(Mfp*(ZD(1,2)*ZDC(2,1)+ZD(1,1)*ZDC(2,2)))
       a(3,2)=DBLE(IC*Mfp*(ZD(1,2)*ZDC(2,1)-ZD(1,1)*ZDC(2,2)))

       a(1,3)=DIMAG(ZD(1,2)*ZDC(2,2))
       a(2,3)=DIMAG(Mfp*(ZD(1,2)*ZDC(2,1)+ZD(1,1)*ZDC(2,2)))
       a(3,3)=DIMAG(IC*Mfp*(ZD(1,2)*ZDC(2,1)-ZD(1,1)*ZDC(2,2)))
       if (ischemeb.eq.1 )then
c ( DR QCD stop sector 
       dMC=(2*dMfpQCD*Mfp+dMSQ2QCD(i))*ZD(ib,1)*ZDC(ib,1)+dMfpQCD*(-
     &  ((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ad(i))*ZD(ib,2)*
     &  ZDC(ib,1)+dMfpQCD*(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+
     &  AdC(i))*ZD(ib,1)*ZDC(ib,2)+2*dMfpQCD*Mfp*ZD(ib,2)*ZDC(ib,2)

       d(1)=DBLE(dMSb2QCD(ib,ib)- dMC) 

       dMC=dMSb2QCD(1,2)-
     &  ((2*dMfpQCD*Mfp+dMSQ2QCD(i))*ZD(1,1)*ZDC(2,1)+dMfpQCD*(-
     &  ((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ad(i))*ZD(1,2)*
     &  ZDC(2,1)+dMfpQCD*(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+
     &  AdC(i))*ZD(1,1)*ZDC(2,2)+2*dMfpQCD*Mfp*ZD(1,2)*ZDC(2,2))
        
       d(2)=DBLE(dMC) 
       d(3)=DIMAG(dMC) 
c DR QCD stop sector )
       call Linearequation_solver(3,a,d,root)
       dMSDR2QCD(i) =root(1)
       dAdQCD(i)= root(2) + IC*root(3)
       dAdCQCD(i) =DCONJG(dAdQCD(i))

       else
c OS QCD stop sector, DR sbottom
       dMSDR2QCD(i)=0D0
       dAdQCD(i)= 0D0
       dAdCQCD(i)=0D0
       endif

       dMSttmp(1,1)=2*dMfpQCD*Mfp+dMSQ2QCD(i)
       dMSttmp(1,2)=dMfpQCD*(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+
     &  AdC(i))+Mfp*dAdCQCD(i)
       dMSttmp(2,1)=dMfpQCD*(-((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+
     &  Ad(i))+Mfp*dAdQCD(i)
       dMSttmp(2,2)=2*dMfpQCD*Mfp+dMSDR2QCD(i)

       do j=1,2
        do k=1,2
          dmc=0D0
          do gt1=1,2
            do gt2=1,2
            dmc= dmc+ ZD(j,gt1)*ZDC(k,gt2)*dMSttmp(gt1,gt2)
            enddo
          enddo
          dMSqtmp(j,k)= dmc
        enddo
       enddo

       dMSbsq1QCD(2*i-1,2*i-1)=dMSqtmp(1,1)
       dMSbsq1QCD(2*i-1,2*i)=dMSqtmp(1,2)
       dMSbsq1QCD(2*i,2*i-1)=dMSqtmp(2,1)
       dMSbsq1QCD(2*i,2*i)=dMSqtmp(2,2)

c QCD sbottom)

        Mtree2(1)=MSd(2*i-1)**2
        Mtree2(2)=MSd(2*i)**2
        call FindStSb(2,Mtree2,Mloop2,ZSfac,2,3,i)
        MSd1L(2*i-1)=Sqrt(Mloop2(1))
        MSd1L(2*i)=Sqrt(Mloop2(2))
        call DSelfSbottom(msd1L(2*i-1)**2,2*i-1,2*i-1,self,2,0)
        dZSbQCD(2*i-1,2*i-1) =-self
        dZSbQCDC(2*i-1,2*i-1) =-self
        call DSelfSbottom(msd1L(2*i)**2,2*i,2*i,self,2,0)
        dZSbQCD(2*i,2*i) =-self
        dZSbQCDC(2*i,2*i) =-self

        call DSelfSbottom(msd1L(2*i-1)**2,2*i-1,2*i-1,self,1,0)
        dZSb(2*i-1,2*i-1) =-self
        dZSbC(2*i-1,2*i-1) =-self
        call DSelfSbottom(msd1L(2*i)**2,2*i,2*i,self,1,0)
        dZSb(2*i,2*i) =-self
        dZSbC(2*i,2*i) =-self

#ifdef details
        print*,   '///////////////////////////////////////////////////////'
        print*,   'check UV, sbottom self energy EW, scheme, 1 OS, 3 DR',ischemeb  
        print*,   'tree-level sbottom masses',MSd(2*i-1),MSd(2*i) 
        print*,   'one-loop sbottom masses',MSd1L(2*i-1),MSd1L(2*i)
        print*,   "dmb", dmfp
        print*,   "dAd(i)", dAd(i)
        print*,   "dMSDR2(i)",dMSDR2(i) 
                print*,   "g3", g3, g3**2/4D0/pi
        print*,   '1->1, renormalized', dMSb2(1,1) -dMSbsq1(2*i-1,2*i-1)
        print*,    '2->2, renormalized', dMSb2(2,2) -dMSbsq1(2*i,2*i)
        print*,    '1->2, renormalized', dMSb2(1,2) -dMSbsq1(2*i-1,2*i)
        print*,    '2->1, renormalized', dMSb2(2,1) -dMSbsq1(2*i,2*i-1)

        print*,    'dZSb(1,1)',dZSb(2*i-1,2*i-1)
        print*,    'dZSb(1,2)',dZSb(2*i-1,2*i)
        print*,    'dZSb(2,2)',dZSb(2*i,2*i)

        print*,   '///////////////////////////////////////////////////////'
        print*,   'check UV, sbottom self energy QCD, scheme, 1 OS, 3 DR',ischemeb 
        print*,   "dmbQCD", dmfpQCD
        print*,   "dAdQCD(i)", dAdQCD(i)
        print*,   "dMSDR2QCD(i)",dMSDR2QCD(i) 
        print*,   '1->1, renormalized', dMSb2QCD(1,1) -dMSbsq1QCD(2*i-1,2*i-1)
        print*,    '2->2, renormalized', dMSb2QCD(2,2) -dMSbsq1QCD(2*i,2*i)
        print*,    '1->2, renormalized', dMSb2QCD(1,2) -dMSbsq1QCD(2*i-1,2*i)
        print*,    '2->1, renormalized', dMSb2QCD(2,1) -dMSbsq1QCD(2*i,2*i-1)
        print*,    'dZSbQCD(1,1)=',dZSbQCD(2*i-1,2*i-1)
        print*,    'dZSbQCD(1,2)=',dZSbQCD(2*i-1,2*i)
        print*,    'dZSbQCD(2,2)=',dZSbQCD(2*i,2*i)

        print*,   '///////////////////////////////////////////////////////'
        print*,   'Sum of QCD+ EW correction for sbottom'
        print*,   "dmb", dmfp+dmfpQCD
        print*,   "dAd(i)", dAd(i)+dAdQCD(i)
        print*,   "dMSDR2(i)",dMSDR2(i)+dMSDR2QCD(i)
        print*,    'dZSb(1,1)',dZSb(2*i-1,2*i-1)+dZSbQCD(2*i-1,2*i-1)
        print*,    'dZSb(1,2)',dZSb(2*i-1,2*i)+dZSbQCD(2*i-1,2*i)
        print*,    'dZSb(2,2)',dZSb(2*i,2*i)+dZSbQCD(2*i,2*i)
       print*, "stop,sbottom tree-level mass", MSUT(5:6),MSDT(5:6)
       print*, "stop,sbottom loop-corrected mass", MSU1L(5:6),MSD1L(5:6)


#endif
c coupling counterterm

       dMUE=0D0
       dMUEC=DCONJG(dMUE)
       dg1= (e*dZe1/CW - e*dCW1/CW**2)
       dg2= (e*dZe1/SW - e*dSW1/SW**2)

       MUE=lam*vS*expetas/sqrt2
       MUEC=DCONJG(MUE)

       do gt1=1,6
        do gt2=1,6
          do gt3=1,6
       dChSupSum(gt2,gt3,gt1)=(dYu(1)*(DCONJG(ZUN(gt2,2))*(vS*(CB*
     &  expeta*MUE-SB*AuC(1))*ZH(gt1,1)-vS*(expeta*MUE*SB+CB*AuC(1))*
     &  ZH(gt1,2)-CB*expeta*MUE*v*ZH(gt1,3)+expeta*IC*MUE*vS*
     &  ZH(gt1,4)-IC*vS*AuC(1)*ZH(gt1,5)+CB*expeta*IC*MUE*v*
     &  ZH(gt1,6))*ZUN(gt3,1)+expeta*DCONJG(ZUN(gt2,1))*((-(CB*MUEC*
     &  vS)+expeta*SB*vS*Au(1))*ZH(gt1,1)+vS*(MUEC*SB+CB*expeta*Au(1))
     &  *ZH(gt1,2)+CB*MUEC*v*ZH(gt1,3)+IC*MUEC*vS*ZH(gt1,4)-expeta*
     &  IC*vS*Au(1)*ZH(gt1,5)+CB*IC*MUEC*v*ZH(gt1,6))*ZUN(gt3,2)))
     &  /(expeta*sqrt2*vS)+Yu(1)**2*(-(dv1*IC*SB*ZH(gt1,5)*
     &  (DCONJG(ZUN(gt2,1))*ZUN(gt3,1)+DCONJG(ZUN(gt2,2))*ZUN(gt3,2))))
     &  +Yu(1)*((expeta*dAu(1)*
     &  DCONJG(ZUN(gt2,1))*(SB*ZH(gt1,1)+CB*ZH(gt1,2)-IC*ZH(gt1,5))*
     &  ZUN(gt3,2))/sqrt2-2*IC*SB*v*dYu(1)*ZH(gt1,5)*
     &  (DCONJG(ZUN(gt2,1))*ZUN(gt3,1)+DCONJG(ZUN(gt2,2))*ZUN(gt3,2))
     &  +(DCONJG(ZUN(gt2,2))*(vS**2*(-SB*dAuC(1))
     &  *ZH(gt1,1)-vS**2*(+CB*dAuC(1))
     &  *ZH(gt1,2)-CB*dv1*expeta*MUE*vS*ZH(gt1,3)-IC*vS**2*dAuC(1)*
     &  ZH(gt1,5)+CB*dv1*expeta*IC*MUE*vS*ZH(gt1,6))*ZUN(gt3,1)+
     &  expeta*DCONJG(ZUN(gt2,1))*(+CB*dv1*MUEC*vS*ZH(gt1,3)+CB*
     &  dv1*IC*MUEC*vS*ZH(gt1,6))*ZUN(gt3,2))/(expeta*sqrt2*vS**2))+(dYu(2)*
     &  (DCONJG(ZUN(gt2,4))*(vS*(CB*expeta*MUE-SB*AuC(2))*ZH(gt1,1)-
     &  vS*(expeta*MUE*SB+CB*AuC(2))*ZH(gt1,2)-CB*expeta*MUE*v*
     &  ZH(gt1,3)+expeta*IC*MUE*vS*ZH(gt1,4)-IC*vS*AuC(2)*ZH(gt1,5)+
     &  CB*expeta*IC*MUE*v*ZH(gt1,6))*ZUN(gt3,3)+expeta*
     &  DCONJG(ZUN(gt2,3))*((-(CB*MUEC*vS)+expeta*SB*vS*Au(2))*
     &  ZH(gt1,1)+vS*(MUEC*SB+CB*expeta*Au(2))*ZH(gt1,2)+CB*MUEC*v*
     &  ZH(gt1,3)+IC*MUEC*vS*ZH(gt1,4)-expeta*IC*vS*Au(2)*ZH(gt1,5)+
     &  CB*IC*MUEC*v*ZH(gt1,6))*ZUN(gt3,4)))/(expeta*sqrt2*vS)+Yu(2)**
     &  2*(-(dv1*IC*SB*ZH(gt1,5)*(DCONJG(ZUN(gt2,3))*ZUN(gt3,3)+
     &  DCONJG(ZUN(gt2,4))*ZUN(gt3,4))))+
     &  Yu(2)*((expeta*dAu(2)*DCONJG(ZUN(gt2,3))*(SB*ZH(gt1,1)+CB*
     &  ZH(gt1,2)-IC*ZH(gt1,5))*ZUN(gt3,4))/sqrt2-2*IC*SB*v*dYu(2)*
     &  ZH(gt1,5)*(DCONJG(ZUN(gt2,3))*ZUN(gt3,3)+DCONJG(ZUN(gt2,4))*
     &  ZUN(gt3,4))+(DCONJG(ZUN(gt2,4))*(vS**2*
     &  (-SB*dAuC(2))*ZH(gt1,1)-vS**2*(+
     &  CB*dAuC(2))*ZH(gt1,2)-CB*dv1*expeta*MUE*vS*ZH(gt1,3)-IC*vS**2
     &  *dAuC(2)*ZH(gt1,5)+CB*dv1*expeta*IC*MUE*vS*ZH(gt1,6))*ZUN(gt3,3)
     &  +expeta*DCONJG(ZUN(gt2,3))*(+CB*dv1*MUEC*vS*ZH(gt1,3)+CB*
     &  dv1*IC*MUEC*vS*ZH(gt1,6))*ZUN(gt3,4))/(expeta*sqrt2*vS**2))
     &  +(IC*(CB*ZH(gt1,4)-SB*
     &  ZH(gt1,5))*((dv1*g1**2-3*dv1*g2**2+2*dg1*g1*v-6*dg2*g2*v)*
     &  DCONJG(ZUN(gt2,1))*ZUN(gt3,1)-4*g1*(dv1*g1+2*dg1*v)*
     &  DCONJG(ZUN(gt2,2))*ZUN(gt3,2)+dv1*g1**2*DCONJG(ZUN(gt2,3))*
     &  ZUN(gt3,3)-3*dv1*g2**2*DCONJG(ZUN(gt2,3))*ZUN(gt3,3)+2*dg1*g1*
     &  v*DCONJG(ZUN(gt2,3))*ZUN(gt3,3)-6*dg2*g2*v*DCONJG(ZUN(gt2,3))*
     &  ZUN(gt3,3)-4*dv1*g1**2*DCONJG(ZUN(gt2,4))*ZUN(gt3,4)-8*dg1*g1*
     &  v*DCONJG(ZUN(gt2,4))*ZUN(gt3,4)+dv1*g1**2*DCONJG(ZUN(gt2,5))*
     &  ZUN(gt3,5)-3*dv1*g2**2*DCONJG(ZUN(gt2,5))*ZUN(gt3,5)+2*dg1*g1*
     &  v*DCONJG(ZUN(gt2,5))*ZUN(gt3,5)-6*dg2*g2*v*DCONJG(ZUN(gt2,5))*
     &  ZUN(gt3,5)-4*dv1*g1**2*DCONJG(ZUN(gt2,6))*ZUN(gt3,6)-8*dg1*g1*
     &  v*DCONJG(ZUN(gt2,6))*ZUN(gt3,6)))/12.+(dYu(3)*
     &  (DCONJG(ZUN(gt2,6))*(vS*(CB*expeta*MUE-SB*AuC(3))*ZH(gt1,1)-
     &  vS*(expeta*MUE*SB+CB*AuC(3))*ZH(gt1,2)-CB*expeta*MUE*v*
     &  ZH(gt1,3)+expeta*IC*MUE*vS*ZH(gt1,4)-IC*vS*AuC(3)*ZH(gt1,5)+
     &  CB*expeta*IC*MUE*v*ZH(gt1,6))*ZUN(gt3,5)+expeta*
     &  DCONJG(ZUN(gt2,5))*((-(CB*MUEC*vS)+expeta*SB*vS*Au(3))*
     &  ZH(gt1,1)+vS*(MUEC*SB+CB*expeta*Au(3))*ZH(gt1,2)+CB*MUEC*v*
     &  ZH(gt1,3)+IC*MUEC*vS*ZH(gt1,4)-expeta*IC*vS*Au(3)*ZH(gt1,5)+
     &  CB*IC*MUEC*v*ZH(gt1,6))*ZUN(gt3,6)))/(expeta*sqrt2*vS)+Yu(3)**
     &  2*(-(dv1*IC*SB*ZH(gt1,5)*(DCONJG(ZUN(gt2,5))*ZUN(gt3,5)+
     &  DCONJG(ZUN(gt2,6))*ZUN(gt3,6))))+
     &  Yu(3)*((expeta*dAu(3)*DCONJG(ZUN(gt2,5))*(SB*ZH(gt1,1)+CB*
     &  ZH(gt1,2)-IC*ZH(gt1,5))*ZUN(gt3,6))/sqrt2-2*IC*SB*v*dYu(3)*
     &  ZH(gt1,5)*(DCONJG(ZUN(gt2,5))*ZUN(gt3,5)+DCONJG(ZUN(gt2,6))*
     &  ZUN(gt3,6))+(DCONJG(ZUN(gt2,6))*(vS**2*
     &  (-SB*dAuC(3))*ZH(gt1,1)-vS**2*(+CB*dAuC(3))*ZH(gt1,2)-CB*dv1*
     &  expeta*MUE*vS*ZH(gt1,3)-IC*vS**2*dAuC(3)*ZH(gt1,5)+CB*dv1*expeta
     &  *IC*MUE*vS*ZH(gt1,6))*ZUN(gt3,5)+expeta*
     &  DCONJG(ZUN(gt2,5))*(+CB*dv1*MUEC*vS*ZH(gt1,3)+CB*dv1*
     &  IC*MUEC*vS*ZH(gt1,6))*ZUN(gt3,6))/(expeta*sqrt2*vS**2))

      dChSdmSdp(gt2,gt3,gt1)=(dCosB1*IC*v*(DCONJG(ZDN(gt2,1))*(g1**2+
     &  3*(g2**2-4*Yd(1)**2))*ZDN(gt3,1)+2*DCONJG(ZDN(gt2,2))*(g1**2-6*
     &  Yd(1)**2)*ZDN(gt3,2)+g1**2*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)+3*g2**
     &  2*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)-12*DCONJG(ZDN(gt2,3))*Yd(2)**2*
     &  ZDN(gt3,3)+2*g1**2*DCONJG(ZDN(gt2,4))*ZDN(gt3,4)-12*
     &  DCONJG(ZDN(gt2,4))*Yd(2)**2*ZDN(gt3,4)+g1**2*DCONJG(ZDN(gt2,5))
     &  *ZDN(gt3,5)+3*g2**2*DCONJG(ZDN(gt2,5))*ZDN(gt3,5)-12*
     &  DCONJG(ZDN(gt2,5))*Yd(3)**2*ZDN(gt3,5)+2*g1**2*
     &  DCONJG(ZDN(gt2,6))*ZDN(gt3,6)-12*DCONJG(ZDN(gt2,6))*Yd(3)**2*
     &  ZDN(gt3,6))*ZH(gt1,4))/12.-(dSinB1*v*(6*expeta**2*MUE*sqrt2*
     &  DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*ZH(gt1,3)-6*MUEC*sqrt2*
     &  DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*ZH(gt1,3)+6*expeta**2*MUE*
     &  sqrt2*DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*ZH(gt1,3)-6*MUEC*
     &  sqrt2*DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*ZH(gt1,3)+expeta*g1*
     &  *2*IC*vS*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)*ZH(gt1,5)+3*expeta*g2**
     &  2*IC*vS*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)*ZH(gt1,5)+2*expeta*g1**
     &  2*IC*vS*DCONJG(ZDN(gt2,4))*ZDN(gt3,4)*ZH(gt1,5)+expeta*g1**2*
     &  IC*vS*DCONJG(ZDN(gt2,5))*ZDN(gt3,5)*ZH(gt1,5)+3*expeta*g2**2*
     &  IC*vS*DCONJG(ZDN(gt2,5))*ZDN(gt3,5)*ZH(gt1,5)+2*expeta*g1**2*
     &  IC*vS*DCONJG(ZDN(gt2,6))*ZDN(gt3,6)*ZH(gt1,5)-6*expeta**2*IC*
     &  MUE*sqrt2*DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*ZH(gt1,6)-6*IC*
     &  MUEC*sqrt2*DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*ZH(gt1,6)-6*
     &  expeta**2*IC*MUE*sqrt2*DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*
     &  ZH(gt1,6)-6*IC*MUEC*sqrt2*DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*
     &  ZH(gt1,6)+2*expeta*DCONJG(ZDN(gt2,2))*(g1**2*IC*vS*ZDN(gt3,2)*
     &  ZH(gt1,5)+3*expeta*MUE*sqrt2*Yd(1)*ZDN(gt3,1)*(ZH(gt1,3)-IC*
     &  ZH(gt1,6)))+DCONJG(ZDN(gt2,1))*(expeta*(g1**2+3*g2**2)*IC*vS*
     &  ZDN(gt3,1)*ZH(gt1,5)-6*MUEC*sqrt2*Yd(1)*ZDN(gt3,2)*(ZH(gt1,3)
     &  +IC*ZH(gt1,6)))))/(12.*expeta*vS)+(6*sqrt2*dAdC(1)*
     &  DCONJG(ZDN(gt2,2))*Yd(1)*ZDN(gt3,1)*(CB*ZH(gt1,1)-SB*
     &  ZH(gt1,2)-IC*ZH(gt1,4))+6*sqrt2*dAdC(2)*DCONJG(ZDN(gt2,4))*
     &  Yd(2)*ZDN(gt3,3)*(CB*ZH(gt1,1)-SB*ZH(gt1,2)-IC*ZH(gt1,4))+6*
     &  sqrt2*dAdC(3)*DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*(CB*
     &  ZH(gt1,1)-SB*ZH(gt1,2)-IC*ZH(gt1,4))-6*sqrt2*dAd(1)*
     &  DCONJG(ZDN(gt2,1))*Yd(1)*ZDN(gt3,2)*(CB*ZH(gt1,1)-SB*
     &  ZH(gt1,2)+IC*ZH(gt1,4))-6*sqrt2*dAd(2)*DCONJG(ZDN(gt2,3))*
     &  Yd(2)*ZDN(gt3,4)*(CB*ZH(gt1,1)-SB*ZH(gt1,2)+IC*ZH(gt1,4))-6*
     &  sqrt2*dAd(3)*DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*(CB*ZH(gt1,1)
     &  -SB*ZH(gt1,2)+IC*ZH(gt1,4))+6*dg2*g2*IC*v*(DCONJG(ZDN(gt2,1))
     &  *ZDN(gt3,1)+DCONJG(ZDN(gt2,3))*ZDN(gt3,3)+DCONJG(ZDN(gt2,5))*
     &  ZDN(gt3,5))*(CB*ZH(gt1,4)-SB*ZH(gt1,5))+2*dg1*g1*IC*v*
     &  (DCONJG(ZDN(gt2,1))*ZDN(gt3,1)+2*DCONJG(ZDN(gt2,2))*ZDN(gt3,2)+
     &  DCONJG(ZDN(gt2,3))*ZDN(gt3,3)+2*DCONJG(ZDN(gt2,4))*ZDN(gt3,4)+
     &  DCONJG(ZDN(gt2,5))*ZDN(gt3,5)+2*DCONJG(ZDN(gt2,6))*ZDN(gt3,6))*
     &  (CB*ZH(gt1,4)-SB*ZH(gt1,5))-(6*dMUE*expeta*sqrt2*
     &  (DCONJG(ZDN(gt2,2))*Yd(1)*ZDN(gt3,1)+DCONJG(ZDN(gt2,4))*Yd(2)*
     &  ZDN(gt3,3)+DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5))*(SB*vS*
     &  ZH(gt1,1)+CB*vS*ZH(gt1,2)+SB*v*ZH(gt1,3)-IC*vS*ZH(gt1,5)-
     &  IC*SB*v*ZH(gt1,6)))/vS+(6*dMUEC*sqrt2*(DCONJG(ZDN(gt2,1))*
     &  Yd(1)*ZDN(gt3,2)+DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)+
     &  DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6))*(SB*vS*ZH(gt1,1)+CB*vS*
     &  ZH(gt1,2)+SB*v*ZH(gt1,3)+IC*vS*ZH(gt1,5)+IC*SB*v*ZH(gt1,6))
     &  )/(expeta*vS)+(6*dvS1*SB*sqrt2*v*(expeta**2*MUE*
     &  DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*ZH(gt1,3)-MUEC*
     &  DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*ZH(gt1,3)+expeta**2*MUE*
     &  DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*ZH(gt1,3)-MUEC*
     &  DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*ZH(gt1,3)-expeta**2*IC*
     &  MUE*DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*ZH(gt1,6)-IC*MUEC*
     &  DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*ZH(gt1,6)-expeta**2*IC*
     &  MUE*DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*ZH(gt1,6)-IC*MUEC*
     &  DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*ZH(gt1,6)+expeta**2*MUE*
     &  DCONJG(ZDN(gt2,2))*Yd(1)*ZDN(gt3,1)*(ZH(gt1,3)-IC*ZH(gt1,6))-
     &  MUEC*DCONJG(ZDN(gt2,1))*Yd(1)*ZDN(gt3,2)*(ZH(gt1,3)+IC*
     &  ZH(gt1,6))))/(expeta*vS**2)+(dv1*(-6*expeta**2*MUE*SB*sqrt2*
     &  DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*ZH(gt1,3)+6*MUEC*SB*sqrt2*
     &  DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*ZH(gt1,3)-6*expeta**2*MUE*
     &  SB*sqrt2*DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*ZH(gt1,3)+6*MUEC*
     &  SB*sqrt2*DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*ZH(gt1,3)+CB*
     &  expeta*g1**2*IC*vS*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)*ZH(gt1,4)+3*
     &  CB*expeta*g2**2*IC*vS*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)*ZH(gt1,4)-
     &  12*CB*expeta*IC*vS*DCONJG(ZDN(gt2,3))*Yd(2)**2*ZDN(gt3,3)*
     &  ZH(gt1,4)+2*CB*expeta*g1**2*IC*vS*DCONJG(ZDN(gt2,4))*
     &  ZDN(gt3,4)*ZH(gt1,4)-12*CB*expeta*IC*vS*DCONJG(ZDN(gt2,4))*
     &  Yd(2)**2*ZDN(gt3,4)*ZH(gt1,4)+CB*expeta*g1**2*IC*vS*
     &  DCONJG(ZDN(gt2,5))*ZDN(gt3,5)*ZH(gt1,4)+3*CB*expeta*g2**2*IC*
     &  vS*DCONJG(ZDN(gt2,5))*ZDN(gt3,5)*ZH(gt1,4)-12*CB*expeta*IC*vS*
     &  DCONJG(ZDN(gt2,5))*Yd(3)**2*ZDN(gt3,5)*ZH(gt1,4)+2*CB*expeta*
     &  g1**2*IC*vS*DCONJG(ZDN(gt2,6))*ZDN(gt3,6)*ZH(gt1,4)-12*CB*
     &  expeta*IC*vS*DCONJG(ZDN(gt2,6))*Yd(3)**2*ZDN(gt3,6)*ZH(gt1,4)-
     &  expeta*g1**2*IC*SB*vS*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)*ZH(gt1,5)-
     &  3*expeta*g2**2*IC*SB*vS*DCONJG(ZDN(gt2,3))*ZDN(gt3,3)*
     &  ZH(gt1,5)-2*expeta*g1**2*IC*SB*vS*DCONJG(ZDN(gt2,4))*
     &  ZDN(gt3,4)*ZH(gt1,5)-expeta*g1**2*IC*SB*vS*DCONJG(ZDN(gt2,5))*
     &  ZDN(gt3,5)*ZH(gt1,5)-3*expeta*g2**2*IC*SB*vS*DCONJG(ZDN(gt2,5)
     &  )*ZDN(gt3,5)*ZH(gt1,5)-2*expeta*g1**2*IC*SB*vS*
     &  DCONJG(ZDN(gt2,6))*ZDN(gt3,6)*ZH(gt1,5)+6*expeta**2*IC*MUE*SB*
     &  sqrt2*DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*ZH(gt1,6)+6*IC*MUEC*
     &  SB*sqrt2*DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*ZH(gt1,6)+6*
     &  expeta**2*IC*MUE*SB*sqrt2*DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*
     &  ZH(gt1,6)+6*IC*MUEC*SB*sqrt2*DCONJG(ZDN(gt2,5))*Yd(3)*
     &  ZDN(gt3,6)*ZH(gt1,6)-2*expeta*DCONJG(ZDN(gt2,2))*(-(IC*vS*
     &  ZDN(gt3,2)*(CB*(g1**2-6*Yd(1)**2)*ZH(gt1,4)-g1**2*SB*
     &  ZH(gt1,5)))+3*expeta*MUE*SB*sqrt2*Yd(1)*ZDN(gt3,1)*(ZH(gt1,3)
     &  -IC*ZH(gt1,6)))+DCONJG(ZDN(gt2,1))*(expeta*IC*vS*ZDN(gt3,1)*
     &  (CB*(g1**2+3*g2**2-12*Yd(1)**2)*ZH(gt1,4)-(g1**2+3*g2**2)*SB*
     &  ZH(gt1,5))+6*MUEC*SB*sqrt2*Yd(1)*ZDN(gt3,2)*(ZH(gt1,3)+IC*
     &  ZH(gt1,6)))))/(expeta*vS)+(6*dYd(1)*(-(expeta*
     &  DCONJG(ZDN(gt2,2))*(4*CB*IC*v*vS*Yd(1)*ZDN(gt3,2)*ZH(gt1,4)+
     &  sqrt2*ZDN(gt3,1)*(vS*(expeta*MUE*SB-CB*AdC(1))*ZH(gt1,1)+vS*
     &  (CB*expeta*MUE+SB*AdC(1))*ZH(gt1,2)+expeta*MUE*SB*v*ZH(gt1,3)
     &  +IC*vS*AdC(1)*ZH(gt1,4)-expeta*IC*MUE*vS*ZH(gt1,5)-expeta*IC*
     &  MUE*SB*v*ZH(gt1,6))))+DCONJG(ZDN(gt2,1))*(-4*CB*expeta*IC*v*
     &  vS*Yd(1)*ZDN(gt3,1)*ZH(gt1,4)+sqrt2*ZDN(gt3,2)*(vS*(MUEC*SB-
     &  CB*expeta*Ad(1))*ZH(gt1,1)+vS*(CB*MUEC+expeta*SB*Ad(1))*
     &  ZH(gt1,2)+MUEC*SB*v*ZH(gt1,3)-expeta*IC*vS*Ad(1)*ZH(gt1,4)+
     &  IC*MUEC*vS*ZH(gt1,5)+IC*MUEC*SB*v*ZH(gt1,6)))))/(expeta*vS)+
     &  (6*dYd(2)*(-(expeta*DCONJG(ZDN(gt2,4))*(4*CB*IC*v*vS*Yd(2)*
     &  ZDN(gt3,4)*ZH(gt1,4)+sqrt2*ZDN(gt3,3)*(vS*(expeta*MUE*SB-CB*
     &  AdC(2))*ZH(gt1,1)+vS*(CB*expeta*MUE+SB*AdC(2))*ZH(gt1,2)+
     &  expeta*MUE*SB*v*ZH(gt1,3)+IC*vS*AdC(2)*ZH(gt1,4)-expeta*IC*
     &  MUE*vS*ZH(gt1,5)-expeta*IC*MUE*SB*v*ZH(gt1,6))))+
     &  DCONJG(ZDN(gt2,3))*(-4*CB*expeta*IC*v*vS*Yd(2)*ZDN(gt3,3)*
     &  ZH(gt1,4)+sqrt2*ZDN(gt3,4)*(vS*(MUEC*SB-CB*expeta*Ad(2))*
     &  ZH(gt1,1)+vS*(CB*MUEC+expeta*SB*Ad(2))*ZH(gt1,2)+MUEC*SB*v*
     &  ZH(gt1,3)-expeta*IC*vS*Ad(2)*ZH(gt1,4)+IC*MUEC*vS*ZH(gt1,5)+
     &  IC*MUEC*SB*v*ZH(gt1,6)))))/(expeta*vS)+(6*dYd(3)*(-(expeta*
     &  DCONJG(ZDN(gt2,6))*(4*CB*IC*v*vS*Yd(3)*ZDN(gt3,6)*ZH(gt1,4)+
     &  sqrt2*ZDN(gt3,5)*(vS*(expeta*MUE*SB-CB*AdC(3))*ZH(gt1,1)+vS*
     &  (CB*expeta*MUE+SB*AdC(3))*ZH(gt1,2)+expeta*MUE*SB*v*ZH(gt1,3)
     &  +IC*vS*AdC(3)*ZH(gt1,4)-expeta*IC*MUE*vS*ZH(gt1,5)-expeta*IC*
     &  MUE*SB*v*ZH(gt1,6))))+DCONJG(ZDN(gt2,5))*(-4*CB*expeta*IC*v*
     &  vS*Yd(3)*ZDN(gt3,5)*ZH(gt1,4)+sqrt2*ZDN(gt3,6)*(vS*(MUEC*SB-
     &  CB*expeta*Ad(3))*ZH(gt1,1)+vS*(CB*MUEC+expeta*SB*Ad(3))*
     &  ZH(gt1,2)+MUEC*SB*v*ZH(gt1,3)-expeta*IC*vS*Ad(3)*ZH(gt1,4)+
     &  IC*MUEC*vS*ZH(gt1,5)+IC*MUEC*SB*v*ZH(gt1,6)))))/(expeta*vS))/12.

       dChSupSumQCD(gt2,gt3,gt1)=(dYuQCD(1)*(expetas*DCONJG(ZUN(gt2,2))*
     &  ((CB*expeta*expetas*lam*vS-SB*sqrt2*AuC(1))*ZH(gt1,1)-(expeta*
     &  expetas*lam*SB*vS+CB*sqrt2*AuC(1))*ZH(gt1,2)-CB*expeta*
     &  expetas*lam*v*ZH(gt1,3)+expeta*expetas*IC*lam*vS*ZH(gt1,4)-
     &  IC*sqrt2*AuC(1)*ZH(gt1,5)+CB*expeta*expetas*IC*lam*v*
     &  ZH(gt1,6))*ZUN(gt3,1)+expeta*DCONJG(ZUN(gt2,1))*((-(CB*lamC*
     &  vS)+expeta*expetas*SB*sqrt2*Au(1))*ZH(gt1,1)+(lamC*SB*vS+CB*
     &  expeta*expetas*sqrt2*Au(1))*ZH(gt1,2)+CB*lamC*v*ZH(gt1,3)+IC*
     &  lamC*vS*ZH(gt1,4)-expeta*expetas*IC*sqrt2*Au(1)*ZH(gt1,5)+CB*
     &  IC*lamC*v*ZH(gt1,6))*ZUN(gt3,2)))/(2.*expeta*expetas)+Yu(1)*
     &  ((DCONJG(ZUN(gt2,2))*(-(SB*sqrt2*dAuCQCD(1)*ZH(gt1,1))-CB*
     &  sqrt2*dAuCQCD(1)*ZH(gt1,2)-IC*sqrt2*dAuCQCD(1)*ZH(gt1,5))*
     &  ZUN(gt3,1))/(2.*expeta)+(expeta*dAuQCD(1)*DCONJG(ZUN(gt2,1))*
     &  (SB*ZH(gt1,1)+CB*ZH(gt1,2)-IC*ZH(gt1,5))*ZUN(gt3,2))/sqrt2-
     &  2*IC*SB*v*dYuQCD(1)*ZH(gt1,5)*(DCONJG(ZUN(gt2,1))*ZUN(gt3,1)+
     &  DCONJG(ZUN(gt2,2))*ZUN(gt3,2)))+(dYuQCD(2)*(expetas*
     &  DCONJG(ZUN(gt2,4))*((CB*expeta*expetas*lam*vS-SB*sqrt2*AuC(2))*
     &  ZH(gt1,1)-(expeta*expetas*lam*SB*vS+CB*sqrt2*AuC(2))*
     &  ZH(gt1,2)-CB*expeta*expetas*lam*v*ZH(gt1,3)+expeta*expetas*
     &  IC*lam*vS*ZH(gt1,4)-IC*sqrt2*AuC(2)*ZH(gt1,5)+CB*expeta*
     &  expetas*IC*lam*v*ZH(gt1,6))*ZUN(gt3,3)+expeta*
     &  DCONJG(ZUN(gt2,3))*((-(CB*lamC*vS)+expeta*expetas*SB*sqrt2*
     &  Au(2))*ZH(gt1,1)+(lamC*SB*vS+CB*expeta*expetas*sqrt2*Au(2))*
     &  ZH(gt1,2)+CB*lamC*v*ZH(gt1,3)+IC*lamC*vS*ZH(gt1,4)-expeta*
     &  expetas*IC*sqrt2*Au(2)*ZH(gt1,5)+CB*IC*lamC*v*ZH(gt1,6))*
     &  ZUN(gt3,4)))/(2.*expeta*expetas)+Yu(2)*((DCONJG(ZUN(gt2,4))*(-
     &  (SB*sqrt2*dAuCQCD(2)*ZH(gt1,1))-CB*sqrt2*dAuCQCD(2)*ZH(gt1,2)
     &  -IC*sqrt2*dAuCQCD(2)*ZH(gt1,5))*ZUN(gt3,3))/(2.*expeta)+
     &  (expeta*dAuQCD(2)*DCONJG(ZUN(gt2,3))*(SB*ZH(gt1,1)+CB*
     &  ZH(gt1,2)-IC*ZH(gt1,5))*ZUN(gt3,4))/sqrt2-2*IC*SB*v*dYuQCD(2)
     &  *ZH(gt1,5)*(DCONJG(ZUN(gt2,3))*ZUN(gt3,3)+DCONJG(ZUN(gt2,4))*
     &  ZUN(gt3,4)))+(dYuQCD(3)*(expetas*DCONJG(ZUN(gt2,6))*((CB*
     &  expeta*expetas*lam*vS-SB*sqrt2*AuC(3))*ZH(gt1,1)-(expeta*
     &  expetas*lam*SB*vS+CB*sqrt2*AuC(3))*ZH(gt1,2)-CB*expeta*
     &  expetas*lam*v*ZH(gt1,3)+expeta*expetas*IC*lam*vS*ZH(gt1,4)-
     &  IC*sqrt2*AuC(3)*ZH(gt1,5)+CB*expeta*expetas*IC*lam*v*
     &  ZH(gt1,6))*ZUN(gt3,5)+expeta*DCONJG(ZUN(gt2,5))*((-(CB*lamC*
     &  vS)+expeta*expetas*SB*sqrt2*Au(3))*ZH(gt1,1)+(lamC*SB*vS+CB*
     &  expeta*expetas*sqrt2*Au(3))*ZH(gt1,2)+CB*lamC*v*ZH(gt1,3)+IC*
     &  lamC*vS*ZH(gt1,4)-expeta*expetas*IC*sqrt2*Au(3)*ZH(gt1,5)+CB*
     &  IC*lamC*v*ZH(gt1,6))*ZUN(gt3,6)))/(2.*expeta*expetas)+Yu(3)*
     &  ((DCONJG(ZUN(gt2,6))*(-(SB*sqrt2*dAuCQCD(3)*ZH(gt1,1))-CB*
     &  sqrt2*dAuCQCD(3)*ZH(gt1,2)-IC*sqrt2*dAuCQCD(3)*ZH(gt1,5))*
     &  ZUN(gt3,5))/(2.*expeta)+(expeta*dAuQCD(3)*DCONJG(ZUN(gt2,5))*
     &  (SB*ZH(gt1,1)+CB*ZH(gt1,2)-IC*ZH(gt1,5))*ZUN(gt3,6))/sqrt2-
     &  2*IC*SB*v*dYuQCD(3)*ZH(gt1,5)*(DCONJG(ZUN(gt2,5))*ZUN(gt3,5)+
     &  DCONJG(ZUN(gt2,6))*ZUN(gt3,6)))

       dChSdmSdpQCD(gt2,gt3,gt1)=(6*sqrt2*dAdCQCD(1)*DCONJG(ZDN(gt2,2))*
     &  Yd(1)*ZDN(gt3,1)*(CB*ZH(gt1,1)-SB*ZH(gt1,2)-IC*ZH(gt1,4))+6*
     &  sqrt2*dAdCQCD(2)*DCONJG(ZDN(gt2,4))*Yd(2)*ZDN(gt3,3)*(CB*
     &  ZH(gt1,1)-SB*ZH(gt1,2)-IC*ZH(gt1,4))+6*sqrt2*dAdCQCD(3)*
     &  DCONJG(ZDN(gt2,6))*Yd(3)*ZDN(gt3,5)*(CB*ZH(gt1,1)-SB*
     &  ZH(gt1,2)-IC*ZH(gt1,4))-6*sqrt2*dAdQCD(1)*DCONJG(ZDN(gt2,1))*
     &  Yd(1)*ZDN(gt3,2)*(CB*ZH(gt1,1)-SB*ZH(gt1,2)+IC*ZH(gt1,4))-6*
     &  sqrt2*dAdQCD(2)*DCONJG(ZDN(gt2,3))*Yd(2)*ZDN(gt3,4)*(CB*
     &  ZH(gt1,1)-SB*ZH(gt1,2)+IC*ZH(gt1,4))-6*sqrt2*dAdQCD(3)*
     &  DCONJG(ZDN(gt2,5))*Yd(3)*ZDN(gt3,6)*(CB*ZH(gt1,1)-SB*
     &  ZH(gt1,2)+IC*ZH(gt1,4))+(6*dYdQCD(1)*(-(expeta*
     &  DCONJG(ZDN(gt2,2))*(4*CB*IC*v*vS*Yd(1)*ZDN(gt3,2)*ZH(gt1,4)+
     &  sqrt2*ZDN(gt3,1)*(vS*(expeta*MUE*SB-CB*AdC(1))*ZH(gt1,1)+vS*
     &  (CB*expeta*MUE+SB*AdC(1))*ZH(gt1,2)+expeta*MUE*SB*v*ZH(gt1,3)
     &  +IC*vS*AdC(1)*ZH(gt1,4)-expeta*IC*MUE*vS*ZH(gt1,5)-expeta*IC*
     &  MUE*SB*v*ZH(gt1,6))))+DCONJG(ZDN(gt2,1))*(-4*CB*expeta*IC*v*
     &  vS*Yd(1)*ZDN(gt3,1)*ZH(gt1,4)+sqrt2*ZDN(gt3,2)*(vS*(MUEC*SB-
     &  CB*expeta*Ad(1))*ZH(gt1,1)+vS*(CB*MUEC+expeta*SB*Ad(1))*
     &  ZH(gt1,2)+MUEC*SB*v*ZH(gt1,3)-expeta*IC*vS*Ad(1)*ZH(gt1,4)+
     &  IC*MUEC*vS*ZH(gt1,5)+IC*MUEC*SB*v*ZH(gt1,6)))))/(expeta*vS)+
     &  (6*dYdQCD(2)*(-(expeta*DCONJG(ZDN(gt2,4))*(4*CB*IC*v*vS*Yd(2)*
     &  ZDN(gt3,4)*ZH(gt1,4)+sqrt2*ZDN(gt3,3)*(vS*(expeta*MUE*SB-CB*
     &  AdC(2))*ZH(gt1,1)+vS*(CB*expeta*MUE+SB*AdC(2))*ZH(gt1,2)+
     &  expeta*MUE*SB*v*ZH(gt1,3)+IC*vS*AdC(2)*ZH(gt1,4)-expeta*IC*
     &  MUE*vS*ZH(gt1,5)-expeta*IC*MUE*SB*v*ZH(gt1,6))))+
     &  DCONJG(ZDN(gt2,3))*(-4*CB*expeta*IC*v*vS*Yd(2)*ZDN(gt3,3)*
     &  ZH(gt1,4)+sqrt2*ZDN(gt3,4)*(vS*(MUEC*SB-CB*expeta*Ad(2))*
     &  ZH(gt1,1)+vS*(CB*MUEC+expeta*SB*Ad(2))*ZH(gt1,2)+MUEC*SB*v*
     &  ZH(gt1,3)-expeta*IC*vS*Ad(2)*ZH(gt1,4)+IC*MUEC*vS*ZH(gt1,5)+
     &  IC*MUEC*SB*v*ZH(gt1,6)))))/(expeta*vS)+(6*dYdQCD(3)*(-(expeta*
     &  DCONJG(ZDN(gt2,6))*(4*CB*IC*v*vS*Yd(3)*ZDN(gt3,6)*ZH(gt1,4)+
     &  sqrt2*ZDN(gt3,5)*(vS*(expeta*MUE*SB-CB*AdC(3))*ZH(gt1,1)+vS*
     &  (CB*expeta*MUE+SB*AdC(3))*ZH(gt1,2)+expeta*MUE*SB*v*ZH(gt1,3)
     &  +IC*vS*AdC(3)*ZH(gt1,4)-expeta*IC*MUE*vS*ZH(gt1,5)-expeta*IC*
     &  MUE*SB*v*ZH(gt1,6))))+DCONJG(ZDN(gt2,5))*(-4*CB*expeta*IC*v*
     &  vS*Yd(3)*ZDN(gt3,5)*ZH(gt1,4)+sqrt2*ZDN(gt3,6)*(vS*(MUEC*SB-
     &  CB*expeta*Ad(3))*ZH(gt1,1)+vS*(CB*MUEC+expeta*SB*Ad(3))*
     &  ZH(gt1,2)+MUEC*SB*v*ZH(gt1,3)-expeta*IC*vS*Ad(3)*ZH(gt1,4)+
     &  IC*MUEC*vS*ZH(gt1,5)+IC*MUEC*SB*v*ZH(gt1,6)))))/(expeta*vS))
     &  /12.

          enddo
        enddo
       enddo
       print*, "///////////////////////////////////////////////////"
       print*, "Renormalization of stop/sbottom sector 1(OS), 2(OS EW, DRb QCD), 3(DRb):", ischemet,ischemeb
       print*, "stop,sbottom tree-level mass    *   loop-corrected masses:"
       print*, "stop1:    ",MSUT(5), "*" , MSU1L(5)
       print*, "stop2:    ",MSUT(6), "*" , MSU1L(6)
       print*, "sbottom1: ",MSDT(5), "*" , MSD1L(5)
       print*, "sbottom2: ",MSDT(6), "*" , MSD1L(6)

       end subroutine RenConstSTSB


c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine RenConstSTauSneu(ischeme) 
      implicit none
      integer i,j,k,l,ib,ischeme,gt1,gt2,gt3,gt4,iew,iuv,jj,kk
      double precision c1,c2,dmf,mf,Mtree2(2),MLoop2(2),
     &                 mfp,dmfp,a(3,3),d(3),root(3),Mq21L(3),dMSQ2B(3)
      double precision Qs

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
     
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)

      common /scale/ Qs      
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZEN,ZDN,ZUN

      double complex IC,lam,kap,expeta,expetas,
     &               dlambdaC1,lamC,Au(3),Ad(3),Ae(3),self,Dself,
     &               selfT(4),dMSt2(2,2),dMSb2(2,2),ZU(2,2),ZUC(2,2),AuC(3),
     &               AdC(3),AeC(3),ZD(2,2),ZDC(2,2),dMC,dAuC(3),dAdC(3),
     &               dmsttmp(2,2),dmsqtmp(2,2),dZSttmp(2,2),dZSbtmp(2,2),dMUE,
     &               dMUEC,MUE,MUEC,dAeC(6),
     &               ZSfac(2,2),dUVMSQ2(3),dUVMSt2(2,2),dUVmf,
     &               atest,ctest

    
#include "HdecayTCLs.inc"
#include "HdecayCTs.inc"

       sqrt2=Sqrt(2D0)
       IC= dcmplx(0,1D0)

       lam= abslambda*(cos(phil)+IC*sin(phil) )
       lamc=DCONJG(lam)
       kap= abskappa*(cos(phik)+IC*sin(phik) )
       dlambda1= dabslambda*(cos(phil)+IC*sin(phil) )
       dlambdaC1= dabslambda*(cos(phil)-IC*sin(phil) )
       expeta = (cos(phiu)+IC*sin(phiu) )   
       expetas= (cos(phis)+IC*sin(phis) )  
       dCW1=-dSW1*SW/CW
       do i=1,3
        au(i)= absAu(i)*(cos(phiau(i))+IC*sin(phiau(i))) 
        ad(i)= absAd(i)*(cos(phiad(i))+IC*sin(phiad(i))) 
        ae(i)= absAe(i)*(cos(phiae(i))+IC*sin(phiae(i))) 
       enddo
       AuC(1:3)=DCONJG(Au(1:3))
       AdC(1:3)=DCONJG(Ad(1:3))
       AeC(1:3)=DCONJG(Ae(1:3))
      
c       do i=1,3
       i=3
c        print*, "mse(2*i-1),mse(2*i)",mse(2*i-1),mse(2*i)
       if(i.eq.1)then
       ZU(1:2,1:2)=ZEN(1:2,1:2)
       mf=me
       elseif (i.eq.2)then
       ZU(1:2,1:2)=ZEN(3:4,3:4)
       mf=mmu
       elseif (i.eq.3)then
       ZU(1:2,1:2)=ZEN(5:6,5:6)
       mf=mtau
       endif 
       ZUC(1:2,1:2)=DCONJG(ZU(1:2,1:2))

c stau sector
       if (ischeme.lt.3)then
c( EW corection in OS scheme
        iuv=0
c EW corection in OS scheme)
       else
c( EW corection in DRbar scheme
        iuv=1
c EW corection in DRbar scheme)
       endif

c(begin sneutrino, using OS/DR scheme
c EW correction

       if (iuv.eq.0)then
       call SelfSneu(msv(i)**2,i,i,self,1,iuv)
       dMSL2(i)=DBLE(self)-dMZsq1/2D0*(CB**2-SB**2)+2*MZ2*CB**3*SB*dTanB1
       dmfp= 0
       MSv1L(i)=MSv(i)
       else
       dMSL2(i)=0D0
       call SelfSneu(msv(i)**2,i,i,self,1,1)
       MSv1L(i)= Sqrt(MSv(i)**2-(DBLE(self)-dMZsq1/2D0*(CB**2-SB**2)))
       endif
c EW correction )
       call DSelfSneu(msv(i)**2,i,i,self,1,0)
       dZSneu(i,i) =-self
c end sneutrino sector)
       ! tau mass is os parameter
       call Selftau(mf**2, i,i,selfT,1,0)  
       dmf= DBLE(mf*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0
       dYe(i)= sqrt2*(dmf/CB/v - mf*dCosB1/CB**2/v- mf*dv1/CB/v**2)

       call SelfStau(mse(2*i-1)**2,2*i-1,2*i-1,self,1,iuv)
       dMSt2(1,1)=DBLE(self)

       call SelfStau(mse(2*i)**2,2*i,2*i,self,1,iuv)
       dMSt2(2,2)=DBLE(self)

       call SelfStau(mse(2*i-1)**2,2*i-1,2*i,self,1,iuv)
       dMSt2(1,2)=self
       dZStau(2*i-1,2*i) = self
       call SelfStau(mse(2*i)**2,2*i-1,2*i,self,1,iuv)
       dZStau(2*i-1,2*i) =(dZStau(2*i-1,2*i) - self)/(mse(2*i)**2-mse(2*i-1)**2 )
       dZStauC(2*i,2*i-1) =       dZStau(2*i-1,2*i) 

       dMSt2(1,2)=DBLE((self+dMSt2(1,2))/2D0)
       dMSt2(2,1)=DCONJG(dMSt2(1,2))

       call SelfStau(mse(2*i-1)**2,2*i,2*i-1,self,1,iuv)
       dZStau(2*i,2*i-1) = 2*(dMSt2(2,1)-self)/(mse(2*i-1)**2-mse(2*i)**2)
       call SelfStau(mse(2*i)**2,2*i-1,2*i,self,1,iuv)
       dZStau(2*i-1,2*i) = -2*(dMSt2(1,2)-self)/(mse(2*i-1)**2-mse(2*i)**2)
       call SelfStau(mse(2*i)**2,2*i,2*i-1,self,1,iuv)
       dZStauC(2*i,2*i-1) =-2*(dMSt2(2,1)-self)/(mse(2*i-1)**2-mse(2*i)**2)  
       call SelfStau(mse(2*i-1)**2,2*i-1,2*i,self,1,iuv)
       dZStauC(2*i-1,2*i) = 2*(dMSt2(1,2)-self)/(mse(2*i-1)**2-mse(2*i)**2)

        call DSelfStau(mse(2*i-1)**2,2*i-1,2*i-1,self,1,iuv)
        dZStau(2*i-1,2*i-1) =-self
        dZStauC(2*i-1,2*i-1) =-self
        call DSelfStau(mse(2*i)**2,2*i,2*i,self,1,iuv)
        dZStau(2*i,2*i) =-self
        dZStauC(2*i,2*i) =-self
c OS EW
       if(abs(ZU(1,1)) > 0.5D0)then
        ib=2
       else
        ib=1
       endif
       if (ischeme.lt.3)then
       dMC=(2*dmf*Mf+2*dSW1*MZ2*(CB**2-SB**2)*SW+2*CB*dCosB1*MZ2*(-
     &  0.5d0+SW**2)-2*dSinB1*MZ2*SB*(-0.5d0+SW**2)+dMZsq1*(CB**2-SB**2)*
     &  (-0.5d0+SW**2)+dMSL2(i))*ZU(ib,1)*ZUC(ib,1)-(dvS1*lamC*Mf*SB*
     &  ZU(ib,2)*ZUC(ib,1))/(CB*expeta*expetaS*sqrt2)-(dSinB1*lamC*Mf*
     &  vS*ZU(ib,2)*ZUC(ib,1))/(CB*expeta*expetaS*sqrt2)-(dlambdaC1*Mf*
     &  SB*vS*ZU(ib,2)*ZUC(ib,1))/(CB*expeta*expetaS*sqrt2)+(dCosB1*
     &  lamC*Mf*SB*vS*ZU(ib,2)*ZUC(ib,1))/(CB**2*expeta*expetaS*sqrt2)+
     &  dmf*(-((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ae(i))*ZU(ib,2)*
     &  ZUC(ib,1)-(dvS1*expeta*expetaS*lam*Mf*SB*ZU(ib,1)*ZUC(ib,2))
     &  /(CB*sqrt2)-(dSinB1*expeta*expetaS*lam*Mf*vS*ZU(ib,1)*ZUC(ib,2)
     &  )/(CB*sqrt2)-(dlambda1*expeta*expetaS*Mf*SB*vS*ZU(ib,1)*
     &  ZUC(ib,2))/(CB*sqrt2)+(dCosB1*expeta*expetaS*lam*Mf*SB*vS*
     &  ZU(ib,1)*ZUC(ib,2))/(CB**2*sqrt2)+dmf*(-((expeta*expetaS*lam*
     &  SB*vS)/(CB*sqrt2))+AeC(i))*ZU(ib,1)*ZUC(ib,2)+2*dmf*Mf*ZU(ib,2)
     &  *ZUC(ib,2)-2*dSW1*MZ2*(CB**2-SB**2)*SW*ZU(ib,2)*ZUC(ib,2)-2*CB*
     &  dCosB1*MZ2*SW**2*ZU(ib,2)*ZUC(ib,2)+2*dSinB1*MZ2*SB*SW**2*
     &  ZU(ib,2)*ZUC(ib,2)-dMZsq1*(CB**2-SB**2)*SW**2*ZU(ib,2)*
     &  ZUC(ib,2)

       d(1)=DBLE(dMSt2(ib,ib)- dMC) 

       dMC=dMSt2(1,2)-((2*(2*dmf*Mf+2*dSW1*MZ2*(CB**2-SB**2)*SW+dMZsq1*(CB**2-SB**
     &  2)*(-0.5D0+SW**2)+CB*dCosB1*MZ2*(-1+2*SW**2)-dSinB1*MZ2*SB*(-1+
     &  2*SW**2)+dMSL2(i))*ZU(1,1)*ZUC(2,1)-(dvS1*lamC*Mf*SB*sqrt2*
     &  ZU(1,2)*ZUC(2,1))/(CB*expeta*expetaS)-(dSinB1*lamC*Mf*sqrt2*vS*
     &  ZU(1,2)*ZUC(2,1))/(CB*expeta*expetaS)-(dlambdaC1*Mf*SB*sqrt2*
     &  vS*ZU(1,2)*ZUC(2,1))/(CB*expeta*expetaS)+(dCosB1*lamC*Mf*SB*
     &  sqrt2*vS*ZU(1,2)*ZUC(2,1))/(CB**2*expeta*expetaS)+2*dmf*(-
     &  ((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ae(i))*ZU(1,2)*
     &  ZUC(2,1)-(dvS1*expeta*expetaS*lam*Mf*SB*sqrt2*ZU(1,1)*ZUC(2,2))
     &  /CB-(dSinB1*expeta*expetaS*lam*Mf*sqrt2*vS*ZU(1,1)*ZUC(2,2))
     &  /CB-(dlambda1*expeta*expetaS*Mf*SB*sqrt2*vS*ZU(1,1)*ZUC(2,2))
     &  /CB+(dCosB1*expeta*expetaS*lam*Mf*SB*sqrt2*vS*ZU(1,1)*ZUC(2,2))
     &  /CB**2+2*dmf*(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+AeC(i))*
     &  ZU(1,1)*ZUC(2,2)+4*dmf*Mf*ZU(1,2)*ZUC(2,2)-4*dSW1*MZ2*(CB**2-
     &  SB**2)*SW*ZU(1,2)*ZUC(2,2)-4*CB*dCosB1*MZ2*SW**2*ZU(1,2)*
     &  ZUC(2,2)+4*dSinB1*MZ2*SB*SW**2*ZU(1,2)*ZUC(2,2)-2*dMZsq1*(CB**
     &  2-SB**2)*SW**2*ZU(1,2)*ZUC(2,2))/2d0)
       d(2)=DBLE(dMC) 
       d(3)=DIMAG(dMC) 

       a(1,1)=DBLE(ZU(ib,2)*ZUC(ib,2))
       a(2,1)=DBLE(Mf*(ZU(ib,2)*ZUC(ib,1)+ZU(ib,1)*ZUC(ib,2)))
       a(3,1)=DBLE(IC*Mf*(ZU(ib,2)*ZUC(ib,1)-ZU(ib,1)*ZUC(ib,2)))

       a(1,2)=DBLE(ZU(1,2)*ZUC(2,2))
       a(2,2)=DBLE(Mf*(ZU(1,2)*ZUC(2,1)+ZU(1,1)*ZUC(2,2)))
       a(3,2)=DBLE(IC*Mf*(ZU(1,2)*ZUC(2,1)-ZU(1,1)*ZUC(2,2)))

       a(1,3)=DIMAG(ZU(1,2)*ZUC(2,2))
       a(2,3)=DIMAG(Mf*(ZU(1,2)*ZUC(2,1)+ZU(1,1)*ZUC(2,2)))
       a(3,3)=DIMAG(IC*Mf*(ZU(1,2)*ZUC(2,1)-ZU(1,1)*ZUC(2,2)))

       call Linearequation_solver(3,a,d,root)
       dMSER2(i) =root(1)
       dAe(i)= root(2) + IC*root(3)
       dAeC(i) =DCONJG(dAe(i))
       else
       dMSER2(i) =0D0
       dAe(i)=0D0
       dAeC(i) =DCONJG(dAe(i))
       endif
c        print*, "dMSL2(i) ",dMSL2(i) 
c        print*, "dAe(i)",dAe(i)
c        print*, "dMSER2(i)",dMSER2(i)
c        stop
c OS EW)
       dMSttmp(1,1)=2*dmf*Mf+2*dSW1*MZ2*(CB**2-SB**2)*SW+dMZsq1*(CB**2-
     &  SB**2)*(-0.5d0+SW**2)+CB*dCosB1*MZ2*(-1+2*SW**2)-dSinB1*MZ2*SB*
     &  (-1+2*SW**2)+dMSL2(i)
       dMSttmp(1,2)=(-(expeta*expetaS*(-(dCosB1*lam*Mf*SB*vS)+CB*(dvS1*
     &  lam*Mf*SB+dSinB1*lam*Mf*vS+dmf*lam*SB*vS+dlambda1*Mf*SB*vS)))+
     &  CB**2*dmf*sqrt2*AeC(i)+CB**2*Mf*sqrt2*dAeC(i))/(CB**2*sqrt2)
       dMSttmp(2,1)=-((CB*dvS1*lamC*Mf*SB+CB*dSinB1*lamC*Mf*vS+CB*dmf*
     &  lamC*SB*vS+CB*dlambdaC1*Mf*SB*vS-dCosB1*lamC*Mf*SB*vS-CB**2*
     &  dmf*expeta*expetaS*sqrt2*Ae(i)-CB**2*expeta*expetaS*Mf*sqrt2*
     &  dAe(i))/(CB**2*expeta*expetaS*sqrt2))
       dMSttmp(2,2)=2*dmf*Mf+SW*(-2*CB*dCosB1*MZ2*SW-CB**2*(2*dSW1*MZ2+
     &  dMZsq1*SW)+SB*(2*dSW1*MZ2*SB+2*dSinB1*MZ2*SW+dMZsq1*SB*SW))+
     &  dMSER2(i)

       do j=1,2
        do k=1,2
          dmc=0D0
          do gt1=1,2
            do gt2=1,2
            dmc= dmc+ ZU(j,gt1)*ZUC(k,gt2)*dMSttmp(gt1,gt2)
            enddo
          enddo
          dMSqtmp(j,k)= dmc
        enddo
       enddo
       dMSesq1(2*i-1,2*i-1)=dMSqtmp(1,1)
       dMSesq1(2*i-1,2*i)=dMSqtmp(1,2)
       dMSesq1(2*i,2*i-1)=dMSqtmp(2,1)
       dMSesq1(2*i,2*i)=dMSqtmp(2,2)
c)EW correction is in OS scheme

        if(ischeme.lt.3)then
        if(ib.eq.1)then
        MSe1L(2*i-1)=MSe(2*i-1)
c
        call SelfStau(mse(2*i)**2,2*i,2*i,self,1,iuv)
        dMSt2(2,2)=DBLE(self)
        MSe1L(2*i)=Sqrt(MSe(2*i)**2-(dMSttmp(2,2)))   
        elseif(ib.eq.2)then
        call SelfStau(mse(2*i-1)**2,2*i-1,2*i-1,self,1,iuv)
        dMSt2(1,1)=DBLE(self)
        MSe1L(2*i-1)=Sqrt(MSe(2*i-1)**2-(dMSttmp(1,1)))  
        MSe1L(2*i)=MSe(2*i)
        endif
        else
        Mtree2(1)=MSe(2*i-1)**2
        Mtree2(2)=MSe(2*i)**2
        call FindStau(2,Mtree2,Mloop2,i)
        MSe1L(2*i-1)=Sqrt(Mloop2(1))
        MSe1L(2*i)=Sqrt(Mloop2(2))
        endif
c         stop
c note EW DSelfStau(mse(2*i-1)**2) evaluated at tree-level mass or loop-corrected mass 
c we still obtain IR finite. One have to evaluate diagrams with photon with the same mass
c of the external line and internal line for DSelfStau, but not for SelfStau

        call DSelfStau(mse1L(2*i-1)**2,2*i-1,2*i-1,self,1,0)
        dZStau(2*i-1,2*i-1) =-self
        dZStauC(2*i-1,2*i-1) =-self
        call DSelfStau(mse1L(2*i)**2,2*i,2*i,self,1,0)
        dZStau(2*i,2*i) =-self
        dZStauC(2*i,2*i) =-self

c#define details
#ifdef details
        print*,  '///////////////////////////////////////////////////////'
        print*,  'check UV, stau self energy EW, scheme, iuv',ischeme,iuv   

        print*, 'mf, mse(5),mse(6)',mf, mse(5),mse(6)
        print*,  'dmt,dYe(i),dAeC(i),dMSER2(i),dMSL2(i)',dmf,dYe(i),dAeC(i),dMSER2(i),dMSL2(i)

        print*, "dMSt2", dMSt2(1:2,1)
        print*, "dMSt2", dMSt2(1:2,2)
        print*,  '1->1, renormalized', dMSt2(1,1) -dMSesq1(2*i-1,2*i-1),dMSt2(1,1),dMSesq1(2*i-1,2*i-1)
        print*,  '2->2, renormalized', dMSt2(2,2) -dMSesq1(2*i,2*i),dMSt2(2,2),dMSesq1(2*i,2*i)
        print*,  '1->2, renormalized', dMSt2(1,2) -dMSesq1(2*i-1,2*i),dMSt2(1,2),dMSesq1(2*i-1,2*i)
        print*,  '2->1, renormalized', dMSt2(2,1) -dMSesq1(2*i,2*i-1),dMSt2(2,1),dMSesq1(2*i,2*i-1)
        print*,  '1->2, unrenormalized',dMSesq1(2*i-1,2*i),dMSesq1(2*i-1,2*i)
        print*,  'dZStau',dZStau(2*i-1,2*i-1),dZStau(2*i-1,2*i),dZStau(2*i,2*i-1),dZStau(2*i,2*i)
#endif
c stau sector)

       print*,  '///////////////////////////////////////////////////////'
       print*, "stau,sneutrino tree-level mass    *   loop-corrected masses:"
       print*, "renormalization scheme 1 (OS), 3 (DR)", ischeme
       print*, "stau(1):      ", MSE(5), "*",MSE1L(5)
       print*, "stau(2):      ", MSE(6), "*",MSE1L(6)
       print*, "sneutrino_tau:", MSv(3), "*",MSv1L(3)

       end subroutine RenConstSTauSneu




c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      subroutine MSTauDRtoOS(ischeme) 
      implicit none
      integer i,j,k,l,id1,id2,ib,inun,ischeme 
      double precision dMW2,dMZ2,dZe,dMHpm2,dthu,dthd,dths,dtad,dtas
      double precision absnew,absold,CB,SB,CW,SW,sqrt2,mf,mfp,
     &                 dmf,MZ2,dSW,dmfp,root(3),a(3,3),d(3),
     &                 dMStauR2,dMStau2,ml2DR,mer2DR

      double precision pi,arg
      parameter (pi = 2d0*Asin(1d0))

      double precision Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      double precision abslambda, abskappa, absAlambda, absAkappa,vs,
     &                 mueff,tanb,beta
     
      double precision absM1, absM2, absAu(3), absAd(3), absAe(3),  
     &                 ml2(3), mer2(3), mq2(3), mdr2(3), mur2(3)
      
      double precision phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu(3), phiAd(3), phiAe(3) 
    
      double precision me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye(3),Yd(3),Yu(3)
      
      double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)

      double precision ZH5(5,5),ZH(6,6)    
      double complex UM(2,2),UP(2,2),NN(5,5),ZEN(6,6),ZDN(6,6),ZUN(6,6)
    
      common /SMinput/ Mz,Gf,alpha,Mw,e,v,g1,g2,alphaS,g3
      common /Higgsinput/ abslambda, abskappa, absAlambda, absAkappa,
     &                    vs,mueff,tanb,beta
      common /softbreak/ absM1, absM2, absAu, absAd, absAe,  
     &                   ml2, mer2, mq2, mdr2, mur2
      common /phases/ phiu, phis, phil, phik, phiAk, phiAl, phiM1,
     &                phiM2, phiAu, phiAd, phiAe
      common /Yukawa/ me,mmu,mtau,mu,md,ms,mc,mt,mb,Ye,Yd,Yu
      common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv

      common /rot/ ZH5,ZH,UM,UP,NN,ZEN,ZDN,ZUN
      logical MHpmInput,CPcon,mQrun,onelswitch
      common /switch/ MHpmInput,CPcon,mQrun,onelswitch

      double complex ZU(2,2),ZUC(2,2),ZD(2,2),ZDC(2,2),AeC(3),
     &               dMSt2(2,2),selfT(4),self,
     &               dMC,lamC,lam,Ae(3),dAtau,dAtauC,AeDR,
     &               IC,expeta,expetas
#include "HdecayCTs.inc"
       i=3
       if(i.eq.1)then
       ZU(1:2,1:2)=ZEN(1:2,1:2)
       mf=me
       elseif (i.eq.2)then
       ZU(1:2,1:2)=ZEN(3:4,3:4)
       mf=mmu
       elseif (i.eq.3)then
       ZU(1:2,1:2)=ZEN(5:6,5:6)
       mf=mtau
       endif 

       sqrt2=Sqrt(2D0)
       IC= dcmplx(0,1D0)
       SB=sin(beta); CB= Cos(beta);CW=MW/MZ; SW=sqrt(1-CW**2)

       if(ischeme.ge.3)then
        ! tau mass is always in OS scheme
c       call Selftau(mf**2,i,i,selfT,0)  
c       dmf= DBLE(mf*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0
c       mf = mf + dmf
c       if(i.eq.3) mtau=mf
c	   ye(i)= mf*sqrt2/CB/v
c      call sleptonmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,
c     &                   phiAe,absAe,ml2,mer2,Ye,MSe,ZEN)  
       else
       MZ2=MZ**2
       lam= abslambda*(cos(phil)+IC*sin(phil) )
       lamc=DCONJG(lam)
       expeta = (cos(phiu)+IC*sin(phiu) )   
       expetas= (cos(phis)+IC*sin(phis) ) 
       ZUC(1:2,1:2)=DCONJG(ZU(1:2,1:2))

       do j=1,3
        ae(j)= absAe(j)*(cos(phiae(j))+IC*sin(phiae(j))) 
        aec(j)=DCONJG(ae(j))
       enddo

c      print*, "msu(5),msu(6),msd(5),msd(6),mt,mb,g3",msu(5),msu(6),msd(5),msd(6), mt,mb,g3
c{ start iteration
       ml2DR=ml2(i); mer2DR=mer2(i); AeDR=ae(i)
       absold=ml2DR
       inun=1
       do while (abs(absnew -absold).gt.1D-3 .AND. inun.le.100)
       absold=absnew
       call Counterterms(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas)
       dSW= CW**2/SW/2.D0 * (dMZ2/MZ**2 - dMW2/MW**2)

       call SelfSneu(msv(i)**2,i,i,self,1,0)
       dMStau2=DBLE(self)-dMZ2/2D0*(CB**2-SB**2)
       dmfp= 0


       call Selftau(mf**2,i,i,selfT,0)  

       dmf= DBLE(mf*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0

       call SelfStau(mse(2*i-1)**2,2*i-1,2*i-1,self,1,0)
       dMSt2(1,1)=DBLE(self)
       call SelfStau(mse(2*i)**2,2*i,2*i,self,1,0)
       dMSt2(2,2)=DBLE(self)
       call SelfStau(mse(2*i-1)**2,2*i-1,2*i,self,1,0)
       dMSt2(1,2)=self
       dZStau(2*i-1,2*i) = self
       call SelfStau(mse(2*i)**2,2*i-1,2*i,self,1,0)
       dZStau(2*i-1,2*i) =(dZStau(2*i-1,2*i) - self)/(mse(2*i)**2-mse(2*i-1)**2 )
       dZStauC(2*i,2*i-1) =       dZStau(2*i-1,2*i) 

       dMSt2(1,2)=DBLE((self+dMSt2(1,2))/2D0)
       dMSt2(2,1)=DCONJG(dMSt2(1,2))

       ZU(1:2,1:2)=ZEN((2*i-1):(2*i),(2*i-1):(2*i))
       ZUC(1:2,1:2)=DCONJG(ZU(1:2,1:2))


       if(abs(ZU(1,1)) > 0.5D0)then
        ib=2
       else
        ib=1
       endif

       dMC=(2*dmf*Mf+2*dSW*MZ2*(CB**2-SB**2)*SW+dMZ2*(CB**2-SB**2)*
     &  (-0.5d0+SW**2)+dMStau2 )*ZU(ib,1)*ZUC(ib,1)+
     &  dmf*(-((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ae(i))*ZU(ib,2)*
     &  ZUC(ib,1)+dmf*(-((expeta*expetaS*lam*
     &  SB*vS)/(CB*sqrt2))+AeC(i))*ZU(ib,1)*ZUC(ib,2)+2*dmf*Mf*ZU(ib,2)
     &  *ZUC(ib,2)-2*dSW*MZ2*(CB**2-SB**2)*SW*ZU(ib,2)*ZUC(ib,2)
     &  -dMZ2*(CB**2-SB**2)*SW**2*ZU(ib,2)*ZUC(ib,2)

       d(1)=DBLE(dMSt2(ib,ib)- dMC) 


       dMC=dMSt2(1,2)-((2*(2*dmf*Mf+2*dSW*MZ2*(CB**2-SB**2)*SW+dMZ2*(CB**2-SB**
     &  2)*(-0.5D0+SW**2)+dMStau2)*ZU(1,1)*ZUC(2,1)+2*dmf*(-
     &  ((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ae(i))*ZU(1,2)*
     &  ZUC(2,1)+2*dmf*(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+AeC(i))*
     &  ZU(1,1)*ZUC(2,2)+4*dmf*Mf*ZU(1,2)*ZUC(2,2)-4*dSW*MZ2*(CB**2-
     &  SB**2)*SW*ZU(1,2)*ZUC(2,2)-2*dMZ2*(CB**
     &  2-SB**2)*SW**2*ZU(1,2)*ZUC(2,2))/2d0)
       d(2)=DBLE(dMC) 
       d(3)=DIMAG(dMC) 

       a(1,1)=DBLE(ZU(ib,2)*ZUC(ib,2))
       a(2,1)=DBLE(Mf*(ZU(ib,2)*ZUC(ib,1)+ZU(ib,1)*ZUC(ib,2)))
       a(3,1)=DBLE(IC*Mf*(ZU(ib,2)*ZUC(ib,1)-ZU(ib,1)*ZUC(ib,2)))

       a(1,2)=DBLE(ZU(1,2)*ZUC(2,2))
       a(2,2)=DBLE(Mf*(ZU(1,2)*ZUC(2,1)+ZU(1,1)*ZUC(2,2)))
       a(3,2)=DBLE(IC*Mf*(ZU(1,2)*ZUC(2,1)-ZU(1,1)*ZUC(2,2)))

       a(1,3)=DIMAG(ZU(1,2)*ZUC(2,2))
       a(2,3)=DIMAG(Mf*(ZU(1,2)*ZUC(2,1)+ZU(1,1)*ZUC(2,2)))
       a(3,3)=DIMAG(IC*Mf*(ZU(1,2)*ZUC(2,1)-ZU(1,1)*ZUC(2,2)))

       call Linearequation_solver(3,a,d,root)
       dMStauR2 =root(1)
       dAtau= root(2) + IC*root(3)
       dAtauC =DCONJG(dAtau)
      ml2(i) = ml2DR - dMStau2
      mer2(i)= mer2DR - dMStauR2
      Ae(i)= AeDR - dAtau; absAe(i) = Abs(Ae(i)); Aec(i)=DCONJG(Ae(i))
      phiAe(i) = arg(DBLE(Ae(i)),DIMAG(Ae(i)) )

       
      call sleptonmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,
     &                   phiAe,absAe,ml2,mer2,Ye,MSe,ZEN)      
      call sneutrinomasses(g1,g2,v,beta,ml2,MSv)
      if(MSv(i)*MSe(2*i-1)*MSe(2*i).ne.MSv(i)*MSe(2*i-1)*MSe(2*i))then
          inun=100
      endif 
      call couplings
      call couplingsXX
      absnew=ml2DR - dMStau2
      inun=inun+1
      enddo
 
      if(inun.gt.101)then
      ml2(i) = ml2DR 
      mer2(i)= mer2DR 
      Ae(i)= AeDR; absAe(i) = Abs(Ae(i)); Aec(i)=DCONJG(Ae(i))
      phiAe(i) = arg(DBLE(Ae(i)),DIMAG(Ae(i)) )
      call sleptonmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,
     &                   phiAe,absAe,ml2,mer2,Ye,MSe,ZEN)      
      call sneutrinomasses(g1,g2,v,beta,ml2,MSv)

       call Counterterms(dMW2,dMZ2,dZe,dMHpm2,dthd,dthu,dths,dtad,dtas)
       dSW= CW**2/SW/2.D0 * (dMZ2/MZ**2 - dMW2/MW**2)

       call SelfSneu(msv(i)**2,i,i,self,1,0)
       dMStau2=DBLE(self)-dMZ2/2D0*(CB**2-SB**2)
       dmfp= 0


       call Selftau(mf**2,i,i,selfT,0)  

       dmf= DBLE(mf*(selfT(1)+selfT(2))+selfT(3)+selfT(4))/2D0

       call SelfStau(mse(2*i-1)**2,2*i-1,2*i-1,self,1,0)
       dMSt2(1,1)=DBLE(self)
       call SelfStau(mse(2*i)**2,2*i,2*i,self,1,0)
       dMSt2(2,2)=DBLE(self)
       call SelfStau(mse(2*i-1)**2,2*i-1,2*i,self,1,0)
       dMSt2(1,2)=self
       dZStau(2*i-1,2*i) = self
       call SelfStau(mse(2*i)**2,2*i-1,2*i,self,1,0)
       dZStau(2*i-1,2*i) =(dZStau(2*i-1,2*i) - self)/(mse(2*i)**2-mse(2*i-1)**2 )
       dZStauC(2*i,2*i-1) =       dZStau(2*i-1,2*i) 

       dMSt2(1,2)=DBLE((self+dMSt2(1,2))/2D0)
       dMSt2(2,1)=DCONJG(dMSt2(1,2))

       ZU(1:2,1:2)=ZEN((2*i-1):(2*i),(2*i-1):(2*i))
       ZUC(1:2,1:2)=DCONJG(ZU(1:2,1:2))


       if(abs(ZU(1,1)) > 0.5D0)then
        ib=2
       else
        ib=1
       endif

       dMC=(2*dmf*Mf+2*dSW*MZ2*(CB**2-SB**2)*SW+dMZ2*(CB**2-SB**2)*
     &  (-0.5d0+SW**2)+dMStau2 )*ZU(ib,1)*ZUC(ib,1)+
     &  dmf*(-((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ae(i))*ZU(ib,2)*
     &  ZUC(ib,1)+dmf*(-((expeta*expetaS*lam*
     &  SB*vS)/(CB*sqrt2))+AeC(i))*ZU(ib,1)*ZUC(ib,2)+2*dmf*Mf*ZU(ib,2)
     &  *ZUC(ib,2)-2*dSW*MZ2*(CB**2-SB**2)*SW*ZU(ib,2)*ZUC(ib,2)
     &  -dMZ2*(CB**2-SB**2)*SW**2*ZU(ib,2)*ZUC(ib,2)

       d(1)=DBLE(dMSt2(ib,ib)- dMC) 


       dMC=dMSt2(1,2)-((2*(2*dmf*Mf+2*dSW*MZ2*(CB**2-SB**2)*SW+dMZ2*(CB**2-SB**
     &  2)*(-0.5D0+SW**2)+dMStau2)*ZU(1,1)*ZUC(2,1)+2*dmf*(-
     &  ((lamC*SB*vS)/(CB*expeta*expetaS*sqrt2))+Ae(i))*ZU(1,2)*
     &  ZUC(2,1)+2*dmf*(-((expeta*expetaS*lam*SB*vS)/(CB*sqrt2))+AeC(i))*
     &  ZU(1,1)*ZUC(2,2)+4*dmf*Mf*ZU(1,2)*ZUC(2,2)-4*dSW*MZ2*(CB**2-
     &  SB**2)*SW*ZU(1,2)*ZUC(2,2)-2*dMZ2*(CB**
     &  2-SB**2)*SW**2*ZU(1,2)*ZUC(2,2))/2d0)
       d(2)=DBLE(dMC) 
       d(3)=DIMAG(dMC) 

       a(1,1)=DBLE(ZU(ib,2)*ZUC(ib,2))
       a(2,1)=DBLE(Mf*(ZU(ib,2)*ZUC(ib,1)+ZU(ib,1)*ZUC(ib,2)))
       a(3,1)=DBLE(IC*Mf*(ZU(ib,2)*ZUC(ib,1)-ZU(ib,1)*ZUC(ib,2)))

       a(1,2)=DBLE(ZU(1,2)*ZUC(2,2))
       a(2,2)=DBLE(Mf*(ZU(1,2)*ZUC(2,1)+ZU(1,1)*ZUC(2,2)))
       a(3,2)=DBLE(IC*Mf*(ZU(1,2)*ZUC(2,1)-ZU(1,1)*ZUC(2,2)))

       a(1,3)=DIMAG(ZU(1,2)*ZUC(2,2))
       a(2,3)=DIMAG(Mf*(ZU(1,2)*ZUC(2,1)+ZU(1,1)*ZUC(2,2)))
       a(3,3)=DIMAG(IC*Mf*(ZU(1,2)*ZUC(2,1)-ZU(1,1)*ZUC(2,2)))

       call Linearequation_solver(3,a,d,root)
       dMStauR2 =root(1)
       dAtau= root(2) + IC*root(3)
       dAtauC =DCONJG(dAtau)
      ml2(3) = ml2DR - dMStau2
      mer2(3)= mer2DR - dMStauR2
      Ae(3)= AeDR - dAtau; absAe(3) = Abs(Ae(3)); Aec(3)=DCONJG(Ae(3))
      phiAe(3) = arg(DBLE(Ae(3)),DIMAG(Ae(3)) )

       
      call sleptonmasses(g1,g2,v,beta,abslambda,vs,phil,phis,phiu,
     &                   phiAe,absAe,ml2,mer2,Ye,MSe,ZEN)      
      call sneutrinomasses(g1,g2,v,beta,ml2,MSv)
      endif


      endif
      end subroutine MSTauDRtoOS

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       subroutine EigensStau(n,i,p2in,p2out,mtree2,igen)
       implicit none
       integer i,j,k,l,n,igen
       double precision mtree2(n)
       double precision Mh(5),MHpm,Mcha(2),Mchi(5), MSe(6),MSd(6),
     &                 MSu(6),MSv(3)
       common /treemasses/ Mh,MHpm,Mcha,Mchi, MSe,MSd,MSu,MSv
       double complex  p2in, p2out

       double complex Mtrix2(n,n),p2,self,tmp,dtmp,dself,U(n,n),m2,
     &             ML2(n)
       double precision p2reim(2),p2re, p2im
       equivalence (p2, p2reim, p2re), (p2reim(2), p2im)
#include "HdecayCTs.inc"
         p2 = p2in
         j=2*igen-2
           do k=1,2
            do l=1,2
             tmp=0D0
             call SelfStau(p2re,j+k,j+l,tmp,1,0)
             tmp=tmp+1/2D0*(p2re- mse(j+k)**2)*dZStau(j+k,j+l)
     &       +1/2D0*(p2re-mse(j+l)**2)*dZStau(j+k,j+l)-dMSesq1(j+k,j+l)
             Mtrix2(k,l)=-tmp
             if (k.eq.l) Mtrix2(k,l)= mtree2(k) + Mtrix2(k,l)
            enddo
           enddo
           call SEigensystem(n,Mtrix2,n,ML2,U,n,1)
            m2= ML2(i)
	 p2out = m2
	end subroutine EigensStau
************************************************************************

	subroutine FindRootStau(n,i,x,mtree2,igen)
	implicit none
	integer i,n,igen
	double precision mtree2(n,n)
	double complex x
	double complex xn1, xn2, fn1
	integer try
	double precision prec
	parameter (prec = 1D-6)
          xn1= x
	  call EigensStau(n,i, xn1, xn2,mtree2,igen)
          fn1= xn1-xn2          
        do try=1,40
          if (abs(fn1) .gt. prec) then
          xn1=xn2
	  call EigensStau(n,i, xn1, xn2,mtree2,igen)
          fn1= xn1-xn2
          else
            x=xn2
            return
          endif         
        enddo
        x=xn2
	end subroutine FindRootStau

c%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
c**********************************************************************************
	subroutine FindStau(n,Mtree2,Mloop2,igen)
	implicit none
        integer n,cc,i,j,k,igen
        double precision m,Mtree2(n),Mloop2(n)
        double complex p2,p2temp(n),c,MH(n,n),DMH(n,n)

        do i =1,n 
	  p2 =  Mtree2(i)
	  call FindRootStau(n,i,p2,mtree2,igen)
	  Mloop2(i) = DBLE(p2) 
        enddo
* sort the masses
        do i = 1, n
          k = i
          m = Mloop2(i) 
          do j = i + 1, n
            if( Mloop2(j) .lt. m ) then
              m = Mloop2(j)
              k = j
            endif
          enddo
          if( k .ne. i ) then
             Mloop2(k) = Mloop2(i)
             Mloop2(i) = m
          endif
        enddo
        end subroutine FindStau


